Sep. 1st, 2006.

Add new code: find_forw_shock_3.f
Major cleanups of the old code.


Sep. 26th, 2005.

In zeus3d.f add a piece of code read in theta_BN.
	
       write(*,*) "input theta_BN (0.001)"
       read(*,*) theta_BN !      theta_BN = 80 degree

The input file need to be changed accordingly.



Date: Nov. 9th, 2004

This directory contains files adapted from ZEUS-3D for calculating accelerated 
particle spectra at a CME or interplanetary shock.
In terms of functionality, the code performs the following in sequence.

0) pre-task: set up a steady solar wind profile for the simulation.

1) When the steady solar wind is in stage, generating a CME-driven shocks
   by perturbing the inner boundary (located at 0.1 AU) condition. 
   Shocks with different shock strength correspond to different factors of increase 
   of the pressure, solar wind speed, etc. for a duration of 1 hour.
   parameter i_shock_strength in gen_bndy.f is used to control the shock strength.	 
   i_shock_strength = 1  ===> ultra-strong shock (increase by a factor of 6).
   i_shock_strength = 2  ===>       strong shock (increase by a factor of 5).
   i_shock_strength = 3  ===> intermediate shock (increase by a factor of 4).
   i_shock_strength = 4  ===>         weak shock (increase by a factor of 3).
   i_shock_strength = 5  ===>   ultra-weak shock (increase by a factor of 2).

2) Follow the shock propagtion: decide the shock parameter (such as compression 
   ratio, shock speed) at every time step.
3) After every 150 time steps, perform the following central tasks:
   a) calculate the wave intensitis (Alfven waves) due to streaming protons
      at the shock front.
   b) expand all shells behind the shock; update the momentum of the particles in
      every shells if necessary.[ momentum change depends on the time lag.]
   c) generate a new shell and add accelerated particles at this new shell 
      behind the shock.
   d) calculate particle diffusion, re-allocate particles among all shells based on 
      the transport equation. Also, calculate particles that leak from shock front and 
      the back; write them out to data file together with time and leakage location.
      These particles will escape the turbulent shock complex into the interplanetary 
      medium and gyrating with Parker Spiral Interplanetary magnetic field (IMF). The 
      motion of these particles will be followed using a Monte-Carlo code, which is 
      the second part of the program.
   e) increase the total shell number by 1. 
4) Terminate the calculation after enough time steps to insure shock passes 1 AU.



To run the program:

make -f makezeus
./xzeus<input>output
       
File input contains the parameters for the code.
 i_shock_strength  ---------------- ( see above note)
 iheavy            ---------------- (1: CNO, 2: IRON)
 i_restart         ---------------- (1: a continued run, need file gl.save 0: run from the beginning.)
 i_perp            ---------------- (0: parallel-Bohm, 1:perp)


About the program:
  
Units:

1) The velocity unit of the code is V0 = 52.483 km/s
2) The distence unit of the code is L0 = 1 AU = 1.5 * 10^8 km
3) From 1) and 2), the time unit is t0 = L0/V0 = 28580683 second
4) The density unit is \rho_0 = 1.67 * 10^{-24} g/cm^3 ==> a number
   density of d = 1 nucleon/cm^3.
5) From 1) and 4), one can define the unit of B through B0^2 = \rho_0 V_0^2
   since [B^2] = [\rho V^2]. Thus B0 = 6.78 * 10^{-6} Gauss.
   (We note here that 1 Gauss ^2 = 1 erg / cm^3. 1 Tesla = 10^4 Gauss. 1 J = 10^7 erg )

To perfom the above functionality, the following files are added apart from those contained 
in ZEUS-3D package.

------------------------- FILES -----------------------------------------
add_acc_ptcls.f:c        written by: Gang Li
diff_distr_fn_posn.f:c   written by: Ken Rice
diffuse_distr.f:c    written by: Ken Rice
	             modified by: Gang Li 02/21/2003    
                     modified by: Gang Li 03/11/2003: Add heavy ions

diffuse_distr_integ2.f:c    written by: Ken Rice
diffuse_distr_integ.f:c     written by: Ken Rice
distr_1AU_time.f:c  written by: Ken Rice
distr_fn_out.f:c    written by: Ken Rice
expand_distr.f:c    written by: Ken Rice
                    modified by: Gang Li
find_forw_shock_2.f:c    written by: Ken Rice
			 modified 1: by Gang Li	

momenta_calc_bohm.f:c    written by: Ken Rice
momenta_calc_gorlee.f:c  written by: Gang Li
observed_ptcls.f:c    written by: Ken Rice
parker_field.f:c      written by: Ken Rice
posn_distr.f:c        written by: Ken Rice
shell_obs.f:c         written by: Ken Rice
shell_track.f:c       written by: Ken Rice
solar.f:c             written by: Ken Rice
time_distr.f:c        written by: Ken Rice
wave_intens.f:c       written by : Ken Rice


SECTION 2,

We now describe each code; its function and its input and output.

------------------------- CODES DESCRIPTION ---------------------------------------
 

The main code is zeus3d.f:


Firstly, "zeus3d.f" opens the following files for data output:
(the first letter at the begining of the following lines denotes in which file the 
data-writing are performed.)

[z] ==> zeus3d.f  
[w] ==> wave_intens.f
[d] ==> diffuse_distr.f
[e] ==> expand_distr.f
[a] ==> add_acc_ptcls.f      
-------------------------------------------------------------------------------------

[d]       open(13,file='ptcls_in_shell.dat', form='formatted',status='unknown')
[d]       open(14,file='distr_in_shell.dat', form='formatted',status='unknown')
[?]       open(35,file='obs_ptcls.dat',      form='formatted',status='unknown')
[?]       open(36,file='posn_distr.dat',     form='formatted',status='unknown')
[?]       open(37,file='time_distr.dat',     form='formatted',status='unknown')
[d]       open(38,file='esc_distr.dat',      form='formatted',status='unknown') 
[?]       open(39,file='distr_1AU_time.dat', form='formatted',status='unknown') 
[w]       open(43,file='waveintens.dat',     form='formatted',status='unknown')
[w]       open(44,file='kappa.dat',          form='formatted',status='unknown')
[z]       open(45,file='shock_momenta.dat',  form='formatted',status='unknown')
[?]       open(47,file='distr_fn_out.dat',   form='formatted',status='unknown')
[z]       open(48,file='shock_posn_comp.dat',form='formatted',status='unknown')
[z]       open(55,file='momenta-hi.dat',     form='formatted',status='unknown')
[d]       open(58,file='esc_distr-hi.dat',   form='formatted',status='unknown')
[?]       open(66,file='f_acc-hi.dat',       form='formatted',status='unknown')   
[e]       open(67,file='kappa-wave-I.dat',   form='formatted',status='unknown')   
[d]       open(68,file='shell-location.dat', form='formatted',status='unknown')   
[d]       open(78,file='current_at_shock.dat', form='formatted',status='unknown')
[d]       open(79,file='dist_at_shock.dat',  form='formatted',status='unknown') 
[d]       open(88,file='esc_num_up.dat',     form='formatted',status='unknown')  
[d]       open(89,file='esc_num_up_hi.dat',  form='formatted',status='unknown')  
[z]       open(90, file ='zeus.log', status='unknown')   
[z]       open(91, file ="gl.input", status='unknown')
[z]       open(92, file ="gl.output", status='unknown')

	
In the code, parameter "i_shock_strength" is used to control which shock profile is to be used.
This parameter is passed to " gen_bndy.f " from zeus3d.f. All information passed to the code are
written to file zeus.log(90).

       write(90,*) " i_shock_strength is: ", i_shock_strength
       write(90,*) " (1: very strong shock ) "
       write(90,*) " (2: strong shock ) "
       write(90,*) " (3: mediate shock ) "
       write(90,*) " (4: weak shock ) "
       write(90,*) " (5: ultra-weak shock ) "
       write(90,*) " (6: April 21st event ) "

The code starts with no_shells = 1. After every 150 time steps, a new shell is constructed. 
Once a new shell is constructed, the above mentioned steps a) - e) are performed:

These corresponds to the following code segment:

	call wave_intens     ! Get the wave intensity and the maximum momentum of proton and heavy ion.
        call expand_distr    ! Calculate the simultaneous expansion of the shells with the solar wind.
        call add_acc_ptcls   ! Add the newly generated particles to the newly generated shell.
        call diffuse_distr   ! Calculate the change of distribution among all shells due to diffusion.

1) wave_intens.f:c       written by : Ken Rice
	   	         modified by: Gang Li
 
   Calculate the wave intensity, generated by streaming protons. Along the way, calculate the 
   maximum proton energy and heavy ion energy.

   Data are written to following files:
	
       open(43,file='waveintens.dat',     form='formatted',status='unknown')
       open(44,file='kappa.dat',          form='formatted',status='unknown')

	Write(43,*) k*Vsw/2.0/pi, energy,
     *            2.0E18*Ipluso(i)*2.0*pi/Vsw, 
     *            2.0e18*Iplus(i,no_shells)*2.0*pi/Vsw,
     *            2.0E18*Ibohm(i)*2.0*pi/Vsw	

        Write(44,111) k*Vsw/2.0/pi, energy, kappa(i,no_shells), 
     *            kappa_hi(i,no_shells),4.0D0/3.0D0/pi*rg*vel,
     *            x1a(shock_begin)

In waveintens.dat(43), we have in sequence:
1)frequency f in solar wind frame, f = k * Vsw / (2*pi),
2)energy,
3)solar wind power spectra P in unit (nT^2/Hz), satisfying  P df = 2 * I dk 
4)turbulence power spectra P in unit (nT^2/Hz), satisfying  P df = 2 * I dk 
5)turbulence power spectra P in accordance with Bohm approximation. 

In kappa.dat(44) we have in sequence:
1)frequency f in solar wind frame, f = k * Vsw / (2*pi),
2)energy,
3)diffusion coefficient for proton, 
4)diffusion coefficient.for hvyIon,
5)diffusion coefficient for Bohm approximation.
6)shock location.

Plotting procedure: 

split -250 kappa.dat KAPPA
Then plot KAPPA?? (x=2,y = 3,4,5) for kappa_p, kappa_hi, kappa_Bohm

split -250 waveintensity.dat WI
Then plot WI?? (x=1, y = 3,4) for I_total, I_o



2)  expand_distr.f:c       written by : Ken Rice
                           modified by: Gang Li

Follow the expansion of each shell in the solar wind. No diffusion in this step.


The diffusion coeff. and wave intensity in these shells are recorded in file 
kappa-wave-I.dat (67).

        write(67,*) "--- time is ---", time
	do i = 1, no_shells 
	  write(67,*) i,temp, Energy, Iplus(j,i),kappa(j,i), kappa_hi(j,i)
	enddo 

To plot the data file,

a)	csplit kappa-wave-I.dat -f KAPPA-TIME /time/ {*}
b)      split -250 KAPPA-TIME??  KAPPA-TIME??-SHELL

Then plot KAPPA-TIME??-SHELL?? using (x=3, y = 5) for kappa

3)  add_acc_ptcls.f  written by: Gang Li

This subroutine add the injected protons and heavy ions at the first shell.


4)  diffuse_distr.f:c    written by: Ken Rice
	                 modified by: Gang Li 02/21/2003    
                         modified by: Gang Li 03/11/2003: Add heavy ions

This file follows the diffusion of the particles between all shells.
It solves the diffusion equation for the current time step for all the shells.
Within this file, two subroutines are called as shown in follows.

call diffuse_distr_integ(num_ptcls,fi,shell_posn, R_shell_x(l), R_shell_x(l+1), temp) 

call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, x1a(shock_begin)+esc_length, temp) 

3.1)  diffuse_distr_integ(num_ptcls,fo, ri, r1, r2, temp) 
c	 		written by: Ken Rice
c    			modified by: Gang Li
The parameters are:
c------ num_ptcls is the output, 
c------ fo: input number density, shell_posn: input shell position, 
c------ ri = 0.5*(r1+r2) is the shell center location. 
c------ r1: beginning loc. of the shell. 
c------ r2: ending loc. of the shell.                              
c------ temp: the length scale (the width of the Gaussin distribution.)

This subroutine gives the number of particles in the lth shell, i.e. between R_shell_x(l) 
and R_shell_x(l+1).

3.2)  diff_distr_fn_posn(dens_ptcls, fo, ri, r, temp)
c	 		written by: Ken Rice
c    			modified by: Gang Li
The parameters are:
c------ dens_ptcls is the output.
c------ fo: input number density, 
c------ ri is the shell center location. 
c------ the location of where the dens_ptcl is calculated.
c------ temp: the length scale (the width of the Gaussin distribution.)

This subroutine calculate the number density at r due to the shell located at ri.

The data output from this file are:

A1) ptcls_in_shell.dat (13)  
    This file contains particle number in every ith shell and for every
    jth momentum bin.
    write(13,*) Energy,distr_array(i,j)* factor_num/dV,
     *            distr_array_hi(i,j)*factor_num/dV

To plot: 
	1) csplit ptcls_in_shell.dat -f PTCL /time/ {*} 
   choose the time period for your interest, for example, PTCL07 then
	2) vi PTCL07, get rid off the first line and do
	3) split -250 PTCL07 PTCL07
   Then files of PTCL07(??) with ?? = aa, ab, ac, ... etc will contain the data in 
   each shell.
   plot (x=1, y = 2) for protons density in each shell. 
   plot (x=1, y = 3) for hvyions density in each shell. 

A2) distr_in_shell.dat (14)
   This file contains particle number density in every ith shell and for every
   jth momentum bin. ( number / d^3p)

    write(14,*) Energy,esc_dens_shell(j,i),esc_dens_shell_hi(j,i)

  Note, esc_dens_shell(j,i) is the phase space density at the outer bc of the ith
  shell. It has the unit of (1/ d^3r d^3p).


To plot: 
	1) csplit distr_in_shell.dat -f DST-SHELL /time/ {*} 
   choose the time period for your interest, for example, DST-SHELL06 then
	2) csplit DST-SHELL06 -f SHELL /shell/ {*}
   Then files of SHELL(??) with ?? = 00, 01, 02, ... etc will contain the data in each shell.
   plot (x=1, y = 2) for proton depsity in each shell. 
   plot (x=1, y = 3) for hvyion density in each shell. 


A3) shell-location.dat (68)
The location of the shell boundaries, as well as total number of particles in each 
shell are recorded in (68).

These corresponds from i = 1, 2, 3, .... no_shells + 1  
and the number are between 1-to-2, 2-to-3, ...... ,no_shells+1-to-infinity, 

       write(68,*) "--- time is ---", time
       do i = 1, no_shells + 1
          write(68,*) i, R_shell_i(i), R_shell_x(i),total_num_p(i),
     *         total_num_hi(i)
       enddo

where total_num_p(i) is for proton, total_num_hi(i) is for hvy ion.

   |     |    |      |             |
   |     |    |      |             |
   |     |    |      |             |

i= 1    2 ...... no_shells     no_shells+1 (=shock_begin)

To plot:  csplit shell-location.dat -f SHELL /time/ {*} 
then choose SHELL?? (eg. SHELL03) 
and plot (x=3,y=4,dy=4) 


B1) esc_distr.dat(38) and esc_distr-hi.dat(58) 

  write(38,*) Energy, esc_dens_up(p_int), x1a(shock_begin)+4.0D0*temp, time
  write(58,*) Energy, esc_dens_up_hi(p_int), x1a(shock_begin)+4.0D0*temp_hi, time

  These two files contain proton and heavy ion density at location 
  x1a(shock_begin)+4.0D0*temp.

  Note: esc_dens_up(p_int) is the phase density and has unit #/(d^3r*d^3p).

B2) esc_num_up.dat (88) and esc_num_up_hi.dat (89).

          If (Exp(p) .LE. p_cut ) Then
             write(88,*) Energy, esc_number_up(p_int), 
     *            esc_number_up(p_int), temp_counter1,
     *            x1a(shock_begin)+escape_length(p_int)
          ELSE
             write(88,*) Energy, esc_number_up(p_int), 0.,
     *            temp_counter1,
     *            x1a(shock_begin)+escape_length(p_int)
          ENDIF

         If (Exp(p) .GE. p_hi_cut ) Then
             write(89,*) Energy, esc_number_up_hi(p_int), 0.,
     *       temp_counter2,    
     *       x1a(shock_begin)+escape_length_hi(p_int)
          ELSE
             write(89,*) Energy, esc_number_up_hi(p_int), 
     *            esc_number_up_hi(p_int), temp_counter2,
     *            x1a(shock_begin)+escape_length_hi(p_int)
          ENDIF

  Note: esc_number_up(p_int) has unit of #/(d^3p).

split -250 esc_num_up.dat ESC (split -250 esc_num_up_hi.dat ESC-HI )
   plot (x =1, y =2) for  (energy, esc_num)	
or  plot (x =1, y =4) for  (energy, temp_counter1) where
temp_counter is the time-integrated escaped particle number.


C) current_at_shock.dat (78) and distr_at_shock.dat (79)

  write(78,*) Energy, den_sh_j, den_sh_hi_j,x1a(shock_begin), time
          
  write(79,*) Energy, distr_array(no_shells, p_int), 
     *         distr_array_hi(no_shells, p_int), time

These file contains particle current ( proton and heavy ions)
 andparticle distribution at the shock location.
 
Note, den_sh_j and den_sh_hi_j have the unit of #/(cm^2 s MeV).
      and distr_array(i,j) has the unit of (number / d^3p).

the plotting procedure: 

split -250 current_at_shock.dat CRT
split -250 dist_at_shock.dat DIST

plot (x=1,y=2) for energy-current  and (x=1,y=3) for hvy-ion current.

----------------------------------------------------------------------

5) Back to file zeus3d.f. File "shock_momenta.dat", which is opened through,

open(45,file='shock_momenta.dat',form='formatted') 

write(45,2110)x1a(shock_begin),(time-1.00003167)*to/3600.,
     *          p_sml,p_big,energy_sml, energy_big

contains the location of the shock, maximum and minimum proton energy.

Similarly, file "momenta-hi.dat" opened through

open(55,file='momenta-hi.dat',form='formatted',
     *         status='unknown') 

write(55,2110)x1a(shock_begin),(time-1.00003167)*to/3600.,
     *          p_sml,p_big,energy_sml, energy_big

contains the location of the shock, maximum and minimum heavy ion energy.

Also, file shock_posn_comp.dat opened through

open(48,file='shock_posn_comp.dat',form='formatted',
     *      status='unknown') 

write(48,2100)x1a(shock_begin),comp_rat,
     *          shock_speed*vo/1000.,v1(shock_end+2,1,5)*vo/1000.,	    
     *          (time - 1.00003167)*to/3600.

contains the location, comp_rat, speed, time of the shock.
plot (x = 1, y = 2) for comp. ratio
plot (x = 1, y = 3) for shock speed.
plot (x = 1, y = 4) for upstream solar wind speed.

       subroutine bsetmag
c
c    dac:zeus3d.bsetmag <------------------ sets all magnetic boundaries
c                                                            march, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This routine collects the calls to the subroutines BSET*
c  which set the inflow boundaries of the magnetic variables.  It is
c  intended to be called just ONCE during the initialisation of the
c  problem.  If the inflow boundary values for the emfs change in time,
c  it is best to update these by calling the subroutines BSETEMF* by
c  themselves.  If BSETMAG is called to update the inflow emfs, then
c  the boundary values for the magnetic fields will be reset without
c  regard to maintaining div(B)=0 numerically.  This could lead to the
c  introduction of monopoles into the grid.
c
c  Also note that the since the emfs are located at different positions
c  on the grid than the velocities and the magnetic fields, the emfs are
c  evaluated by either averaging or upwinding the relevant quantities.
c  If the boundary values for the velocities and magnetic fields are
c  constant in space, then this prescription is OK.  But, if these
c  quantities possess some spatial dependence, it is probably best to
c  set the emfs directly in the intialising subroutine with the known
c  values of the velocities and magnetic fields at the locations of the
c  emfs, rather than relying on this subroutine to set them correctly.
c
c  INPUT VARIABLES: [NONE]
c
c  OUTPUT VARIABLES: [NONE]
c
c  LOCAL VARIABLES: [NONE]
c
c  EXTERNALS:
c    BSETB1  , BSETB2  , BSETB3
c    BSETEMF1, BSETEMF2, BSETEMF3
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c      External statements
c
       external      bsetb1  , bsetb2  , bsetb3
     1             , bsetemf1, bsetemf2, bsetemf3
c
c-----------------------------------------------------------------------
c
       call bsetb1
       call bsetb2
       call bsetb3
       call bsetemf1
       call bsetemf2
       call bsetemf3
c
       return
       end

       subroutine lookup ( ra, rmin, rmax, ta, tmin, tmax, j1, j2, isen
     1                   , qty, irb, jtb )
c
c    dac:zeus3d.lookup <----------- generates lookup tables for RT -> XY
c                                                            april, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  For the purposes of speeding up the RT to XY re-map, this
c  subroutine generates high-resolution look-up vectors ("irb", "jtb")
c  which are used to locate a set of arbitrary coordinates (r,theta) on
c  a discretised grid (ra(i),ta(j)).
c
c  INPUT VARIABLES:
c    ra         face-centred radial coordinate of computational grid
c    ta         face-centred angular coordinate of computational grid
c    j1,j2      starting and ending indices for "ta".
c    rmax,rmin  desired extrema of "ra"
c    tmax,tmin  desired extrema of "ta"
c    isen       >0 => map only the portion of "ta" between "tmin" and
c                     "tmax" to the look-up vector "jtb".
c               <0 => map all of "ta" to the look-up vector "jtb".
c
c  OUTPUT VARIABLES:
c    irb,jtb    look-up vectors to facilitate remapping
c    qty(1,2)   effective range of "ra"  spanned by "irb"
c    qty(3)     resolution of look-up vector "irb"
c    qty(4,5)   effective range of "ta" spanned by "jtb"
c    qty(6)     resolution of look-up vector "jtb"
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       integer       j1      , j2      , isen
       integer       jmax    , j       , jc      , nmax    , i
     1             , im1     , n       , jm1
       real*8        rmin    , rmax    , tmin    , tmax
       real*8        ramn    , ramx    , dra     , rb      , tamn
     1             , tamx    , dta     , tb      , small
c
       integer       irb     (   *), jtb     (   *)
       real*8        ra      (   *), ta      (   *), qty     (   *)
       real*8        tax   (3*ijkn)
c
c      Careful!  "wa1d" through "wf1d" are used in PIXDMP.
c
       equivalence   ( tax     , wg1d     )
c
c      Data statements
c
       data          small    / 0.001 /
c
c-----------------------------------------------------------------------
c
c      "tax" is the extended angular grid, and stores three branches of
c  the grid specified in "ta" in the same array.  This is only required
c  when the angular grid "ta" spans 2*pi radians, and when the segment
c  to be mapped to a Cartesian grid straddles the branch point.
c  Otherwise, "tax" can be thought of as nothing more than a copy of
c  "ta".
c
       jmax = j2 - j1 + 1
       do 10 j=1,jmax
         jc            = j + j1 - 1
         tax(j       ) = ta(jc) - 2.0 * pi
         tax(j+  jmax) = ta(jc)
         tax(j+2*jmax) = ta(jc) + 2.0 * pi
10     continue
c
c      "irb" is a (long) vector containing the indices of the nearest
c  value of "ra" for a large sample of radial coordinates possible on
c  the Cartesian grid.
c
       nmax = 20 * ijkn
       ramn = 0.0
       ramx = sqrt ( 2.0 ) * rmax
       dra  = ( ramx - ramn ) /  real(nmax)
       rb   = ramn - dra / 2.0
       i    = 1
       im1  = 1
       do 30 n=1,nmax
         rb = rb + dra
         if ( (rb .lt. rmin) .or. (rb .gt. rmax) ) then
           irb(n) = 0
           go to 30
         endif
20       continue
         if (rb .gt. ra(i)) then
           im1 = i
           i   = i + 1
           go to 20
         else
           irb(n) = im1
         endif
30     continue
c
c      "jtb" is a (long) vector containing the indices of the nearest
c  value of "ta" for a large sample of angular coordinates possible on
c  the Cartesian grid.
c
       nmax = 40 * ijkn
       tamn =  real(  int ( 2.0*tmin/pi + 4.0 + small ) ) * pi / 2.0
     1      - 2.0 * pi
       tamx =  real(  int ( 2.0*tmax/pi + 5.0 - small ) ) * pi / 2.0
     1      - 2.0 * pi
       if ( (tamx-tamn .gt. pi+small) .or. (isen .lt. 0) ) then
         tamn = tmax - 2.0 * pi
         tamx = tmax
       endif
       dta  = ( tamx - tamn ) /  real(nmax)
       tb   = tamn - dta / 2.0
       j    = 1
       jm1  = 1
       do 50 n=1,nmax
         tb = tb + dta
         if ( (tb .lt. tmin) .or. (tb .gt. tmax) ) then
           jtb(n) = 0
           go to 50
         endif
40       continue
         if (tb .gt. tax(j)) then
           jm1 = j
           j   = j + 1
           go to 40
         else
           jtb(n) = mod ( jm1, jmax ) + j1 - 1
         endif
50     continue
c
c      Set elements of "qty" to scalars.
c
       qty(1) = ramn
       qty(2) = ramx
       qty(3) = dra
       qty(4) = tamn
       qty(5) = tamx
       qty(6) = dta
c
       return
       end

      program zeus3d
c
c    dac:zeus3d <------------------------- multi-physics, 3-D fluid code
c    from jms:zeus2d (NCSA),                               january, 1990
c         mln,dac:zeus04 (NCSA),
c         mln,dac:b2 (LANL),
c         mln:a2 (LANL)
c
c    Written by: David Clarke
c    Modified 1: Robert Fiedler, 2/95, so that the calls to the various
c                timing routines work properly on Convex, Sun, SGI,
c                IBM, and HP machines even if compiler flags are used
c                to promote the default precision to 64-bits.
c
c    Modified by: Gang Li 08/2006 
c                 Delete ishock input since it is in gen_bndy.f
c
c  PURPOSE:  The main program orchestrates the calls to the major
c  subroutines in the hydrodynamical loop, and the subroutines which
c  handle the output.
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundares
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c     
c-----------------------------------------------------------------------
c------------------ Start of Main program ------------------------------
c-----------------------------------------------------------------------
c
       integer       nzones  , nzceff  , nzcact  , cpuhours, cpumins
     1             , cpusecs , wchours , wcmins  , wcsecs
       real*8        zcspk   , zcseff  , zcsact  , cputot  , wctot
     1             , cpu1    , cpu2    , ptime
       real*4        tarray  (   2)
       integer*4     iarray  (   3)
c
       integer i,j,maxshells
       real*8    max_p
c
       parameter (maxshells = 200, max_p = 10.0D0)
c
       real*8   R_shell_x(maxshells)
       integer  R_shell_i(maxshells)
       real*8   esc_shell(in,250)
       real*8   shock_speed, Machno, comp_rat
       real*8   prev_shock_posn, prev_shock_time
       real*8   p_cut_bohm, p_cut_gorlee,p_cut_gorlee_hi
       real*8   p_inj, p_cut, distr_array(maxshells,250)
       real*8   esc_dens_up(250),esc_dens_down(250)
       real*8   prev_acc_time, prev_expand_time(maxshells), 
     *       prev_acc_posn
       real*8   arrive_distr(250,10) 
       integer  no_shells, shell_dt_count
       integer  shock_begin, shock_end     
       real*8   charge, Amass, p_hi_inj, p_hi_cut
       real*8   distr_array_hi(maxshells,250),esc_dens_up_hi(250),
     *      esc_dens_down_hi(250),esc_shell_hi(in,250)
c
       real *8 to, vo
       real *8 p_sml, energy_sml, p_big, energy_big, mp, c

       integer  N_shell_dt      ! controls the time steps for 
                                ! generating a new shell.

       integer i_shock_strength ! controls the shock strength.
       integer i_heavy          ! controls CNO or IRON.

       integer i_perp           ! controls if this is a perp. shock.
       integer i_restart        ! controls if this is a restart.

       integer R_shell_i_prev(maxshells)! used to calculate the shell position

       real*8 esc_ptcl_counter(250) ! time-integrated escaped particles.
       real*8 esc_ptcl_counter_hi(250) ! time-integrated escaped particles.


       real*8 ipmax(maxshells),ipmin(maxshells)
                                ! ipmax(j) is the maximum proton momentum index
                                ! for the jth shell.
       real*8 ipmax_hi(maxshells),ipmin_hi(maxshells)
                                ! ipmax(j) is the maximum HvyIon momentum index
                                ! for the jth shell.

       
       integer j_p_cut_chk, j_p_cut
       integer j_p_cut_chk_hi, j_p_cut_hi
       
       real*8   erfcc
       real*8   distr_array_all(250)
       real*8   distr_all(250)

       real*8  shock_start_time

       real*8  alphaK, theta_BN
       
       common /wave_add/j_p_cut_chk,j_p_cut,j_p_cut_chk_hi,j_p_cut_hi

       common /shell/  esc_shell, R_shell_x, R_shell_i, no_shells 
       common /shock1/ prev_shock_posn, prev_shock_time
       common /shock2/ shock_begin, shock_end, shock_speed,
     *                 Machno, comp_rat  
       common /ptcls/  p_inj, p_cut, distr_array, esc_dens_up,
     *                 esc_dens_down, prev_acc_time,
     *      prev_expand_time, prev_acc_posn
       common /shocktime/ shock_start_time

       common /arrive/ arrive_distr  
       common /heavyIon/ charge, Amass, p_hi_inj, p_hi_cut
       common /heavyIon2/distr_array_hi,esc_dens_up_hi,esc_dens_down_hi,
     *      esc_shell_hi

       common /kappa_perp/ i_perp
c       common /gl_save/ shell_dt_count

       common /R_shell_int/R_shell_i_prev

       common /p_checker/ipmax,ipmin,ipmax_hi,ipmin_hi
       common /escape_counter/ esc_ptcl_counter, esc_ptcl_counter_hi
       common /total_ptcl /distr_array_all       
       common /diag/distr_all
       common /zeus3d_wave_intens/ alphaK, theta_BN

       integer ctoi
       external ctoi 

       real*8 res_time
       common /dump_time/res_time

       common /shell_control/ shell_dt_count, N_shell_dt  

c     
c      External statements.
c
       real*4        etime
       external      etime   , itime
       external      empty   , renam
c
c      The following external statements are defined only if the EDITOR
c  alias is aliased to something other than "empty".  This prevents
c  "empty" from being declared in more than one external statement.
c
       external      gen_bndy  
       external      mstart
       external      srcstep
       external      transprt
       external      nudt
       external      dataio

       integer isolar
       real *8 time_0
       real *8 tmtreT


c
c-----------------------------------------------------------------------
c
c      Initialise cpu and wall clocks.  "cputot" will be the total cpu
c  time (in seconds) consumed by this job.  "wctot" will be the total
c  elapsed wall clock time (in seconds) since the job began.
c

       cputot = etime ( tarray )
       call itime ( iarray )
       wctot  = iarray(1) * 3600. + iarray(2) * 60. + iarray(3)
c
c      Initialise execution and make dump of initial model.
c
c --- Jan. 11th, 2006 GL: important parameters in strange unit. 
       to = 2858055.0   ! time unit  (in seconds)
       vo = 52483.25D0  ! speed unit (in m/sec) 
       mp = 1.67D-27    ! mass of proton (in gram)
       c = 3.0D8        ! speed of light (in m/sec)



       write(*,*) "input iheavy (1 for CNO, 2 for IRON)"
       write(*,*) "Is this a CONTINUED run (1:yes,0:no)"
       read(*,*) i_heavy
       read(*,*) i_restart

       write(*,*) "input i_perp (0: Bohm, 1:perp) "
       read(*,*) i_perp         ! i_perp = 0

       write(*,*) "input alphaK (0.001)"
       read(*,*) alphaK !        alphaK = 0.001

       write(*,*) "input theta_BN (80.)"
       read(*,*) theta_BN !      theta_BN = 80 degree

       call mstart

       res_time = 0.
       iresdmp = ctoi ( resfile, 3, 4 )
       print*, "iresdmp is", iresdmp
       print*, "time is", time
       res_time = time
c       pause

       if (iresdmp .eq. 0) then ! usrdmp file zr01IH 
          res_time = 0.
          isolar = 0
          print*, "---going to 2000-----"
          go to 2000
       else 
          isolar = 1
          print*,"res_time is",res_time 
          open (27,file="start_time.dat")
          write(27,*) res_time, x1a(is)
          close(27)
       endif

c---- initial values for our own code. --GL
       j_p_cut = 0                
       j_p_cut_hi = 0 
       j_p_cut_chk = 0
       j_p_cut_chk_hi = 0

       N_shell_dt = 150 ! the initial N_shell_dt

c     
c ---  Initialise ptcl acc variables and arrays.        
c
       Do i = 1, maxshells
         R_shell_x(i) = 0.1
         R_shell_i(i) = is + 3    
         Do j = 1, 250 
	    esc_shell(i,j) = 0.0
         End Do
       End Do 

       Do i = 1, maxshells
         R_shell_i_prev(i) = 0    
       End Do 
c
       Do i = 1, 10
         Do j = 1, 250
	   arrive_distr(j,i) = 0.0D0
	 EndDo
       EndDo	  

c ---initialize distr_array
       Do i =1, maxshells
          Do j =1, 250
             distr_array(i,j) = 0.  ! for proton
             distr_array_hi(i,j) = 0. ! heavy ion
          ENDDO
       ENDDO

c ---initialize distr_array_all
          Do j =1, 250
             distr_array_all(j) = 0.
          ENDDO

c ---initialize esc_ptcl_counter (p_number)
       Do j =1, 250
          esc_ptcl_counter(j) = 0.
          esc_ptcl_counter_hi(j) = 0.
          distr_all(j) = 0.
       ENDDO

c
c       shock_speed = 10.9       ! Initial shock speed.       
       prev_shock_posn = x1a(is) ! Shock starting position.
       prev_shock_time = time   ! Shock starting time.
       prev_acc_time = time     ! Acceleration starting time.
       prev_acc_posn = x1a(is)  ! Acceleration starting position.
       R_shell_x(1) = x1a(is)
       R_shell_i(1) = is
       R_shell_x(2) = x1a(is)
       R_shell_i(2) = is

       shock_begin = 0

       shock_start_time = time
c
c --------------------------------------------------------------------  
c  Open output files
c --------------------------------------------------------------------
c

       open(13,file='ptcls_in_shell.dat',form='formatted',
     *         status='unknown')
c
       open(14,file='distr_in_shell.dat',form='formatted',
     *         status='unknown')
c
       open(35,file='obs_ptcls.dat',form='formatted',
     *         status='unknown')
c
       open(36,file='posn_distr.dat',form='formatted',
     *         status='unknown')
c
       open(37,file='time_distr.dat',form='formatted',
     *         status='unknown')
c
       open(38,file='esc_distr.dat',form='formatted',
     *         status='unknown')                   
c
       open(39,file='distr_1AU_time.dat',form='formatted',
     *         status='unknown')   
c
       open(43,file='waveintens.dat',form='formatted',
     *         status='unknown')
c    
       open(44,file='kappa.dat',form='formatted',
     *         status='unknown') 
c
       open(45,file='shock_momenta.dat',form='formatted',
     *         status='unknown') 
c

c       open(46,file='f_acc.dat',form='formatted', 
c     *         status='unknown')   

c
       open(47,file='distr_fn_out.dat',form='formatted',
     *         status='unknown')  
c    
       open(48,file='shock_posn_comp.dat',form='formatted',
     *      status='unknown') 

       open(55,file='momenta-hi.dat',form='formatted',
     *         status='unknown') 

       open(58,file='esc_distr-hi.dat',form='formatted',
     *         status='unknown')                   

       open(65,file='momenta-bohm.dat',form='formatted',
     *         status='unknown') 

       open(66,file='f_acc-hi.dat',form='formatted', 
     *         status='unknown')   

       open(67,file='kappa-wave-I.dat',form='formatted',
     *         status='unknown') 

       open(68,file='shell-location.dat',form='formatted',
     *         status='unknown') 

       open(69,file='shell-location2.dat',form='formatted',
     *         status='unknown') 

       open(78,file='current_at_shock.dat',form='formatted', 
     *         status='unknown')   

       open(79,file='dist_at_shock.dat',form='formatted', 
     *         status='unknown')   

       open(88,file='esc_num_up.dat',form='formatted', 
     *         status='unknown')   

       open(89,file='esc_num_up_hi.dat',form='formatted', 
     *         status='unknown')   
       
       open(90, file ='zeus.log', status='unknown')   

       open(91, file ="gl.input", status='unknown')  ! no use now. -- GL

       open(92, file ="gl.output", status='unknown') ! no use now. -- GL

       no_shells = 1
       shell_dt_count = 0

c   --- ZEUS part.

 2000  continue
       if (iolog .gt. 0) then
         if (nwarn .eq. 0) write (iolog, 2010)
         if (nwarn .eq. 1) write (iolog, 2020)
         if (nwarn .gt. 1) write (iolog, 2030) nwarn
       endif
       if (iotty .gt. 0) then
         if (nwarn .eq. 0) write (iotty, 2010)
         if (nwarn .eq. 1) write (iotty, 2020)
         if (nwarn .gt. 1) write (iotty, 2030) nwarn
       endif
       nzceff  = 0
       nzcact  = 0
       zcspk   = 0.0
       tused   = 1.0
       cpu1    = etime ( tarray )

       time_0 = dtdmp
       print*, "--- dtdmp ---", dtdmp
c       pause

       if (isolar .eq. 0) then
          print*, "----going to 10 ----"
          go to 10
       endif

c ---initialize distr_array, esc_num_d

       if (i_restart .eq. 1) then
          print*, "---- Read continution from gl.input -----"
          
          read (91,*) no_shells,shell_dt_count,shock_speed
          read (91,*) prev_shock_posn,prev_shock_time
          read (91,*) prev_acc_time, prev_acc_posn

          Do i = 1, maxshells
             read(91,*) R_shell_x(i), R_shell_i(i), 
     *            prev_expand_time(i)
          End Do 
          
          Do i =1, maxshells
             Do j =1, 250
                read(91,*) distr_array(i,j),distr_array_hi(i,j)
             ENDDO
          ENDDO

       print*, "----successful read in gl.input -----"
       endif
       
c---------------
       
       if (ifsen .eq. 1) go to 20
c     
c-----------------------------------------------------------------------
c--------------------------  START OF MAIN LOOP  -----------------------
c-----------------------------------------------------------------------
c
c      Execution ends when INTCHK returns a value of 1 for "ifsen".
c
       print*, " ------ In zeus3d.f -------"

c---- only the ratio of amass/charge matters.

       if (i_heavy .eq. 0) then ! For checking code.
          amass = 1. 
          charge = 1.
       elseif (i_heavy .eq. 1) then ! select CNO.
c---  for CNO
          amass = 14. 
          charge = 6.57
       elseif ( i_heavy .eq. 2) then ! select IRON.
c---  for IRON
          amass = 56.
          charge = 14.
       endif

       write(90,*) " --- This file is generated at the begining "
       write(90,*) " --- of running xzeus -----"
       write(90,*) " i_heavy is: ", i_heavy
       write(90,*) " amass and charge are ", amass, charge 
       close (90)

10     continue
c----------- [FLAG]: most of the following are ZEUS part.

       call gen_bndy  ! boundary condition subroutine need to be changed for different shocks.
       call empty
       call empty
       call srcstep
       call empty
       call transprt
       call empty
       call nudt
       call empty
       call dataio

       nhy    = nhy   + 1
       time   = time  + dt
c
c       print*, 'nhy=',nhy,' & dt=',dt,' & time=',time
c     
       if (isolar .eq. 0) then
          if ( time .gt. time_0) then
             do i = 1, 450      ! boundary at 5000  write solar wind speed to data file.
c                print*, "----gamma is ---", gamma(1)
c                pause

                tmtreT = e(i*10, 1, 5)*(gamma(1)-1.)/(6.*d(i*10, 1, 5))
                write(22,*)x1a(i*10), d(i*10, 1, 5),
     X               v1(i*10,1,5)*vo/1000., tmtreT, time 
                write(23,*)x1a(i*10), b1(i*10, 1, 5),
     X               b3(i*10,1,5), time
             enddo
             time_0 = time_0 + dtdmp
             print*, "----writing solar wind speed to a dump file --"
             print*, "iresdmp is", iresdmp
          endif
c          print*, "---going to 2001-----"
          go to 2001 
       endif

c-----------END [FLAG].

c---   The following deals with shells. GL

       shell_dt_count = shell_dt_count + 1
c       
c       print*, "shell_dt_count, N_shell_dt",shell_dt_count, N_shell_dt
 
       If ((shell_dt_count.gt.0) .and. 
     *      (shell_dt_count.lt. N_shell_dt)) Then
          call shell_track
	  If (mod(shell_dt_count,5*N_shell_dt) .eq. 0) then
            call posn_distr(0.8D0)
	  EndIf  	    
       EndIf
c     
c
       If ((shell_dt_count .eq. N_shell_dt).or. 
     *      (shell_dt_count.eq.0)) Then
          call shell_track	 
          
          print*, "prev_acc_time ",prev_acc_time 
          print*, "prev_acc_posn", prev_acc_posn
          print*, 'time = ', time
          print*, "---time,shock_begin, x1a(shock_begin)---", 
     *         time, shock_begin, x1a(shock_begin)
          if( (prev_acc_posn .gt. x1a(shock_begin)) .and.
     *         (shell_dt_count.ne.0) )then
             print*, "N_shell_dt", N_shell_dt
             print*, "prev_acc_posn, x1a(shock_begin)", 
     *            prev_acc_posn, x1a(shock_begin)
c             pause
          endif

          If (shell_dt_count .eq. N_shell_dt) Then ! create a new shell.
             
             call wave_intens   ! get the wave intensity
             call expand_distr  ! Calculate the simultaneous expansion with the solar wind.
             call add_acc_ptcls ! At the shock front, add the newly generated particles.
             call diffuse_distr ! Calculate the change of distribution due to diffusion.
c------------
             
             print*, " --- After subroutine calls ----" 
             
c---- Check how far are we from the sun and update N_shell_dt if necessary.
             
             if (x1a(shock_begin) .lt. 0.35 ) then
                N_shell_dt = 120 ! time steps for generating a new shell.
             else
                N_shell_dt = 150 ! time steps for generating a new shell.
             endif
             
             prev_acc_time = time
             prev_acc_posn = x1a(shock_begin)
             
             print*, "shock_speed,shock_posn",shock_speed, prev_acc_posn
             print*, "no_shells", no_shells
c     
c---- write location of the shock, maximum and minimum proton energy
c---- to file, shock_momenta.dat(45)

             p_sml = (mp*vo*c*p_inj)/1.6D-19 ! Inject  mom. in eV
             p_big = (mp*vo*c*p_cut)/1.6D-19 ! Maximum mom. in eV
             
             energy_sml = (Sqrt((mp*c**2.0)**2.0+(mp*vo*c*p_inj)**2.0)- !Inject kinetic 
     *            mp*c**2.0)/1.6D-19 !energy in eV
             
             energy_big = (Sqrt((mp*c**2.0)**2.0+(mp*vo*c*p_cut)**2.0)- !kinetic energy
     *            mp*c**2.0)/1.6D-19 !energy in eV
             
             write(45,2110)x1a(shock_begin),(time-res_time)*to/3600.,
     *            p_sml,p_big,energy_sml, energy_big
             
             print*, " *** ---------***"
             
             print*, x1a(shock_begin),(time-res_time)*to/3600.,
     *            p_sml,p_big,energy_sml, energy_big
             
             print*, " *** ---------***"
             
c---- write location of the shock, maximum and minimum proton energy
c---- to file, shock_momenta.dat(45)

            write(65,2110)x1a(shock_begin),(time-1.00003167)*to/3600.,
     *           p_sml,p_cut_bohm

c---- write location of the shock, maximum and minimum heavy ion energy
c---- to file, shock_momenta.dat(55)

             p_sml = (mp*vo*c*p_hi_inj)/1.6D-19 ! Inject  mom. in eV
             p_big = (mp*vo*c*p_hi_cut)/1.6D-19 ! Maximum mom. in eV
           
             energy_sml = (Sqrt((mp*c**2.0)**2+(mp*vo*c*p_hi_inj)**2.0)- !Inject kinetic 
     *            mp*c**2.0)/1.6D-19 !energy in eV
             
             energy_big = (Sqrt((mp*c**2.0)**2+(mp*vo*c*p_hi_cut)**2.0)- !kinetic energy
     *            mp*c**2.0)/1.6D-19 !energy in eV
             
             write(55,2110)x1a(shock_begin),(time-res_time)*to/3600.,
     *            p_sml,p_big,energy_sml, energy_big
            
c---- write shock location, comp_rat, speed, time
c---- to file, shock_posn_comp.dat (48)

             print*,"output in shock_posn*.dat",time,res_time 
             write(48,2100)x1a(shock_begin),comp_rat,
     *            shock_speed*vo/1000.,v1(shock_end+2,1,5)*vo/1000.,	    
     *            (time - res_time)*to/3600.
             
             write(*,*) "x1a(shock_begin),shock_speed,comp_rat",
     *           x1a(shock_begin),shock_speed*vo/1000.,comp_rat
             
             no_shells = no_shells + 1
             shell_dt_count = 0  
c--- ( debug
c            pause
c--- ) debug

          EndIf
       EndIf

c---- ZEUS part of the code.       	 	              
 2001 continue

      nzones = nx1z * nx2z * nx3z
      cpu2   = cpu1
      cpu1   = etime ( tarray )
      cpu1   = tarray(1)
      cpu2   = cpu1 - cpu2
      zcspk  =   max ( zcspk,  real(nzones) / cpu2 )
      nzceff = nzceff + nx1zmx * nx2zmx * nx3zmx
      nzcact = nzcact + nzones
      if (ifsen .eq. 1) go to 20
      go to 10
 20   continue
c     
      close(47)
      close(46)
      close(45)
      close(48)
      close(44)
      close(43)
      close(39)
      close(38)
      close(37)
      close(36)
      close(35)
      close(54)
      close(55)
      
c     
c-----------------------------------------------------------------------
c---------------------------  END OF MAIN LOOP  ------------------------
c---------------------------  ZEUS part of the code  ------------------------
c-----------------------------------------------------------------------
c
c      Perform any user-specified clean-up tasks.
c
       call empty
c
c      Determine number of zone-cycles per second.
c
       zcseff   =  real(nzceff) / tused
       zcsact   =  real(nzcact) / tused
c
c      Final wall clock time, expressed in hours, minutes, and seconds.
c
       call itime (iarray)
       wctot  = iarray(1) * 3600. + iarray(2) * 60. + iarray(3) - wctot
       wchours  =  int ( wctot / 3600.0 )
       wcmins   =  int ( wctot / 60.0   ) - 60   * wchours
       wcsecs   =  int ( wctot + 0.5    ) - 3600 * wchours
     1                                    - 60   * wcmins
c
c      cpu usage, expressed in hours, minutes, and seconds.
c
       cpusecs  = etime ( tarray )
       cputot   = tarray(1) - cputot
       cpuhours =  int ( cputot / 3600.0 )
       cpumins  =  int ( cputot / 60.0   ) - 60   * cpuhours
       cpusecs  =  int ( cputot + 0.5    ) - 3600 * cpuhours
     1                                     - 60   * cpumins
c
c      Percent of real time that job was serviced.
c
       if (wctot .le. 0.0) wctot =   max ( cputot, tiny )
       ptime    = 100.0 * cputot / wctot
c
c      Final messages to crt and log.
c
       if (iolog .gt. 0) then
         if (nwarn .eq. 0) write (iolog, 2040)
         if (nwarn .eq. 1) write (iolog, 2050)
         if (nwarn .gt. 1) write (iolog, 2060) nwarn
         write (iolog, 2070) zcspk, zcseff, zcsact
c         write (iolog, 2080) wchours, wcmins, wcsecs, cpuhours
c     1                     , cpumins, cpusecs, ptime
         write (iolog, 2080) wctot, cputot, ptime
       endif
       if (iotty .gt. 0) then
         if (nwarn .eq. 0) write (iotty, 2040)
         if (nwarn .eq. 1) write (iotty, 2050)
         if (nwarn .gt. 1) write (iotty, 2060) nwarn
         write (iotty, 2070) zcspk, zcseff, zcsact
c         write (iotty, 2080) wchours, wcmins, wcsecs, cpuhours
c     1                     , cpumins, cpusecs, ptime
         write (iotty, 2080) wctot, cputot, ptime
       endif
c
c      Close ascii files, and then AMF!
c
       if (iolog .gt. 0) then
         close ( unit=iolog )
         ilogdmp = ilogdmp + 1
         write (logfile, 2090) 'zl', ilogdmp, id
         call renam ( 'zltemp', logfile(1:6) )
       endif
       if (dttsl .gt. 0.0) close ( unit=iotsl )
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2010   format('ZEUS3D  :',/
     1       ,'ZEUS3D  : Setup complete with no warnings issued, '
     2       ,'entering main loop...',/,'ZEUS3D  :')
2020   format('ZEUS3D  :',/
     1       ,'ZEUS3D  : Setup complete with 1 warning issued, '
     2       ,'entering main loop...',/,'ZEUS3D  :')
2030   format('ZEUS3D  :',/
     1       ,'ZEUS3D  : Setup complete with ',i2,' warnings issued, '
     2       ,'entering main loop...',/,'ZEUS3D  :')
2040   format('ZEUS3D  :',/,'ZEUS3D  : Execution terminating with no '
     1       ,'warnings issued.')
2050   format('ZEUS3D  :',/,'ZEUS3D  : Execution terminating with 1 '
     1       ,'warning issued.')
2060   format('ZEUS3D  :',/,'ZEUS3D  : Execution terminating with ',i4
     1       ,' warnings issued.')
2070   format('ZEUS3D  : Peak      zone-cycles per second for this '
     1       ,'job = ',1pe12.5,/
     2       ,'ZEUS3D  : Effective zone-cycles per second for this '
     3       ,'job = ',1pe12.5,/
     4       ,'ZEUS3D  : Average   zone-cycles per second for this '
     5       ,'job = ',1pe12.5)
c2080   format('ZEUS3D  : Real time =',i3,':',i2.2,':',i2.2
c     1       ,', CPU time =',i3,':',i2.2,':',i2.2,' (',f6.2,'%)')
2080   format('ZEUS3D  : Wall clock time = ', f12.2
     1       ,', CPU time = ', f12.2, ' (',f6.2,'%)')
2090   format(a2,i2.2,a2)
c
       stop

 2100  format(2x, f10.5, 2x, f8.4, 2(2x,f10.5), 2x, f12.5)
 2110      format( 2(f10.4,2x), 4(e12.6,2x) )


       print*, " ****** Leave zeus3d.f *******"
       end

      Function erfcc(x)
      Real *8 erfcc, x
      real *8 t, z
      z = abs(x)
      t = 1. /(1. + 0.5 * z)
      erfcc = t * Dexp(-z*z - 1.26551223 + t * ( 1.00002368 + 
     *     t* (0.39409196 + t * (0.09678418 + t* (-0.18628806 + 
     *     t* (-1.13520398 + t * (1.48851587 + t * (-0.82215223 +
     *     t* 0.17087277))))))))
      if ( x .lt. 0.) erfcc = 2. - erfcc
      return
      end

       function overlap ( ishp, rad, x0, y0, z0, xin, yin, zin, xout
     1                  , yout, zout )
c
c    dac:zeus3d.overlap <--------- overlap of region over Cartesian zone
c                                                            april, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Determines the fraction of a Cartesian zone that overlaps
c  the specified geometrical region (sphere or right cylinder).  This
c  is done by dividing the zone into 20**3 "subzones", and finding the
c  fraction of subzone centres lying inside the surface of the region.
c
c  INPUT VARIABLES:
c
c    ishp            =1 => sphere
c                    =2 => right cylinder
c    rad             radius of region
c    x0,y0,z0        coordinates of centre of curvature.
c    xin,yin,zin     coordinates of zone corner known to lie inside
c                    region.
c    xout,yout,zout  coordinates of zone corner diametrically opposed to
c                    zone corner known to lie inside region.
c
c  OUTPUT VARIABLES:
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
       integer       i       , j       , k       , nx      , ny
     1             , nz      , ishp
       real*8        overlap
       real*8        rad     , x0      , y0      , z0      , xin
     1             , yin     , zin     , xout    , yout    , zout
     2             , delx    , dely    , delz    , r       , fact
     3             , scount
c
       real*8        xsq     (  20), ysq     (  20), zsq     (  20)
     1             , count   (  20)
c
c-----------------------------------------------------------------------
c
       overlap = 1.0
c
       return
       end

       subroutine displayi ( lunit, iarray, iar, jar
     1                     , ibeg, iend, jbeg, jend, clab, ctitle )
c
c    dac:zeus3d.displayi <-------- displays portion of 2-D integer array
c                                                          october, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This subroutine writes to "lunit" the specified portion of
c  the specified integer array "iarray".  The difference between "iend"
c  and "ibeg" should not be greater than 38.
c
c  INPUT VARIABLES:
c    lunit       logical unit to which display is sent
c    iarray      2-D integer array to display
c    iar,jar     dimensions of "iarray"
c    ibeg,iend   range in "i" to be displayed
c    jbeg,jend   range in "j" to be displayed
c    clab        character string to label axes
c    ctitle      character string to head data
c
c  OUTPUT VARIABLES: NONE
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       character*(*) clab    , ctitle
       integer       lunit   , iar     , jar     , ibeg    , iend
     1             , jbeg    , jend    , i       , j       , iran
     1             , i1      , i2      , imax    , iarmax  , iarmaxt
     2             , iarmin
       real*8        q1      , q2      , q3
c
       integer       ilab    (ijkn), jlab    (ijkn), idummy  (ijkn)
c
       integer       iarray  ( iar, jar)
c
cRAF       equivalence   ( ilab    , wx1d     ), ( jlab    , wy1d     )
cRAF     1             , ( idummy  , wz1d     )
c
c-----------------------------------------------------------------------
c
c      Write "ctitle" to "lunit"
c
       write (lunit, 2010) ctitle
c
c      Set limits for i-sweep
c
       iran =  min ( 38, iend - ibeg + 1 )
       i1   = ibeg
       i2   = ibeg + iran - 1
c
c      Set axis labels
c
       do 10 i=i1,i2
         ilab(i) = i
10     continue
       do 20 j=jbeg,jend
         jlab(j) = j
20     continue
c
c      Find extrema of array "iarray"
c
       iarmax =-999999
       iarmin = 999999
       do 40 j=jbeg,jend
         do 30 i=i1,i2
           iarmax =  max ( iarmax, iarray(i,j) )
           iarmin =  min ( iarmin, iarray(i,j) )
30       continue
40     continue
       if (iarmax .lt.  abs(iarmin)) iarmax = iarmin
       iarmaxt = iarmax
       if (iarmax .eq. 0.0) iarmax = 1.0
c
c      Display array "iarray" depending on "iran".
c
       if (iran .ge. 20) then
         imax = 99
         q1   = 0.499
       endif
       if ( (iran .ge. 16) .and. (iran .le. 19) ) then
         imax = 999
         q1   = 0.4999
       endif
       if ( (iran .ge. 13) .and. (iran .le. 15) ) then
         imax = 9999
         q1   = 0.49999
       endif
       if ( (iran .ge. 11) .and. (iran .le. 12) ) then
         imax = 99999
         q1   = 0.499999
       endif
       if (iran .le. 10) then
         imax = 999999
         q1   = 0.4999999
       endif
       q2 =   min ( one,  dble(imax) / abs ( dble(iarmax)) )
       do 60 j=jend,jbeg,-1
         do 50 i=i1,i2
           q3        = q2 *  real(iarray(i,j))
           idummy(i) =  int ( q3 + sign ( q1, q3 ) )
50       continue
         if (iran .ge. 26)
     1     write (lunit, 2020) jlab(j), (idummy(i),i=i1,i2)
         if ( (iran .ge. 20) .and. (iran .le. 25) )
     1     write (lunit, 2030) jlab(j), (idummy(i),i=i1,i2)
         if ( (iran .ge. 16) .and. (iran .le. 19) )
     1     write (lunit, 2040) jlab(j), (idummy(i),i=i1,i2)
         if ( (iran .ge. 13) .and. (iran .le. 15) )
     1     write (lunit, 2050) jlab(j), (idummy(i),i=i1,i2)
         if ( (iran .ge. 11) .and. (iran .le. 12) )
     1     write (lunit, 2060) jlab(j), (idummy(i),i=i1,i2)
         if (iran .le. 10)
     1     write (lunit, 2070) jlab(j), (idummy(i),i=i1,i2)
60     continue
c
c      Label horizontal axis.
c
       if (iran .ge. 26)
     1   write (lunit, 2080) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 20) .and. (iran .le. 25) )
     1   write (lunit, 2090) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 16) .and. (iran .le. 19) )
     1   write (lunit, 2100) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 13) .and. (iran .le. 15) )
     1   write (lunit, 2110) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 11) .and. (iran .le. 12) )
     1   write (lunit, 2120) clab, (ilab(i),i=i1,i2)
       if (iran .le. 10)
     1   write (lunit, 2130) clab, (ilab(i),i=i1,i2)
c
c      Indicate scale of displayed data.
c
       if (q2 .lt. 1.0) write (lunit, 2140) imax, iarmaxt
       if (q2 .eq. 1.0) write (lunit, 2150)
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2010   format('DISPLAYI:',/,'DISPLAYI: ',a)
2020   format(i3,1x,38i2)
2030   format(i3,1x,25i3)
2040   format(i3,1x,19i4)
2050   format(i3,1x,15i5)
2060   format(i3,1x,12i6)
2070   format(i3,1x,10i7)
2080   format(a3,1x,38i2)
2090   format(a3,1x,25i3)
2100   format(a3,1x,19i4)
2110   format(a3,1x,15i5)
2120   format(a3,1x,12i6)
2130   format(a3,1x,10i7)
2140   format('DISPLAYI: Data scaled so that a display of ',i6
     1       ,' corresponds to ',i12)
2150   format('DISPLAYI: Data are not scaled.')
c
       return
       end

       subroutine trapzd ( func, x1, x2, n, s )
c
c    dac:zeus3d.trapzd <-------------- n'th refinement of trapezoid rule
c    from whp:numerical recipes                           december, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This routine returns in "s" the n'th stage of refinement of
c  an extended trapezoidal rule.  "func" is input as the name of the
c  function to be integrated between limits "x1" and "x2", also input.
c  When called with n=1, the crudest estimate of the definite integral
c  is returned.  Subsequent calls with n=2,3,... (in that order) will
c  improve the accuracy of "s" by adding 2**(n-2) additional interior
c  points.  The value of "s" should not be modified between successive
c  calls (see Numerical Recipes, 1st edition for FORTRAN, page 111).
c
c  INPUT VARIABLES:
c    func     name of external function describing the univariate
c             function to be integrated.
c    x1, x2   integration limits
c    n        stage of refinement
c
c  OUTPUT VARIABLES:
c    s        value of definite integral after n'th stage of refinement.
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       n       , it      , j
       real*8        x1      , x2      , s      , tnm     , del
     1             , x       , sum
c
c      Save statements
c
       save          it
c
c      External statements
c
       real*8        func
       external      func
c
c-----------------------------------------------------------------------
c
       if (n .eq. 1) then
         s  = 0.5 * ( x2 - x1 ) * ( func(x2) + func(x1) )
         it = 1
       else
         tnm = 1.0 /  real(it)
         del = ( x2 - x1 ) * tnm
         x   = x1 + 0.5 * del
         sum = 0.0
         do 10 j=1,it
           sum = sum + func(x)
           x   = x + del
10       continue
         s  = 0.5 * ( s + ( x2 - x1 ) * sum * tnm )
         it = 2 * it
       endif
c
       return
       end

       subroutine wave_intens
c
c    dac:zeus3d.wave_intens <---------------- Calculates the wave intensity
c          (see Gordon et al. 1999) upstream of a shock for a given momentum.
c
c    Written by : Ken Rice
c
c                           Modified : 04/19/2000
c
c    Modified by:  Gang Li (Extensive changes)
c  EXTERNALS: [NONE]
c
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundaries
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)     
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
c-----------------------------------------------------------------------
c-------------- START OF PROGRAM/SUBROUTINE ----------------------------
c
c  This subroutine is all written in cgs units and is taken from 
c  Gordon et al., 1999.
c
c-----------------------------------------------------------------------
c
       integer maxshells
       real*8  max_p, p0
c
       parameter (maxshells = 200, max_p = 10.0D0, p0 = 2.0)
c
       real*8 p, psf, del_p, vel, gamma_rel, energy
       real*8 B, muo
       real*8 vo, VA, Vsw, Vsh, V, Vpr, Vd
       real*8 n, mp, rg
       real*8 Lo, k, ko        
       real*8 injectrate, intensnorm
       real*8 alpha_wave, Io
       real*8 pinj, acc_time, acc_time_hi
       real*8 c, ech, gyrof
       real*8 psi, beta
       real*8 shock_speed, Machno, comp_rat
       real*8 p_inj, p_cut, distr_array(maxshells, 250)
       real*8 esc_dens_up(250), esc_dens_down(250)
       real*8 prev_acc_time, prev_expand_time(maxshells),
     *             prev_acc_posn
c
       real*8 Iplus(250,maxshells), Ipluso(250), Ibohm(250)
       real*8 fo(250,maxshells)
       real*8 kappa(250,maxshells),kappa_hi(250,maxshells)
       real*8 kappa_perp(250,maxshells), kappa_perp_hi(250,maxshells)
       real*8 s_ratio, s(250)
       real*8 wave_comp_rat
       real*8 x, dx, xintegral(250,1000), uintegral, u, Uo
c
       integer p_int
       integer shock_begin, shock_end
       integer i, j, l, index, ik
       real *8 Amass, charge,p_hi_inj, p_hi_cut, p_hi_cut2
       real *8 p_max, p_max_hi,time_all, psf_hi
       real *8 energy_inj
       real *8 Iplustemp, Iplusotemp

       real*8   esc_shell(in, 250), R_shell_x(maxshells)
       integer  R_shell_i(maxshells), no_shells

       real*8 ipmax(maxshells),ipmin(maxshells)
                                ! ipmax(j) is the maximum proton momentum index
                                ! for the jth shell.
       real*8 ipmax_hi(maxshells),ipmin_hi(maxshells)
                                ! ipmax(j) is the maximum HvyIon momentum index
                                ! for the jth shell.
       real*8 temp_p, temp_k, temp_I ! for heavy ions.
       real*8 temp, gammag
       
       real*8 alpha_bohm
       real*8 alphaK

       real*8 shock_start_time

       integer j_p_cut_chk, j_p_cut
       integer j_p_cut_chk_hi, j_p_cut_hi

       real*8 to
       real*8 time_initslap
       integer i_perp

c----- the following is added for the function get_injection_speed(....)       
       real*8 get_injection_speed
       real*8 theta_BN, deltaB,B0,uspeed,comp,alpha_inj,s2d, 
     X      lambda_c, vinj, tempVd
       real*8 lambda_perp, lambda_par
c----- the following is added for the function get_rl(....)       
       real*8 get_rl
       real*8 tempP, temp_rl, temp_kappa_perp, temp_kappa_par, tempt

       common /wave_add/j_p_cut_chk,j_p_cut,j_p_cut_chk_hi,j_p_cut_hi

       common /shell/  esc_shell,R_shell_x,R_shell_i,no_shells
       common /shock2/ shock_begin, shock_end, shock_speed,
     *                 Machno, comp_rat
       common /ptcls/  p_inj, p_cut, distr_array, esc_dens_up,
     *                 esc_dens_down, prev_acc_time, prev_expand_time,
     *             prev_acc_posn
       common /shocktime/ shock_start_time

       common /diff_coeff/ kappa,kappa_hi
       common /heavyIon/ charge, Amass, p_hi_inj, p_hi_cut
       common /p_checker/ipmax,ipmin,ipmax_hi,ipmin_hi

       common /wave_action/ Iplus
       common /time_init/ time_initslap
       common /kappa_perp/ i_perp
       common /zeus3d_wave_intens/ alphaK, theta_BN
       real *8 shock_init_loc
c
c---------------------------------------------------------------------- 
c
       print*, "-------Entering wave_intens.f -------"
       print*, " -- time is --", time 
       print*, "*** no_shells is  ***", no_shells
c
       print*, "amass, charge", amass, charge
       muo = 4.0D0*pi*1.0D-7       
c        
       del_p = (max_p - p0)/250.0D0
c
       vo = 52483.25   ! Velocity normalization in MKS units.
       to = 2858055.0  ! time normalization in seconds.
c                        
       alpha_bohm = 2.

       gammag = 5./3.


       shock_init_loc = 0.025 ! the "real" shock initialization point.

c       alphaK = 0.001

c----- set j_p_cut_chk = j_p_cut
       j_p_cut_chk = j_p_cut
       j_p_cut_chk_hi = j_p_cut_hi

       call parker_field(B, x1a(shock_end+10), v1(shock_end+10,1,1))
c       print*, "B_parker", B
       B = Sqrt(B1(shock_end+2,1,5)**2.0+B3(shock_end+2,1,5)**2.0)
c       print*, "B", B
c
       B = B*5.38E-9                ! Unnormalized B in Tesla.
c       B0 = 5.38D-9 is the scale of magnetic field through B^2/2 ~ pressure.

       n = d(shock_end+5,1,5)*5.0D6   ! Density in m^-3.
c       n0 = 5.0D6 is the normalized number density at 0.1 AU.
       mp = 1.67D-27                ! Proton mass in kg.                   
c                        
       VA = Sqrt(B*B/(muo*mp*n)) ! Alfven speed in m/s.
c
       Lo = 0.025               ! Correlation length in AU.
       ko = 2.0*pi/(Lo*1.5D11)  ! ko in m^-1.
c     
       c = 3.0D8                ! Speed of light in m/s.
       ech = 1.6D-19            ! Electron charge in coulombs
c     
       gyrof = ech*B/mp         ! Non-relativistic Gyrofrequency in MKS.
c       print*, gyrof,'    gyrof'
c
       psi = 0.0*pi/180.0       ! Shock obliquity
c     
       Vsw = V1(shock_end+10,1,1)*vo ! Solar wind speed in m s^-1.
c     Vsw = 400000.0D0
       
       Vsh = shock_speed*vo     ! Shock speed in MKS.
c     Vsh = 540000.0D0 

       V = Vsh - Vsw            ! upstream speed in shock frame.
       If (VA*cos(psi) .LT. V) Then
          Vpr = V - VA*cos(psi) ! Scattering center speed.
       Else
          Vpr = 0.0
       End If  
       Vpr = V     
c     
       Vd = (shock_speed-v1(shock_begin-5,1,1))*vo
c     
c       print*, "Vsw, Vsh, V, VA, Vpr, Vd, x1a(shock_begin)"
c       print*, Vsw, Vsh, V, VA, Vpr, Vd, x1a(shock_begin)
c   
       wave_comp_rat = Vpr/Vd
c     
       beta = 3.0*wave_comp_rat/(wave_comp_rat - 1.0) 
c       print*, "beta, comp_rat, wave_comp_rat"

       beta = 3.0*comp_rat/(comp_rat - 1.0)
       print*, "beta, comp_rat, wave_comp_rat",
     *      beta, comp_rat, wave_comp_rat

       print*, " shock_begin , shock_end",shock_begin,shock_end
c     
       injectrate = 0.01D0*n*V  !simple approach on injection.
c                        
       alpha_wave = 1.0D0                 ! Fraction of magnetic energy density in waves.
       Io = 8. * pi * alpha_wave/(5.0*ko)*B**2.0/(2.0*muo) ! Background intensity.

       temp = 2.0/((gammag - 1.0)*Machno*Machno)  
       temp = 1.0 - 1.0/(comp_rat*comp_rat) + temp

       p_inj = 3.0*0.5*(gammag - 1.0)
       p_inj = p_inj*(shock_speed - v1(shock_end+2,1,5))**3
       p_inj = p_inj/(2.0*gammag
     *           *(shock_speed - v1(shock_end+2, 1, 5)))
c
       p_inj = Sqrt(p_inj*temp)    !  Lower boundary of injection momentum.
c
c       p_inj = 3. * (shock_speed-v1(shock_end+2,1,5))/(comp_rat -1.)
c------ for parallel case, take zeta = 3u/ (v*(s-1))  = 0.5 to decide u
       
       print*, "*** p_inj, temp, comp_rat ***", p_inj, temp, comp_rat
       print*, " ---- revised p_inj for para case ----", p_inj, comp_rat

       print*, "--- shock_speed,v1 --",shock_speed, v1(shock_end+2,1,5)
       print*, "--- v0 ---", vo
c      pause  ! GL

       p_inj = shock_speed + p_inj   

       if (i_perp .eq. 1) then  ! redecide p_inj
          
c ---------use function get_injection_speed(theta_BN,deltaB,B0,uspeed,comp,alpha, beta)
c     -------- theta_BN == the angle between shock normal and B0 in degree.
c     -------- deltaB == the turbulent field delta_B.
c     -------- B0 == ambient B.
c     -------- uspeed == flow speed.
c     -------- alpha == lambda_2D / lambda_slab 
c     -------- s2d == (b_2D/b)^2
c ---------------------------------------------------------------------------

c       theta_BN = 80.  ! the angle in degree.

          B0 =  B * 1.D4        ! in Gauss
          print*, "x1a(shock_end+10)", x1a(shock_end+10)
          deltaB = 13.6**(0.5) * 1.D-5 * (x1a(shock_end+10)/1.)**(-3/2.) ! in gauss
          uspeed = (shock_speed - v1(shock_end+10, 1,1)) *vo/1000. ! upstream flow speed in shock frame in km/s
          tempVd = (shock_speed-v1(shock_begin-5,1,1))*vo/1000. ! dnstream flow speed in shock frame in km/s.
          comp = uspeed/tempVd  ! compression ratio.
          alpha_inj = 0.1       ! lambda_2D / lambda_slab 
          s2d = 0.8
          lambda_c = Lo * 1.5 D8 ! correlation length in km (assuming not change with distance).
          
          vinj = get_injection_speed(theta_BN,deltaB,B0,uspeed,
     X         comp,alpha_inj, s2d, lambda_c, lambda_perp, lambda_par) ! in km/s
          
          p_inj = vinj * 1000. / vo ! normalized p_inj (vo is in m/s)
          
          print*, "********** p_inj for perp case **********", p_inj
       endif

c     pause
       
       pinj = p_inj*mp*vo       ! un-normalized pinj
c     
       intensnorm = 8.0*gyrof*Vpr**2.0*mp/pinj
       intensnorm = intensnorm/(VA*pinj*beta*injectrate*cos(psi))
       intensnorm = intensnorm*mp/pinj
c
       If (intensnorm .LE. 0.0) Then
          intensnorm = 1.0E30   ! Make intensnorm very large - no wave growth.
       End If  
c     
c       write(43,*) "time is", time
c       write(44,*) "time is", time, x1a(shock_begin)

c       print*, time
       
c---- decide kappa perp.
       Do i = 1, 250
          p = p0 + del_p * (i-1)
          psf = Exp(p)*mp*vo    ! momentum in MKS.
          vel = psf/mp*(1/Sqrt(1.0 + (psf/(mp*c))**2.0)) 
          
          kappa_perp(i,no_shells) = (R_shell_x(no_shells)/1.0)**(2/3.) 
     *         * 1/3. * alphaK * ( psf/(mp*c)*0.938)**(1/3.) 
     *         * 0.4 * 1.5D11 * vel
c     print*, "R_shell_x(no_shells),vel",R_shell_x(no_shells), vel
c     print*, "i, kappa_perp",i, kappa_perp(i, no_shells)
          
c     print*,"---lambda_perp, lambda_par---", lambda_perp, lambda_par
          
          
          IF ( i_perp .eq. 1) then 
             
             tempP = psf/(mp*c) * 938. ! momentum in MeV/c.
             temp_rl = get_rl(B0,tempP, lambda_c,alpha_inj,s2d,deltaB,
     X            temp_kappa_perp, temp_kappa_par, tempt)
             
             print*,"--temp_rl,temp_kappa_perp,temp_kappa_par--"

             print*, temp_rl, temp_kappa_perp, temp_kappa_par

             print*, "---- i, kappa_perp(i,no_shells), t",
     X            i, kappa_perp(i,no_shells), tempt
             
             kappa_perp(i,no_shells) = temp_kappa_perp  * 
     X            sin(theta_BN/90. * 3.14/2.)**2/ 5.  !  devide by 5 to agree with the 
c lambda = 0.4 AU * P^(1/3)*r^(2/3) assumption made in Li 2003 and 2005.
          ENDIF 
      enddo
      
c     pause
      
      Do i = 1, 250
         p = p0 + del_p * (i-1)
         psf = Exp(p)*mp*vo     ! momentum in MKS.
c     
         vel = psf/mp*(1/Sqrt(1.0 + (psf/(mp*c))**2.0)) ! in real unit.
         gamma_rel = 1.0/Sqrt(1.0 - vel**2.0/c**2.0)  
c     
         k = mp*gyrof/(psf)     ! the wave vector whose resonance p is psf.
                                ! k is the same for rel. or non-rel. case.
         
c         rg = gamma_rel*vel/gyrof ! Need gamma_rel since gyrof is Non-relativistic.	     
         rg =  1./ k
c     
         energy = Sqrt((mp*c**2.0)**2.0+(mp*Exp(p)*vo*c)**2.0)- !kinetic energy
     *        mp*c**2.0
         energy = energy/1.6E-19 ! in eV.
         
c     print*, "gamma_rel", gamma_rel, psf * 3.*1.D8/1.6D-13, i
                                !     psf is in (MeV).
c------- The weakest Iplus can NOT be smaller than  B^2/(2 \mu_0 k)
         If (k .LT. ko) Then
            Ipluso(i) = Io      ! Energy containing range.
         Else
            Ipluso(i) = Io*(k/ko)**(-5.0/3.0)
         End If          
         
c----------The strongest Iplus can NOT exceed 24 pi/32 * B^2/(2 \mu_0 k)
         Ibohm(i) = alpha_bohm * 24.* pi/32.*(B**2.0/(muo*2.0*k)) ! The Bohm approximation
         
         Ibohm(i) = Ibohm(i) /2. ! &&&&&&& ----- special treatment
         
         s(i) = k/(mp*gyrof/pinj) ! ratio of k to the K>, K> corresponds to pinj
         s_ratio = k/(mp*gyrof/pinj)
c     print*, "--- s(i) ---", s(i)
         
         If (s_ratio .GE. 1.0) Then
            Iplus(i,no_shells) = pi*beta*gyrof*injectrate*VA*
     *           cos(psi)*pinj/(Vpr**2 * k**2) *
     *           (1.0/(beta-4.0)-(psf/pinj)**2.0/(beta-2.0))
     *           + Ipluso(i)
c     print*, " --------- YOU SHOULD NOT SEE THIS ------------"
c     print*, "--- i,k > mp*Omega/pinj--",  i,k, mp*gyrof/pinj
         ELSE                   !  So, s(i) .LT. 1.0
            Iplus(i,no_shells)= 2*pi*beta*gyrof*injectrate*VA*cos(psi)*
     *           psf*(psf/pinj)**(3.0-beta)/( (beta-4.)*(beta-2.) )
     *           /(Vpr**2 * k**2) +  Ipluso(i)
            fo(i,no_shells) = (psf/pinj)**(-1.0*beta)
         ENDIF
         Iplus(i,no_shells) = Iplus(i,no_shells) / 2.0 ! &&&&&&& ----- special treatment
         
c          print*," i,Iplus(i,no_shells),Ibohm", 
c     *         i,Iplus(i,no_shells),Ibohm(i)

c          print*," k, ko", k, ko

          If (Iplus(i,no_shells)/(Ibohm(i)+Ipluso(i)).GT. 1.0) Then
c             print*," i,Iplus(i,no_shells),Ibohm", 
c     *            i,Iplus(i,no_shells),Ibohm(i)
             Iplus(i,no_shells) = Ibohm(i)+Ipluso(i)
          End If
          
          kappa(i,no_shells) = psf**2.0*vel/
     *         (ech**2.0*2.0*muo*Iplus(i,no_shells))
       End Do

c-------Need to decide the maximum momentum carefully.

       time_all = x1a(shock_end+5) *1.5D11 / (shock_speed*vo)       
       print*, " ---time_all is--", time_all

       print*, "no of shells", no_shells

       if (no_shells .eq. 1) then
          time_initslap =  ( x1a(is) - shock_init_loc)  ! 0.025 ==> 4 solar radii 
     *      *1.5D11 / (shock_speed*vo)
       endif

       time_all = (x1a(shock_end+5) - x1a(is) ) 
     *      *1.5D11 /(shock_speed*vo)  + time_initslap

       print*, " time_all is", time_all

       time_all = (time - shock_start_time) * to + time_initslap

       print*, " time_all is", time_all

       acc_time = 0.
       
       print*, "-------time all is ********", time_all

c       pause

       p_max = 0.
       
c       psf = Exp(p)*mp*vo       ! momentum.

       if (i_perp .ne. 1) then
          goto 16
       endif

       DO i = 1, 250
          p = p0 + (i-1)*del_p   
          
          if ( Exp(p) .ge. p_inj) then
             acc_time = acc_time+2.* beta/Vpr**2.0*
     *            kappa_perp(i,no_shells)* del_p ! See Drury's paper for the factor 2.
c     *            (exp(p+del_p/2.0D0)-exp(p-del_p/2.0D0))/exp(p)
c             print*, "i,p, acc_time,time_all", i,p, acc_time, time_all
c             print*, "beta,kappa(i,1),Vpr", beta,kappa(i,1), Vpr

             if ( (acc_time .gt. time_all) .and. (p_max .eq. 0.)) then
                p_max = Exp(p)
c                print*, "p_max, p_cut",p_max,p_cut
                p_cut = p_max
                j_p_cut = i
                goto 16
             endif
c             print*, "acc_time", acc_time
          endif
          
       ENDDO


 16    CONTINUE
        print*, "p_cut",p_cut
c        pause


       IF ( i_perp .eq. 1) then 
          goto 17
       ENDIF

       DO i = 1, 250
          p = p0 + (i-1)*del_p   
          
          if ( Exp(p) .ge. p_inj) then
             acc_time = acc_time+2.* beta/Vpr**2.0*kappa(i,no_shells)*  ! See Drury's paper for the factor 2.
     *            del_p
c     *            (exp(p+del_p/2.0D0)-exp(p-del_p/2.0D0))/exp(p)
             print*, "i,p, acc_time,time_all", i,p, acc_time, time_all
c             print*, "beta,kappa(i,1),Vpr", beta,kappa(i,1), Vpr

             if ( (acc_time .gt. time_all) .and. (p_max .eq. 0.)) then
                p_max = Exp(p)
c                print*, "p_max, p_cut",p_max,p_cut
                p_cut = p_max
                j_p_cut = i
                goto 15
             endif
c             print*, "acc_time", acc_time
          endif
          
       ENDDO
       
 15    continue
c       pause
c-------Since no spectra transfer involves, Reset Iplus(i,1) to Iplus0(i)
c-------when p<p_inj or p>p_cut.
c-------Reset the kappa(i,1) after reset Iplus(i,1)

       DO i = 1, 250
          p = p0 + (i-1)*del_p   
          psf = Exp(p)*mp*vo    ! momentum.
          vel = psf/mp*(1/Sqrt(1.0 + (psf/(mp*c))**2.0)) ! in real unit.          
          
          If ((Exp(p) .LT. p_inj) .OR. (Exp(p) .GT. p_cut)) Then
             Iplus(i,no_shells) = Ipluso(i)
          ENDIF
          
          kappa(i,no_shells) = psf**2.0*vel/
     *         (ech**2.0*2.0*muo*Iplus(i,no_shells))
       ENDDO

 17    continue

c-------Since Iplus is known for all $k$ now, we next 
c-------find out kappa_hi(i,no_shells). Note, the resonant index j for 
c-------kappa_hi(i,no_shells) is given by (Amass/charge) * p_proton. 
c-------Also note there is a (A/Q)**2 dependence of kappa for heavy Ions.
       
       energy_inj =  Sqrt((mp*c**2.0)**2.0+(mp*vo*p_inj*c)**2.0)- !kinetic energy
     *      mp*c**2.0
       energy_inj = energy_inj/1.6E-19 ! in eV.
       
       print*, "The injection energy in eV is", energy_inj
c       pause !GL 

       DO i = 1, 250
          p = p0 + (i-1) *del_p
          psf = Exp(p)*mp*vo    ! momentum per nucleon.
          vel = psf/mp*(1/Sqrt(1.0 + (psf/(mp*c))**2.0)) ! in real unit.          
          
          energy = Sqrt((mp*c**2.0)**2.0+(psf*c)**2.0)- !kinetic energy
     *         mp*c**2.0
          energy = energy/1.6E-19 ! in eV.
          
          psf_hi = Exp(p) * (Amass/charge) ! psf_hi is the resonant proton momentum for heavy ions.          
          k = mp*gyrof /psf_hi

c     print*, "psf_hi,  p", psf_hi, Exp(p)
c     print*, "(Amass/charge), Log",(Amass/charge),
c     *         DLog(Amass/charge)

          index = i + INT(( DLog(psf_hi)-p)/del_p + 0.5)
          
          if (index .ge. 250) then  ! the corresponding turbulence must be due to solar wind.
             temp_p = Exp(p0 + index*del_p) * mp * vo 
             temp_k = (charge/Amass)*(ech * B)/ temp_p 
             temp_k = mp*gyrof /temp_p

             if ( temp_k .lt. ko) then
                temp_I = Io
             else 
                temp_I = Io*(temp_k/ko)**(-5.0/3.0)
             endif
             kappa_hi(i,no_shells) = psf**2.0*vel/
     *            (ech**2.0*2.0*muo*temp_I) * (Amass/charge)**2.
c---- ( debug
c             print*, "i,index,kappa_hi(i,no_shells)",
c     *            i,index,kappa_hi(i,no_shells)
c---- ) debug

          else
             kappa_hi(i,no_shells) = psf**2.0*vel/
     *            (ech**2.0*2.0*muo*Iplus(index,no_shells))          
     *            * (Amass/charge)**2.
          endif
       ENDDO

c-----Now decide the maximum heavy ion momentum.
       
       p_hi_cut2 =  p_cut * (charge/Amass)
       p_max_hi = 0.
       acc_time_hi = 0.
       
       p_hi_inj = p_inj


       DO i = 1, 250
          p = p0 + (i-1)* del_p   
          
c     print*,"kappa(i,1),kappa_hi(i,1),i",kappa(i,1),kappa_hi(i,1),i
          if ( Exp(p) .ge. p_inj) then 
             acc_time_hi = acc_time_hi + beta/Vpr**2.0*kappa_hi(i,
     *            no_shells)*
     *            (exp(p+del_p/2.0D0)-exp(p-del_p/2.0D0))/exp(p)
             
             if ( (acc_time_hi .gt. time_all) 
     *            .and. (p_max_hi .eq. 0.)) then
                p_max_hi = Exp(p-del_p)
                p_hi_cut = p_max_hi
                goto 20
             endif
          endif
       ENDDO
       
 20    CONTINUE

c----( debug
c       print*, "i,acc_time_hi,time_all", i,acc_time_hi, time_all
c       print*, "p_hi_cut, p_hi_cut2", p_hi_cut, p_hi_cut2
c----) debug


       print*, "The proton injection and maximum momentum (in mp*c)", 
     *      p_inj * vo/c, p_cut*vo/c
       print*, "The hvyIon injection and maximum momentum (in mp*c)", 
     *      p_hi_inj*vo/c, p_hi_cut*vo/c
       print*, "*** p_hi_cut, p_hi_cut2 ***", p_hi_cut, p_hi_cut2

       write(90,*) "***********************************"
       write(90,*) "*** no_shells is ***", no_shells
       write(90,*) "*** p_hi_cut, p_hi_cut2 ***", p_hi_cut, p_hi_cut2
       write(90,*) "*** Normal case: p_hi_cut2 <p_hi_cut ***"
       write(90,*) "***********************************"
       if ( p_hi_cut2 .lt. p_hi_cut) then
          p_hi_cut = p_hi_cut2
       endif

       j_p_cut_hi = INT (0.5+(Dlog(p_hi_cut) - p0) / del_p) + 1

c       print*, " j_p_cut_hi", j_p_cut_hi
c       print*, " j_p_cut", j_p_cut
c       print*, "(Dlog(p_cut) - p0) / del_p ",(Dlog(p_cut) - p0) / del_p 
       j_p_cut = INT ( 0.5+(Dlog(p_cut) - p0) / del_p) + 1
c       print*, " j_p_cut", j_p_cut

c       pause

       write(90,*) "*** p_hi_cut2 > p_hi_cut1 ***"

       energy = Sqrt((mp*c**2.0)**2.0+(mp*p_cut*vo*c)**2.0)- !kinetic energy
     *      mp*c**2.0
       energy = energy/1.6E-19  ! in eV.
       
       print*, "p_inj,p_cut, energy_cut",p_inj,p_cut, energy
       
c       pause

c---- write out data at the shock location.

       DO i = 1, 250
          p = p0 + (i-1)* del_p   
          psf = Exp(p)*mp*vo    ! momentum.
          k = mp*gyrof/psf
c          
          vel = psf/mp*(1/Sqrt(1.0 + (psf/(mp*c))**2.0)) ! in real unit.
          gamma_rel = 1.0/Sqrt(1.0 - vel**2.0/c**2.0)  
          rg = gamma_rel*vel/gyrof 

          energy = Sqrt((mp*c**2.0)**2.0+(mp*Exp(p)*vo*c)**2.0)- !kinetic energy
     *         mp*c**2.0
          energy = energy/1.6E-19 ! in eV.
          If (s(i) .NE. 0.0) Then
             Write(43,111) k*Vsw/2.0/pi, energy,
     *            2.0E18*Ipluso(i)*2.0*pi/Vsw, 
     *            2.0e18*Iplus(i,no_shells)*2.0*pi/Vsw, 
     *            2.0E18*Ibohm(i)*2.0*pi/Vsw
             Write(44,112) k*Vsw/2.0/pi,energy, kappa_perp(i,no_shells), 
c     *            kappa_hi(i,no_shells),4.*pi/3.*rg*vel/alpha_bohm,
     *            kappa(i,no_shells),
     *            4.*pi/3.*rg*vel/alpha_bohm,x1a(shock_begin)
          Else
             Write(43,111) 0.0, 0.0, 0.0, 0.0, 0.0
             Write(44,112) 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
          End If
       ENDDO

       ipmin(no_shells) = INT(( DLog(p_inj)- 2.0)/del_p ) + 2
       ipmax(no_shells) = INT(( DLog(p_cut)- 2.0)/del_p ) + 1
       ipmin_hi(no_shells) = INT(( DLog(p_hi_inj)- 2.0)/del_p ) +2
       ipmax_hi(no_shells) = INT(( DLog(p_hi_cut)- 2.0)/del_p ) +1
       
        print*, " ipmin, ipmax ", ipmin(no_shells), ipmax(no_shells)
       print*, " ipmin_hi, ipmax_hi ", 
     *      ipmin_hi(no_shells), ipmax_hi(no_shells)

       Do j = ipmax(no_shells) - 10, ipmax(no_shells) + 10
          
          print*, " j, kappa(ipmax(j,no_shells )", 
     *         j,kappa(j, no_shells )
       Enddo

c       pause

c----( debug       
c       do j = ipmin(no_shells) - 1, ipmax(no_shells) + 1
c          print*, " j,kappa(j,no_shells) ", j,kappa(j,no_shells)
c       enddo
c       do  j = ipmin_hi(no_shells) -1 , ipmax_hi(no_shells) +2
c          print*, "j, kappa_hi(j,no_shells) ", j,kappa_hi(j,no_shells)
c       enddo
c----) debug       

c--------- Reset kappa(j,no_shells) to happa_perp(i,no_shells) for later diffusion.
c--------- Gang Li, Sep. 19th, 2005.
c--------- Need to do the same for heavy ions. (need Q/A dependence).

       if (i_perp .eq. 1) then 
          Do i = 1, 250
             kappa(i,no_shells) = kappa_perp(i,no_shells)
          Enddo
       endif

       print*, " -- time is --", time 

c---- Increase the 

       print*, "---***--- Inc. the turb. power acr. the shock ---**---"
       Do j = 1, 250
          Iplus(j,no_shells) =   Iplus(j,no_shells) * (comp_rat**2)
          kappa(j, no_shells) =  kappa(j, no_shells)/ (comp_rat**2)
          kappa_hi(j,no_shells)= kappa_hi(j,no_shells)/(comp_rat**2)
       ENDDO


       print*, "******* Leaving wave_intens.f *******"
       print*, "---comp_rat ----", comp_rat
c       pause
       print*, "                                       "
       return
       
 111   format (5 (2x,E9.4) )
 112   format (6 (2x,E9.4) )

       end

      Function get_injection_speed(theta,deltaB,B0,u,comp,
     X     alpha, s,lambda_c, lambda_perp, lambda_par)      

      real*8 get_injection_speed
c ---------------------------------------------------------------------------
c----        by Gang Li
c----        Sep., 13th, 2005.
c----        This code returns the injection speed for perp. shock case.
c----        See Zank et al. 2004.
c -------------------   Input    -----------------------------------------
c     -------- theta_BN == the angle between shock normal and B0 in degree.
c     -------- deltaB == the turbulent field delta_B.
c     -------- B0 == ambient B.
c     -------- u == flow speed.
c     -------- alpha == lambda_2D / lambda_slab 
c     -------- s == (b_2D/b)^2
c -------------------   Output  ------------------------------------------
c     -------- injection momentum p_inj  (in MeV/c ?)
c----   Code description.
c----
c----   y = lambda_{xx} / r_l
c----   x = rl/lambda_c
c----   rl/lambda_c. 

      integer j
      
      real*8 theta,deltaB, B0,comp, u,alpha,s,lambda_c
      real*8 v_inj              ! the return value of momentum in SGI unit.
      
      real*8  beta, phi
      real*8  oneAU
      
      real*8  lambda_par, lambda_perp
      real*8  kesi, kesi1, kesi2, kesi_pre
      real*8  t,rl,x, sg, q, A, D, z,y,v
      real*8  ratio, factor, solution

c ----- need the following input

      oneAU = 1.5D8             ! 1AU =1.5E8 km      
      phi =  theta/90. * (3.14/2.) ! theta in radian.
      beta = (deltaB/B0)**2 ! beta is the ratio of deltaB/B0

      kesi_pre = 10.            ! initialize solution for kesi


c      alpha = 0.05               ! = lambda_2d/lambda_SLAB
c      beta = 1.                 ! = b^2/B^2_0
c      s = 0.8                   ! = b^2_2d/b^2

c      oneAU = 1.5E8             ! 1AU =1.5E8 km
c      u  = 400.  ! flow speed 400 km/s
c      comp_ratio = 4. ! compression ratio 

c      print*, " alpha, beta, s, u, comp"
c      print*, alpha, beta, s, u, comp
c      print*, "B0,deltaB, lambda_c", B0,deltaB,lambda_c

c ----- need the following input

c      B0 = 4.12E-5  ! magnetic field at 1 AU
c      lambda_c = 0.03 * 1.5 E8 ! correlation length at 1 AU in km.

      do j = 0, 1300  
         
         t =  1D-4 * exp(j* 0.01) ! t is the kinetic energy in MeV
         rl = 31. /B0 * (2.13E-3 * t * (1+t/(2.*938.) ) )**0.5 ! Larmor radius in km.
         
         x = rl /lambda_c       ! normalized rl
         
         sg = 0.7468 * x
         q = 5. /3. * sg**2 / (1+ sg**2 -(1+sg**2)**(1/6.))
         A = (1+sg**2)**(5/6.) - 1.
         D = 7./9. * A / ( (q + 1./3.) * (q + 7./3.)  )
         
         z = 2.343 /( (1-s) * beta ) * x**(1/3.) * (1+D)
         
         if( z/1.732 .lt. 1.) then
            factor = 4.33 * z/1.732
         else
            factor = 3.09
         endif
         
         y = 0.36 * (s * alpha * beta)**(2/3.)*z**(1/3.)*(1.339/x)
     X        *(1+ 0.1102*(1-s) *beta**(1/3.) / (alpha *s)**(2/3.)
     X        /(z**(1/3.))* factor ) 
         
         lambda_perp = y        ! lambda_perp / rl
         lambda_par =  z * (1.339/x) ! lambda_par / rl
         
         ratio = lambda_perp / lambda_par
         
c     --now calculate kesi.
         
         v = ((t/938.) * ( 2+ t/938.))**0.5/(1+t/938.)
     X        * 3.E5            ! particle speed in km/s
         
c         write (30,*) t, rl/OneAU,lambda_perp*rl/OneAU,
c     X        lambda_par*rl/OneAU, D            
         
         kesi  = 3 * u /v  *( 
     X        1 / (comp_ratio-1)**2 + 
     X        (1+ ((lambda_par - lambda_perp)*cos(phi))**2)
     X        *sin(phi)**2 
     X        / ( lambda_perp*sin(phi)**2 
     X        + lambda_par*cos(phi)**2 )**2 )**0.5 
         
         if ( (kesi_pre .gt. 1.) .and. (kesi .le. 1.)) then
            solution = t
            kesi1 = kesi_pre
            kesi2 = kesi
            goto 10
         endif
         kesi_pre = kesi
      enddo
         
 10   print*, "***solution***",solution, kesi1, kesi2

      v_inj = ((solution / 938.) * (2 + solution / 938.))**0.5/
     X     (1 + solution / 938.) ! injection speed in unit of c.
      
      get_injection_speed = v_inj * 3.D5 ! injection speed in unit of km/s.
      lambda_perp = lambda_perp * rl ! lambda_perp in km.
      lambda_par =  lambda_par * rl ! lambda_par in km.

      return 
      
      end
      

      Function get_rl(B0,tempP, lambda_c, alpha, s, deltaB,
     X     temp_kappa_perp, temp_kappa_par, tempt) 

c---- B0  == magnatic field in gauss. 
c---- tempP ==  momentum in MeV/c.
c---- lambda_c == correlation length in km.
c---- alpha == lambda_2d/lambda_SLAB
c---- s == b^2_2d/b^2
c---- deltaB == turbulent magnetic field in gauss.
      
      real*8 tempP, tempt
      real*8 get_rl, rl, temp_kappa_perp, temp_kappa_par
      real*8 deltaB, B0,alpha,s,lambda_c, beta
      real*8 t, x, sg, q, A, D, z, y, v
      

      beta = (deltaB/B0)**2 ! beta is the ratio of deltaB/B0
      t = (tempP**2 + 938**2)**0.5 - 938.  ! particle energy in MeV.
      v = ((t/ 938.) * (2 + t / 938.))**0.5/
     X     (1 + t / 938.) * 3.D5 ! particle speed in km/s.
      
      rl = 31. /B0 * (2.13E-3 * t * (1+t/(2.*938.) ) )**0.5 ! Larmor radius in km.
      
      x = rl /lambda_c          ! normalized rl
      
      sg = 0.7468 * x
      q = 5. /3. * sg**2 / (1+ sg**2 -(1+sg**2)**(1/6.))
      A = (1+sg**2)**(5/6.) - 1.
      D = 7./9. * A / ( (q + 1./3.) * (q + 7./3.)  )
      
      z = 2.343 /( (1-s) * beta ) * x**(1/3.) * (1+D)
      
      if( z/1.732 .lt. 1.) then
         factor = 4.33 * z/1.732
      else
         factor = 3.09
      endif
      
      y = 0.36 * (s * alpha * beta)**(2/3.)*z**(1/3.)*(1.339/x)
     X     *(1+ 0.1102*(1-s) *beta**(1/3.) / (alpha *s)**(2/3.)
     X     /(z**(1/3.))* factor ) 

c      print*, " ----y,z, v-----", y,z, v
      

      get_rl = rl
      temp_kappa_perp = y * rl * v / 3. * 1.D6 ! kappa_perp in m^2/s
      temp_kappa_par =  z * (1.339/x)  * rl * v /3. * 1.D6 ! kapa_par in m^2/s
      temp_t = t

      return 
      end

      subroutine time_distr(obs_time)
c
c    abcd:zeus3d.time_distr <--- Gives the distribution functions
c           in all shells at a particular time.
c
c                                                        DATE 15/01/02
c
c    written by: Ken Rice
c    modified 1:
c
c  PURPOSE:
c
c
c  LOCAL VARIABLES:
c
c  EXTERNALS:
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundaries
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)     
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c

       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
c
c-----------------------------------------------------------------------
c-------------- START OF PROGRAM/SUBROUTINE ----------------------------
c-----------------------------------------------------------------------
c
       integer   maxshells, p_number
       real*8    max_p, mp,vo, p0 
c
       parameter (maxshells = 200, max_p = 11.0D0, p_number = 250, 
     *      p0 = 2.0, vo = 52483.25D0, mp = 1.67D-27) 
      

       real*8      R_shell_x(maxshells), obs_time, kappa
       real*8      del_p, p, shell_vol, shell_posn
       real*8      vel, Energy              
       real*8      shock_speed, Machno, comp_rat
       real*8      prev_shock_posn, prev_shock_time 
       real*8      p_inj, p_cut, distr_array(maxshells, p_number)   
       real*8      esc_dens_up(p_number), esc_dens_down(p_number),
     *             prev_acc_time, prev_expand_time(maxshells),
     *             prev_acc_posn
       real*8      esc_shell(in, p_number)  
       integer     shock_begin, shock_end
       integer     i , j , k, R_shell_i(maxshells), no_shells
       integer     p_int
       common /shell/  esc_shell,R_shell_x,R_shell_i,no_shells
       common /shock1/ prev_shock_posn, prev_shock_time
       common /shock2/ shock_begin, shock_end, shock_speed,
     *                 Machno, comp_rat 
       common /ptcls/  p_inj, p_cut, distr_array, esc_dens_up,
     *                 esc_dens_down, prev_acc_time, prev_expand_time,
     *             prev_acc_posn
c       
c-----------------------------------------------------------------------
c                         
       del_p = (max_p - 2.0)/(p_number*1.)
c                                                  
       If ((time .GE. obs_time) .AND. 
     *         (time .LT. (obs_time + 175.0*dt))) Then
c
         Do i = 1, no_shells
c
           p = 2.0
c
           shell_vol = 4.0D0*pi*(R_shell_x(i+1)**3.0D0 - 
     *                           R_shell_x(i)**3.0D0)/3.0D0
           shell_posn = (R_shell_x(i+1) + R_shell_x(i))/2.0
c                        
           Do j = 1, p_number
c
             p_int = ((p - 2.0)/del_p + 0.5) + 1  
c
             vel = Exp(p)*52483.25/Sqrt(1.0 + Exp(p)*Exp(p)*
     *          52483.25*52483.25/(3.0E8*3.0E8))
c
             Energy = 1.0/Sqrt(1.0 - vel*vel/(3.0E8*3.0E8))
             Energy = Energy - 1.0
             Energy = 1.67E-27*3.0E8*3.0E8*Energy/1.6E-19
c
             Write(37, *) Exp(p), vel, Energy, 
     *            Distr_array(i,j)/shell_vol, time, i
c
             p = p + del_p 
c
           End Do
c        
         End Do                  
c
       End If         
c                                           
       return
       end

       subroutine displayr ( lunit, array, iar, jar
     1                     , ibeg, iend, jbeg, jend, clab, ctitle )
c
c    dac:zeus3d.displayr <----------- displays portion of 2-D real array
c                                                          october, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This subroutine writes to "lunit" the specified portion of
c  the specified real array "array".  The difference between "iend" and
c  "ibeg" should not be greater than 38.
c
c  INPUT VARIABLES:
c    lunit       logical unit to which display is sent
c    array       2-D real array to display
c    iar,jar     dimensions of "array"
c    ibeg,iend   range in "i" to be displayed
c    jbeg,jend   range in "j" to be displayed
c    clab        character string to label axes
c    ctitle      character string to head data
c
c  OUTPUT VARIABLES: NONE
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       character*(*) clab    , ctitle
       integer       lunit   , iar     , jar     , ibeg    , iend
     1             , jbeg    , jend    , i       , j       , iran
     1             , i1      , i2      , imax
       real*8        armax   , armaxt  , armin   , q1      , q2
     1             , qmax
c
       integer       ilab    (ijkn), jlab    (ijkn), dummy   (ijkn)
c
       real*8        array   ( iar, jar)
c
cRAF       equivalence   ( ilab    , wx1d     ), ( jlab    , wy1d     )
cRAF     1             , ( dummy   , wz1d     )
c
c-----------------------------------------------------------------------
c
c      Write "ctitle" to "lunit"
c
       write (lunit, 2010) ctitle
c
c      Set limits for i-sweep
c
       iran =  min ( 38, iend - ibeg + 1 )
       i1   = ibeg
       i2   = ibeg + iran - 1
c
c      Set axis labels
c
       do 10 i=i1,i2
         ilab(i) = i
10     continue
       do 20 j=jbeg,jend
         jlab(j) = j
20     continue
c
c      Find extrema of array "array"
c
       armin = huge
       armax =-armin
       do 40 j=jbeg,jend
         do 30 i=i1,i2
           armax =   max ( armax, array(i,j) )
           armin =   min ( armin, array(i,j) )
30       continue
40     continue
       if (armax .lt. abs(armin)) armax = armin
       armaxt = armax
       if (armax .eq. 0.0) armax = 1.0
c
c      Display array "array" depending on "iran".
c
       if (iran .ge. 20) then
         qmax = 99.0
         q1   = 0.499
       endif
       if ( (iran .ge. 16) .and. (iran .le. 19) ) then
         qmax = 999.0
         q1   = 0.4999
       endif
       if ( (iran .ge. 13) .and. (iran .le. 15) ) then
         qmax = 9999.0
         q1   = 0.49999
       endif
       if ( (iran .ge. 11) .and. (iran .le. 12) ) then
         qmax = 99999.0
         q1   = 0.499999
       endif
       if ( (iran .ge.  9) .and. (iran .le. 10) ) then
         qmax = 999999.0
         q1   = 0.4999999
       endif
       do 60 j=jend,jbeg,-1
         if (iran .ge. 9) then
           do 50 i=i1,i2
             q2       = qmax * array(i,j) / armax
             dummy(i) =  int ( q2 + sign ( q1, q2 ) )
50         continue
           if (iran .ge. 26)
     1       write (lunit, 2020) jlab(j), (dummy(i),i=i1,i2)
           if ( (iran .ge. 20) .and. (iran .le. 25) )
     1       write (lunit, 2030) jlab(j), (dummy(i),i=i1,i2)
           if ( (iran .ge. 16) .and. (iran .le. 19) )
     1       write (lunit, 2040) jlab(j), (dummy(i),i=i1,i2)
           if ( (iran .ge. 13) .and. (iran .le. 15) )
     1       write (lunit, 2050) jlab(j), (dummy(i),i=i1,i2)
           if ( (iran .ge. 11) .and. (iran .le. 12) )
     1       write (lunit, 2060) jlab(j), (dummy(i),i=i1,i2)
           if ( (iran .ge.  9) .and. (iran .le. 10) )
     1       write (lunit, 2070) jlab(j), (dummy(i),i=i1,i2)
         endif
         if (iran .eq. 8)
     1     write (lunit, 2080) jlab(j), (array(i,j),i=i1,i2)
         if (iran .le. 7)
     1     write (lunit, 2090) jlab(j), (array(i,j),i=i1,i2)
60     continue
c
c      Label horizontal axis
c
       if (iran .ge. 26)
     1   write (lunit, 2100) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 20) .and. (iran .le. 25) )
     1   write (lunit, 2110) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 16) .and. (iran .le. 19) )
     1   write (lunit, 2120) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 13) .and. (iran .le. 15) )
     1   write (lunit, 2130) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge. 11) .and. (iran .le. 12) )
     1   write (lunit, 2140) clab, (ilab(i),i=i1,i2)
       if ( (iran .ge.  9) .and. (iran .le. 10) )
     1   write (lunit, 2150) clab, (ilab(i),i=i1,i2)
       if (iran .eq. 8)
     1   write (lunit, 2160) clab, (ilab(i),i=i1,i2)
       if (iran .le. 7)
     1   write (lunit, 2170) clab, (ilab(i),i=i1,i2)
c
c      Indicate scale of displayed data.
c
       imax =  int ( qmax + 0.1 )
       if (iran .ge. 9) write (lunit, 2180) imax, armaxt
       if (iran .lt. 9) write (lunit, 2190)
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2010   format('DISPLAYR:',/,'DISPLAYR: ',a)
2020   format(i3,1x,38i2)
2030   format(i3,1x,25i3)
2040   format(i3,1x,19i4)
2050   format(i3,1x,15i5)
2060   format(i3,1x,12i6)
2070   format(i3,1x,10i7)
2080   format(i3,1x,1p8g9.2)
2090   format(i3,1x,1p7g10.3)
2100   format(a3,1x,38i2)
2110   format(a3,1x,25i3)
2120   format(a3,1x,19i4)
2130   format(a3,1x,15i5)
2140   format(a3,1x,12i6)
2150   format(a3,1x,10i7)
2160   format(a3,1x,8i9)
2170   format(a3,1x,7i10)
2180   format('DISPLAYR: Data scaled so that a display of ',i6
     1       ,' corresponds to ',1pg12.5)
2190   format('DISPLAYR: Data are not scaled.')
c
       return
       end

       subroutine padr3d ( arr, idim, jdim, kdim, ndim, imin, imax
     1                   , jmin, jmax, kmin, kmax )
c
c    dac:zeus3d.padr3d <---------------------------- pads real 3-D array
c                                                              may, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE: Pads input real 3-D array "arr" with edge values.
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       idim    , jdim    , kdim    , ndim    , imin
     1             , imax    , jmin    , jmax    , kmin    , kmax
     2             , i       , j       , k       , n
c
       real*8        arr     (idim,jdim,kdim,ndim)
c
c-----------------------------------------------------------------------
c
       do 190 n=1,ndim
         do 30 i=1,imin-1
           do 20 k=kmin,kmax
             do 10 j=jmin,jmax
               arr(i,j,k,n) = arr(imin,j,k,n)
10           continue
20         continue
30       continue
         do 60 i=imax+1,idim
           do 50 k=kmin,kmax
             do 40 j=jmin,jmax
               arr(i,j,k,n) = arr(imax,j,k,n)
40           continue
50         continue
60       continue
         do 90 j=1,jmin-1
           do 80 i=1,idim
             do 70 k=kmin,kmax
               arr(i,j,k,n) = arr(i,jmin,k,n)
70           continue
80         continue
90       continue
         do 120 j=jmax+1,jdim
           do 110 i=1,idim
             do 100 k=kmin,kmax
               arr(i,j,k,n) = arr(i,jmax,k,n)
100          continue
110        continue
120      continue
         do 150 k=1,kmin-1
           do 140 j=1,jdim
             do 130 i=1,idim
               arr(i,j,k,n) = arr(i,j,kmin,n)
130          continue
140        continue
150      continue
         do 180 k=kmax+1,kdim
           do 170 j=1,jdim
             do 160 i=1,idim
               arr(i,j,k,n) = arr(i,j,kmax,n)
160          continue
170        continue
180      continue
190    continue
c
       return
       end

       subroutine qromb ( func, x1, x2, ss )
c
c    dac:zeus3d.qromb <------------------- integrates func from x1 to x2
c    from whp:numerical recipes                           december, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Returns the definite integral of the function "func"
c  between specified limits "x1" and "x2" using Romberg's method of
c  order 2k, where k=2 is Simpson's rule (see Numerical Recipes, 1st
c  edition for FORTRAN, page 114).
c
c  INPUT VARIABLES:
c    func     name of external function describing the univariate
c             function to be integrated.
c    x1, x2   integration limits
c
c  OUTPUT VARIABLES:
c    ss       value of definite integral
c
c  EXTERNALS:
c    FUNC
c    TRAPZD
c    POLINT
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
       integer       jmx     , jmxp    , k       , km
       real*8        eps
       parameter     ( jmx=20, jmxp=jmx+1, k=5, km=k-1 )
       parameter     ( eps=0.1**(isig+1) )
c
       integer       j
       real*8        x1      , x2      , ss      , dss
c
       real*8        s       (jmxp), h       (jmxp)
c
c      External statements
c
       real*8        func
       external      func    , trapzd  , polint
c
c-----------------------------------------------------------------------
c
       h(1) = 1.0
       do 10 j=1,jmx
         call trapzd ( func, x1, x2, j, s(j) )
         if (j .ge. k) then
           call polint ( h(j-km), s(j-km), k, zro, ss, dss )
           if (abs(dss) .lt. eps*abs(ss)) return
         endif
         s(j+1) = s(j)
         h(j+1) = 0.25 * h(j)
10     continue
       write (6, 2000) jmx, dss, ss
       return
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2000   format('QROMB   : *** WARNING *** Romberg Integration failed '
     1       ,'to converge in ',i2,' steps.',/
     1       ,'QROMB   : error =',1pg12.5,', definite integral =',g12.5)
c
       end

       subroutine ctor ( cstr, nch, rval, ierr )
c
c    dac:zeus3d.ctor <-------------- translates character string to real
c                                                          january, 1992
c
c      Written by: David Clarke
c      Modified 1:
c
c  PURPOSE:  This subroutine translates a character string to a real
c  constant.
c
c  INPUT VARIABLES:
c    cstr      character representation of real number
c    nch       number of characters in "cstr"
c
c  OUTPUT VARIABLES
c    rval      floating representation of real number
c    ierr      0 => floating conversion successful
c              1 => non-translatable character found in "cstr"
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       character*1   char1
       character*(*) cstr
       integer       nch     , ierr    , i       , esign   , ipnt
     1             , npnt    , more    , iman    , iexp    , j
       real*8        rval    , msign   , term    , fact
c
       character*1   ch      (  10)
       integer       exponent(   4), mantissa(  16)
c
c      Data statements
c
       data          ch       /'0','1','2','3','4','5','6','7','8','9'/
c
c-----------------------------------------------------------------------
c
c      Initialise parameters.
c
       do 10 i=1,4
         exponent(i) = 0
10     continue
       do 20 i=1,16
         mantissa(i) = 0
20     continue
       rval  = 0.0
       msign = 1.0
       esign = 1
       ipnt  = 0
       npnt  = 0
       more  = 1
       iman  = 0
       iexp  = 0
       ierr  = 0
c
c      Scan "cstr".
c
       do 40 i=1,nch
         char1 = cstr(i:i)
         if (char1 .eq. ' ') go to 40
         if (char1 .eq. '-') then
           if (more .eq. 1) msign = -1.0
           if (more .eq. 2) esign = -1
           go to 40
         endif
         if (char1 .eq. '+') go to 40
         if (char1 .eq. '.') then
           npnt = 1
           ipnt = i - 2
           if (msign .eq. -1.0) ipnt = ipnt - 1
           go to 40
         endif
         if ( (char1 .eq. 'e') .or. (char1 .eq. 'd') ) then
           more = 2
           if (npnt .eq. 0) then
             npnt = 1
             ipnt = i - 2
             if (msign .eq. -1.0) ipnt = ipnt - 1
             if (ipnt .lt. 0) ipnt = 0
           endif
           go to 40
         endif
         do 30 j=1,10
           if (char1 .eq. ch(j)) then
             if (more .eq. 1) then
               iman = iman + 1
               mantissa(iman) = j - 1
             endif
             if (more .eq. 2) then
               iexp = iexp + 1
               exponent(iexp) = j - 1
             endif
             go to 40
           endif
30       continue
c
c      Illegal character found.  Set "ierr" to 1 and return.
c
         ierr = 1
         return
40     continue
       if (npnt .eq. 0) ipnt = iman - 1
c
c      Evaluate the mantissa.
c
       if (iman .gt. 0) then
         do 50 i=1,iman
           term =  real(mantissa(i)) * 10.0**ipnt
           rval = rval + term
           ipnt = ipnt - 1
50       continue
       else
         rval = 1.0
       endif
       rval = rval * msign
c
c      Evaluate the exponential factor.
c
       fact = 1.0
       if (iexp .gt. 0) then
         do 60 i=1,iexp
           ipnt = iexp - i
           fact = fact * 10.0 ** (exponent(i) * 10.0**ipnt)
60       continue
       endif
       if (esign .eq. -1) fact = 1.0 / fact
c
c      Return real representation of character string.
c
       rval = rval * fact
c
       return
       end

       function norm ( idum )
c
c    dac:zeus3d.norm <------------- returns normally distributed deviate
c    from whp:numerical recipes                           december, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Returns a normally distrbuted deviate with zero mean and
c  unit variance (see Numerical Recipes, 1st edition for FORTRAN, page
c  203, function GASDEV).
c
c  INPUT VARIABLES:
c    idum     .ge. 0 => get next random number from sequence
c             .lt. 0 => initialise sequence depending on absolute value
c                       of "idum", and gets next random number
c
c  OUTPUT VARIABLES:
c    norm     deviate with normal distribution
c
c  EXTERNALS: RAN1
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       idum    , inext
       real*8        v1      , v2      , r       , fact    , next
     1             , norm
c
c      Data statements
c
       data          inext    / 0 /
       save          inext   , next
c
c      External statements
c
       real*8        ran1
       external      ran1
c
c-----------------------------------------------------------------------
c
       if (inext .eq. 0) then
10       continue
         v1    = 2.0 * ran1(idum) - 1.0
         v2    = 2.0 * ran1(idum) - 1.0
         r     = v1**2 + v2**2
         if (r .ge. 1.0) go to 10
         fact  = sqrt ( -2.0 *  log(r) / r )
         next  = v1 * fact
         norm  = v2 * fact
         inext = 1
       else
         norm  = next
         inext = 0
       endif
c
       return
       end

       subroutine rttoxy ( iar, ar, rvecb, drvecbi, tvecb, dtvecbi
     1                   , j1, j2, nxz, nyz, xb, yb, qvar, irb, jtb
     2                   , th0, iqty, qty )
c
c    dac:zeus3d.rttoxy <------------------- Map 2-D RT array to XY array
c                                                         february, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Maps a (not necessarily uniformly gridded) spherical polar
c  2-D array "ar" onto a (not necessarily uniformly gridded) Cartesian
c  2-D array "qty".  The spherical polar image is rotated by an angle
c  "th0" before it is remapped.
c
c  INPUT VARIABLES:
c    iar         leading dimension of "ar"
c    ar          input array (a 2-D polar slice of a 3-D datacube)
c    rvecb       zone-centred radial coordinate of computational grid
c    drvecbi     inverse of radial b-grid differences
c    tvecb       zone-centred angular coordinate of computational grid
c    dtvecbi     inverse of angular b-grid differences
c    j1,j2       starting and ending indices for "tvecb"
c    nxz,nyz     number of Cartesian zones in x- and y-directions.
c    xb,yb       zone-centred Cartesian grid.
c    qvar(1,2)   effective range of radial  coordinates spanned by "irb"
c    qvar(3)     resolution of look-up vector "irb"
c    qvar(4,5)   effective range of angular coordinates spanned by "jtb"
c    qvar(6)     resolution of look-up vector "jtb"
c    irb,jtb     look-up vectors to facilitate remapping
c    th0         CC angle about centre to rotate image before remapping
c    iqty        leading dimension of "qty"
c
c  The quantities "qvar", "irb", and "jtb" are computed by LOOKUP.
c
c  OUTPUT VARIABLES:
c    qty         remapped array
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
       integer       iar     , j1      , j2      , nxz     , nyz
     1             , iqty    , j       , nx      , ny      , ic
     2             , icmp1   , jc      , jcmp1
       real*8        th0     , sinth0  , costh0  , rbmn    , drai
     1             , rb0     , drb     , tamn    , tamx    , tbmn
     2             , dtai    , tb0     , dtb     , sintb0  , xb0
     3             , yb0     , sgnxb   , sgnyb   , sgnmn   , sgnmx
     4             , q1      , q2      , q3      , darr    , darl
     5             , d2ar    , dqx1    , dqx2    , qmax    , qmin
c
       integer       irb     (   *), jtb     (   *)
       real*8        rvecb   (   *), drvecbi (   *), tvecb   (   *)
     1             , dtvecbi (   *), xb      (   *), yb      (   *)
     2             , qvar    (   *), sintb   (ijkn), costb   (ijkn)
c
       real*8        ar      ( iar,   *), qty     (iqty,   *)
c
c  WARNING:  Do not equivalence the temporary vectors to the worker
c            arrays.  Conflicts result when this routine is called in
c            parallel loops in routines BININT and ZRPTOXYZ.
c
c-----------------------------------------------------------------------
c
       do 10 j=j1,j2
         sintb(j) = sin(tvecb(j))
         costb(j) = cos(tvecb(j))
10     continue
       sinth0 = sin(th0)
       costh0 = cos(th0)
c
       drai = 1.0 / qvar(3)
       rbmn = qvar(1) + qvar(3) / 2.0
       tamn = qvar(4)
       tamx = qvar(5)
       dtai = 1.0 / qvar(6)
       tbmn = qvar(4) + qvar(6) / 2.0
c
c      Re-map the data ("ar" -> "qty").  For each point on the pixel
c  grid, the coordinates of the nearest computational zone are
c  determined using the look-up tables ("irb" and "jtb").  The value
c  assigned to the pixel is then interpolated by use of a van-Leer
c  differencing scheme which has been determined (by trial and error) to
c  yield a much smoother (less jagged) re-map than, say, a weighted
c  average.
c
       do 30 ny=1,nyz
         q1 = yb(ny) * sinth0
         q2 = yb(ny) * costh0
         q3 = yb(ny)**2
         do 20 nx=1,nxz
           xb0    = q1 + xb(nx) * costh0
           sgnxb  = sign ( haf, xb0 )
           yb0    = q2 - xb(nx) * sinth0
           sgnyb  = sign ( one, yb0 )
           rb0    = sqrt ( xb(nx)**2 + q3 )
           ic     = irb (  int ( (rb0-rbmn) * drai ) + 1 )
           sintb0 =   max ( mone,   min ( one, xb0/(rb0+tiny) ) )
           tb0    = sgnyb * asin(sintb0) + ( 1.0 - sgnyb ) * sgnxb * pi
           sgnmn  = sign ( haf, tb0-tamn )
           sgnmx  = sign ( haf, tb0-tamx )
           tb0    = tb0 - ( sgnmn + sgnmx ) * 2.0 * pi
           jc     = jtb (  int ( (tb0-tbmn) * dtai ) + 1 )
           if (ic*jc .eq. 0) then
             qty(nx,ny) = 0.0
           else
             darr       = ( ar(ic+1,jc) - ar(ic  ,jc) ) * drvecbi(ic+1)
             darl       = ( ar(ic  ,jc) - ar(ic-1,jc) ) * drvecbi(ic  )
             d2ar       = darr * darl
             drb        = rb0 - rvecb(ic)
             dqx1       = drb * ( 1.0 + sign ( one, d2ar ) )
     1                  * d2ar / ( ( darr + darl ) + pi*tiny )
             darr       = ( ar(ic,jc+1) - ar(ic,jc  ) ) * dtvecbi(jc+1)
             darl       = ( ar(ic,jc  ) - ar(ic,jc-1) ) * dtvecbi(jc  )
             d2ar       = darr * darl
             dtb        = ( sin(tb0)*costb(jc) - sintb(jc)*cos(tb0) )
             dqx2       = dtb * ( 1.0 + sign ( one, d2ar ) )
     1                  * d2ar / ( ( darr + darl ) + pi*tiny )
             qty(nx,ny) = ar(ic,jc) + dqx1 + dqx2
             icmp1      = ic +  int ( sign ( one, drb ) )
             jcmp1      = jc +  int ( sign ( one, dtb ) )
             qmax       =   max ( ar(ic   ,jc), ar(ic   ,jcmp1)
     1                          , ar(icmp1,jc), ar(icmp1,jcmp1) )
             qmin       =   min ( ar(ic   ,jc), ar(ic   ,jcmp1)
     1                          , ar(icmp1,jc), ar(icmp1,jcmp1) )
             qty(nx,ny) =   max ( qmin,   min ( qmax, qty(nx,ny) ) )
           endif
20       continue
30     continue
c
       return
       end

       subroutine gridx1
c
c    dac:zeus3d.gridx1 <----------------------- initialises the x1a-grid
c    from jms:zeus3d.gridi                                     may, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Initialises the x1a-grid as specified by the parameters in
c  the namelist "ggen1".
c
c  LOCAL VARIABLES:
c
c  EXTERNALS:
c    ROUND
c    MODULO
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundaries
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       integer       mgit
       real*8        gerr
       parameter     ( mgit = 20, gerr = 1.0e-6 )
c
       logical       lgrid
       integer       nbl     , igrid   , imin    , imax    , ibeg
     1             , iend    , iter    , i
       real*8        x1min   , x1max   , x1rat   , dx1min  , dfndx1r
     1             , x1r     , deltx1r , gerrx1r
       real*8        fn      , small
       character*32  namelist (   2,1000)
       external      nlsdac01, nlsdac02, nlsdac03, nlsdac04, nlsdac05
     1             , nlsdac06, nlsdac07, nlsdac08, nlsdac09, nlsdac10
     2             , nlsdac11, nlsdac12, nlsdac13, nlsdac14, nlsdac15
     3             , nlsdac16, nlsdac17, nlsdac18, nlsdac19, nlsdac20
     4             , nlsdac21, nlsdac22, nlsdac23, nlsdac24
c
c      Data statements
c
       data          small    / 0.001 /
c
c      External statements
c
       real*8        modulo
       external      round   , modulo
c
c-----------------------------------------------------------------------
c
       if (in .le. 6) then
c
c      Set up a token x1-grid with one zone for problems with 1-symmetry
c
         ismn   = 1
         iemx   = 1
         ione   = 0
         x1a(1) = 0.0
         return
       endif
c
c      Set up a full x1-grid for problems where in > 6.  Read in blocks
c  of x1 grid zones.  Loop over read statement until all blocks are read
c  (signalled by reading in "lgrid" = .true.).  Each block can be zoned
c  independently of the others.  The only constraint is that the
c  starting position of the current block ("x1min") must correspond to
c  the ending position ("x1max") of the previous block.  Over the
c  current block, the zone widths are either ratioed or scaled, as
c  explained below.
c
c      Case 1:  RATIOED ZONES
c
c      Ratioed zones means that the ratio dx(i+1)/dx(i) is constant over
c  a specified region of the grid.  The zones can then be computed using
c  the zoning equation:
c
c      x1(I) = x1min + SUM OVER i UP TO I [dx1min*x1rat**i]
c
c  Not all parameters are independent.  Since x1max is specified, then
c
c      x1max = x1(N) = x1min + SUM OVER i UP TO N [dx1min*x1rat**i]
c
c  will allow "dx1min" to be computed from "x1rat" ("igrid" = +1, -1),
c  or "x1rat" to be computed from "dx1min" ("igrid" = +2, -2).
c
c      Case 2:  SCALED ZONES
c
c      Scaled zones are zones where dx is proportional to x. Thus, zones
c  with uniform shapes in spherical coordinates can be achieved with
c  this option.  In this case, the ratio x(i+1)/x(i) is constant over
c  the specified region of the grid.  The zones are computed using the
c  zoning equation:
c
c      x1(I) = x1min * x1rat**(I)
c
c  Since x1max = x1(N) is specified, N and "x1rat" are not independent.
c
c      x1max = x1min * x1rat**(N)
c
c  Thus, in this case ("igrid" = 3) the grid can be generated from N,
c  "x1min", and "x1max" and the user specified values of "x1rat" and
c  "dx1min" are ignored.
c
c   nbl        number of active zones in block being generated
c   x1min      x1a(imin), bottom position of block
c   x1max      x1a(imax), top    position of block
c   x1scale    arbitrary scaling factor for x1min and x1max
c   igrid      selects zoning type.
c              = 0  => block has already been set (irestart=1)
c              =+1  => (ratioed) use input "x1rat" to compute "dx1min",
c                      where x1a(imin+1) = x1a(imin) + dx1min.
c              =-1  => (ratioed) use input "x1rat" to compute "dx1min",
c                      where x1a(imax) = x1a(imax-1) + dx1min.
c              =+2  => (ratioed) use input "dx1min" to compute "x1rat",
c                      where x1a(imin+1) = x1a(imin) + dx1min.
c              =-2  => (ratioed) use input "dx1min" to compute "x1rat",
c                      where x1a(imax) = x1a(imax-1) + dx1min.
c              = 3  => (scaled) compute "x1rat" and "dx1min" from "nbl".
c   lgrid      =.false. => read another block (namelist card).
c              =.true.  => all blocks are read in.  Do not look for
c                          another namelist card.
c   imax,imin  indices of top and bottom of block
c
       ismn   = 3
       imax   = ismn - 1
       call nlsdac01 ( namelist, 1000 )
       namelist (1,   1) = 'nbl                          i s'
       namelist (1,   2) = 'x1min                        r s'
       namelist (1,   3) = 'x1max                        r s'
       namelist (1,   4) = 'x1scale                      r s'
       namelist (1,   5) = 'igrid                        i s'
       namelist (1,   6) = 'x1rat                        r s'
       namelist (1,   7) = 'dx1min                       r s'
       namelist (1,   8) = 'lgrid                        l s'
       nbl     = 2
       x1min   = 0.0
       x1max   = 0.0
       x1scale = 1.0
       igrid   = 1
       x1rat   = 1.0
       dx1min  = 0.0
       lgrid   = .false.
c
10     continue
       call nlsdac02 ( ioin    , 'ggen1   ', namelist, 1000,    8 )
       call nlsdac04 ( nbl     , 'nbl     ', namelist, 1000 )
       call nlsdac05 ( x1min   , 'x1min   ', namelist, 1000 )
       call nlsdac05 ( x1max   , 'x1max   ', namelist, 1000 )
       call nlsdac05 ( x1scale , 'x1scale ', namelist, 1000 )
       call nlsdac04 ( igrid   , 'igrid   ', namelist, 1000 )
       call nlsdac05 ( x1rat   , 'x1rat   ', namelist, 1000 )
       call nlsdac05 ( dx1min  , 'dx1min  ', namelist, 1000 )
       call nlsdac06 ( lgrid   , 'lgrid   ', namelist, 1000 )
       if (iolog .gt. 0) then
       call nlsdac24 ( iolog   , 'ggen1   ', namelist, 1000 )
       endif
c
       imin   = imax + 1
       imax   = imax + nbl
       if (imax .gt. in-3) then
         if (iolog .gt. 0) write (iolog, 2010) imax, in
         if (iotty .gt. 0) write (iotty, 2010) imax, in
         stop
       endif
c
c      Set limits of do-loops so that boundary zones will be computed
c  with the active zones.
c
       ibeg = imin
       if (imin .eq. ismn) ibeg = imin - 2
       iend = imax + 1
       if (lgrid)          iend = imax + 3
c
c  IGRID = 0:  This portion of the grid has already been set (this is
c              a restarted job: irestart = 1).  Write grid to log file
c              (zlnnid) and go on to next block.
c
       if (igrid .eq. 0) then
         if (iolog .gt. 0) then
           write (iolog, 2050) ibeg, iend
           write (iolog, 2060) resfile
           write (iolog, 2100) (x1a(i),i=ibeg,iend)
         endif
         if (.not. lgrid) go to 10
         go to 80
       endif
c
c  IGRID = 1:  For ratioed zones, compute "dx1min" from given value of
c              "x1rat".
c
       if ( abs(igrid) .eq. 1)  then
         if (igrid .eq. -1) x1rat = 1.0 / x1rat
         if (x1rat .eq. 1.0)  then
           dx1min = ( x1max - x1min ) /  real(nbl)
         else
           dx1min = ( x1max - x1min ) * ( x1rat      - 1.0 )
     1                                / ( x1rat**nbl - 1.0 )
         endif
       endif
c
c  IGRID = 2:  For ratioed zones, compute "x1rat" from given value of
c              "dx1min".
c
c  A Newton Raphson iteration is used to find the root ("x1rat") of the
c  function:
c
c    fn(x1r) = (x1max-x1min) - dx1min * [(x1r)**nbl - 1] / [x1r - 1] = 0
c
c  dfndx1r = derivative of fn wrt x1r
c  deltx1r = correction term to x1r
c  gerrx1r = relative error of correction
c
       if ( abs(igrid) .eq. 2) then
         x1r = 1.01
         do 20 iter=1,mgit
           fn      = x1max - x1min
     1             - dx1min * ( x1r**nbl - 1.0 ) / ( x1r - 1.0 )
           dfndx1r = dx1min * ( x1r**nbl - 1.0 ) / ( x1r - 1.0 )**2
     1             - nbl * dx1min * x1r**(nbl-1) / ( x1r - 1.0 )
           deltx1r = - fn / dfndx1r
           gerrx1r = abs ( deltx1r / x1r)
           x1r     = x1r + deltx1r
           if (gerrx1r .lt. gerr) go to 30
20       continue
         if (iolog .gt. 0) write (iolog, 2020) imin, x1r, deltx1r, fn
         if (iotty .gt. 0) write (iotty, 2020) imin, x1r, deltx1r, fn
         stop
c
30       continue
         x1rat = x1r
       endif
       if (igrid .eq. -2) then
         dx1min = dx1min * x1rat**(nbl-1)
         x1rat  = 1.0 / x1rat
       endif
c
c  IGRID = 3:  For scaled zones, compute "x1rat", the ratio of adjacent
c              zone-centre coordinates.
c
       if (igrid .eq. 3) then
         if (x1min .le. 0.0) then
           if (iolog .gt. 0) write (iolog, 2030) x1min
           if (iotty .gt. 0) write (iotty, 2030) x1min
           stop
         endif
         x1rat = ( x1max / x1min )**( 1.0 /  real(nbl) )
       endif
c
c      Default = error in input of "igrid".  Issue error message and
c  terminate execution (only legal values of "igrid" are -2, -1, 0, 1,
c  2, and 3).
c
       if ( (igrid .lt. -2) .or. (igrid .gt. 3) ) then
         if (iolog .gt. 0) write (iolog, 2040) imin, igrid
         if (iotty .gt. 0) write (iotty, 2040) imin, igrid
         stop
       endif
c
c      Set "x1a" grid from i = "ibeg" to "iend", using known values of
c  "x1min" and "x1rat".
c
       if (igrid .le. 2) then
         if (x1rat .eq. 1.0) then
           do 40 i=ibeg,iend
             x1a(i) = x1min + dx1min *  real(i-imin)
40         continue
         else
           do 50 i=ibeg,iend
             x1a(i) = x1min + dx1min * ( x1rat**(i-imin) - 1.0 )
     1                               / ( x1rat           - 1.0 )
50         continue
         endif
       endif
       if (igrid .eq. 3) then
         do 60 i=ibeg,iend
           x1a(i) = x1min * x1rat**(i-imin)
60       continue
       endif
c
c      Write grid to log file (zlnnid).
c
       if (iolog .gt. 0) then
         write (iolog, 2050) ibeg, iend
         if (x1rat .ge. 1.0) write (iolog, 2070) dx1min, x1rat
         if (x1rat .lt. 1.0) write (iolog, 2080) dx1min, x1rat
         write (iolog, 2090) x1scale
         write (iolog, 2100) (x1a(i),i=ibeg,iend)
       endif
c
c      Scale the grid.
c
       do 70 i=ibeg,iend
         x1a (i) = x1scale * x1a(i)
70     continue
c
c      Go back and read another block of x1 grid zones if "lgrid" is
c  still .false..
c
       if (.not. lgrid) go to 10
80     continue
       iemx = imax
       ione = 1
c
c      Grid in 1-direction is complete.  Round values for "x1a" grid to
c  "isig" significant figures.
c
       call round ( x1a, in, isig )
c
c      Grid consistency check.  Make sure origin always occurs at
c  x1a(ismn).
c
       if ( (x1a(ismn-1) .le. 0.0) .and. (x1a(ismn) .ne. 0.0) ) then
         if (iolog .gt. 0) write (iolog, 2110) x1a(ismn)
         if (iotty .gt. 0) write (iotty, 2110) x1a(ismn)
         stop
       endif
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2010   format('GRIDX1  : ***** ERROR ***** Number of zones in '
     1       ,' 1-direction exceeds array bounds',/
     2       ,'GRIDX1  : imax = ',i4,'  in = ',i4,/
     3       ,'GRIDX1  : ABORTS!')
2020   format('GRIDX1  : ***** ERROR ***** Newton-Raphson did not'
     1       ,' converge for x1rat.',/
     2       ,'GRIDX1  : imin = ',i3,' x1r = ',1pe12.5,' deltx1r = '
     3       ,1e12.5,' fn = ',1e12.5,/
     4       ,'GRIDX1  : ABORTS!')
2030   format('GRIDX1  : ***** ERROR ***** Hey chucklehead, you '
     1       ,'can''t have x1min = ',1pg12.5,/
     2       ,'GRIDX1  : with the scaled zone option! (igrid = 3)',/
     3       ,'GRIDX1  : ABORTS!')
2040   format('GRIDX1  : ***** ERROR ***** Illegal value of igrid '
     1       ,'during x1 grid generation.',/
     2       ,'GRIDX1  : imin = ',i3,'  igrid = ',i2,/
     3       ,'GRIDX1  : ABORTS!')
2050   format('GRIDX1  :',/
     1       ,'GRIDX1  : --------------------> x1a (face-centred) '
     2       ,'grid, zones ',i4,' through ',i4)
2060   format('GRIDX1  : These zones read from restart dump ',a8)
2070   format('GRIDX1  : grid parameters:  dx1min  = ',1pg12.5
     1       ,', x1rat = ',g12.5)
2080   format('GRIDX1  : grid parameters:  dx1max  = ',1pg12.5
     1       ,', x1rat = ',g12.5)
2090   format('GRIDX1  :                   x1scale = ',1pg12.5)
2100   format('GRIDX1  : ',1p5g14.6)
2110   format('GRIDX1  : ***** ERROR ***** Ill-defined grid, zero of '
     1       ,'x1 not at x1a(ismn).',/
     2       ,'GRIDX1  : x1a(ismn) = ',1pe12.5,/
     3       ,'GRIDX1  : ABORTS!')
c
       return
       end

       subroutine bndyall
c
c    dac:zeus3d.bndyall <------------ sets all hydrodynamical boundaries
c                                                            march, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This routine collects the calls to the subroutines BVAL*
c  which update the boundaries of the hydrodynamical variables.  The
c  boundaries of the magnetic fields are intentionally omitted, since
c  they are computed directly in the CT algorithm.
c
c  INPUT VARIABLES: [NONE]
c
c  OUTPUT VARIABLES: [NONE]
c
c  LOCAL VARIABLES: [NONE]
c
c  EXTERNALS:
c    BVALD
c    BVALE
c    BVALV1  , BVALV2, BVALV3
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c      External statements
c
       external      bvald   , bvale   , bvalv1  , bvalv2  , bvalv3
c
c-----------------------------------------------------------------------
c
       call bvald
       call bvale
       call bvalv1
       call bvalv2
       call bvalv3
c
       return
       end

       subroutine copyit ( nelt, arrin, incin, arrout, incout )
c
c    dac:zeus3d.copyit <----------- copies input vector to output vector
c                                                           august, 1992
c
c    written by: David Clarke
c    modified 1: 09/12/94 by Robert Fiedler to correct the indices
c                in the assignment statement involving arrout.
c
c  PURPOSE:  This subroutine copies the input vector "arrin" to the
c  output vector "arrout".  It is useful if multi-dimensional arrays
c  are to be copied because this subroutine will treat the arrays as
c  1-D vectors, thereby increasing the vector length making better use
c  of the vector machine.  If "arrin" and "arrout" are 1-D vectors in
c  the calling routine, calling this routine will degrade performance
c  because of the overhead involved in calling a subroutine.  This
c  routine has the same functionality as SCOPY and is only slightly
c  slower (2%).  Unlike SCOPY, however, this is completely portable.
c
c  INPUT VARIABLES:
c    nelt      number of elements to be copied
c    arrin     vector (array) to be copied
c    incin     increment between elements of "arrin"
c    incout    increment between elements of "arrout"
c
c  OUTPUT VARIABLES:
c    arrout    output vector (array)
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       nelt    , incin   , incout  , i       , j
c
       real*8        arrin   (   *), arrout  (   *)
c
c-----------------------------------------------------------------------
c
       j = 1
       do 10 i=1,(nelt-1)*incin+1,incin
         arrout(j) = arrin(i)
         j         = j + incout
10     continue
c
       return
       end

       function xibtorsq ( xi )
c
c    dac:zeus3d.xibtorsq <-------- integrand for magnetic energy density
c                                                              may, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  This function describes the integrand for integrating the
c  toroidal magnetic field energy density across the jet orifice.  For
c  a cylindrical jet, the integrand is xi * btor(xi)**2 and for a slab
c  jet, the integrand is btor(xi)**2, where BTOR is an external function
c  describing the profile of the toroidal field.
c
c  INPUT VARIABLES:
c    xi        point at which function is being evaluated (in units of
c              jet radii).
c
c  OUTPUT VARIABLES:
c    xibtorsq  the value of the integrand at "xi".
c
c  LOCAL VARIABLES:
c
c  EXTERNALS:
c    BTOR
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       real*8        xi      , xibtorsq
c
c      External statements
c
       real*8        btor
       external      btor
c
c-----------------------------------------------------------------------
c
       xibtorsq = 2.0 * xi * btor(xi)**2
c
       return
       end

       subroutine padi2d ( iarr, idim, jdim, ndim, imin, imax, jmin
     1                   , jmax )
c
c    dac:zeus3d.padi2d <------------------------- pads integer 2-D array
c                                                              may, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE: Pads input integer 2-D array "iarr" with edge values.
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       idim    , jdim    , ndim    , imin    , imax
     1             , jmin    , jmax    , i       , j       , n
c
       integer       iarr    (idim,jdim,ndim)
c
c-----------------------------------------------------------------------
c
       do 90 n=1,ndim
         do 20 i=1,imin-1
           do 10 j=jmin,jmax
             iarr(i,j,n) = iarr(imin,j,n)
10         continue
20       continue
         do 40 i=imax+1,idim
           do 30 j=jmin,jmax
             iarr(i,j,n) = iarr(imax,j,n)
30         continue
40       continue
         do 60 j=1,jmin-1
           do 50 i=1,idim
             iarr(i,j,n) = iarr(i,jmin,n)
50         continue
60       continue
         do 80 j=jmax+1,jdim
           do 70 i=1,idim
             iarr(i,j,n) = iarr(i,jmax,n)
70         continue
80       continue
90     continue
c
       return
       end

       function ctoi ( string, istrt, ifin )
c
c    jms:zeus3d.ctoi <------------- converts CHAR*8 string to an integer
c    from jms:zeus2d.strtoi                              ?????????, 19??
c
c    written by: Jim Stone
c    modified 1: January, 1990 by David Clarke; incorporated into ZEUS3D
c
c  PURPOSE:  Converts a segment of a character*8 string into an integer.
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       character*8   string
       integer       istrt   , ifin    , ishift  , ival    , i
       integer       ctoi
c
       integer       asciic  (48:57)
c
c      Data Statements
c
       data          asciic  / 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 /
       save          asciic
c
c-----------------------------------------------------------------------
c
       ishift = 1
       ival   = 0
       do 10 i=ifin,istrt,-1
         ival   = ival + ishift * asciic ( ichar(string(i:i)) )
         ishift = ishift * 10
10     continue
       ctoi = ival
c
       return
       end

       subroutine findno ( msg, istrt, ifin )
c
c    jms:zeus3d.findno <-------- finds reset number in interrupt message
c                                                             june, 1988
c
c    written by: Jim Stone
c    modified 1: January, 1990 by David Clarke; incorporated into ZEUS3D
c
c  PURPOSE:  Finds beginning and ending of a reset number in an
c  interrupt message string.
c
c  INPUT VARIABLES:
c    msg      character*80 string containing the message
c
c  OUTPUT VARIABLES:
c    istrt    number of first character of reset number in message
c             If no number is found, a value of -1 is returned
c    ifin     number of last character of reset number in message
c
c  LOCAL VARIABLES:
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       character*80  msg
       integer       istrt   , ifin    , iblnk
c
c-----------------------------------------------------------------------
c
       istrt = 0
       ifin  = 0
c
       do 10 iblnk=1,80
         if (msg(iblnk:iblnk) .eq. ' ') go to 20
10     continue
20     continue
       do 30 istrt=iblnk,80
         if (msg(istrt:istrt) .ne. ' ') go to 40
30     continue
       istrt = -1
       return
c
40     continue
       do 50 ifin=istrt,80
         if (msg(ifin:ifin) .eq.  ' ') go to 60
50     continue
60     continue
       ifin = ifin - 1
c
       return
       end

       subroutine polint ( xa, ya, n, x, y, dy )
c
c    dac:zeus3d.polint <---------------------- interpolates gridded data
c    from whp:numerical recipes                           december, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Given arrays "xa" and "ya", each of length "n", and a given
c  value "x", this routine returns a value "y" and an error estimate
c  "dy" (see Numerical Recipes, 1st edition for FORTRAN, page 82).
c
c  INPUT VARIABLES:
c    xa       input independent variable array
c    ya       input dependent   variable array
c    n        length of "xa" and "ya"
c    x        value of independent variable at which dependent variable
c             is to be interpolated
c
c  OUTPUT VARIABLES:
c    y        interpolated value of dependent variable
c    dy       estimate of error of interpolation.
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
       integer       nmax
       parameter     ( nmax=20 )
c
       integer       n       , ns      , i       , m
       real*8        x       , y       , dy      , dif     , dift
     1             , ho      , hp      , w       , den
c
       real*8        xa      (   n), ya      (   n)
     1             , c       (nmax), d       (nmax)
c
c-----------------------------------------------------------------------
c
       ns  = 1
       dif = abs ( x - xa(1) )
       do 10 i=1,n
         dift = abs ( x - xa(i) )
         if (dift .lt. dif) then
           ns  = i
           dif = dift
         endif
         c(i) = ya(i)
         d(i) = ya(i)
10     continue
       y  = ya(ns)
       ns = ns - 1
       do 30 m=1,n-1
         do 20 i=1,n-m
           ho   = xa(i  ) - x
           hp   = xa(i+m) - x
           w    = c (i+1) - d(i)
           den  = w / ( ( ho - hp ) + tiny )
           c(i) = ho * den
           d(i) = hp * den
20       continue
         if (2*ns .lt. n-m) then
           dy = c(ns+1)
         else
           dy = d(ns  )
           ns = ns - 1
         endif
         y = y + dy
30     continue
c
       return
       end

       subroutine mnmx3d ( qty, i1, j1, k1, i2, j2, k2, qmin, qmax
     1                   , nlog )
c
c    dac:zeus3d.mnmx3d <----------- finds extrema of a regular 3-d array
c                                                             july, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE: This subroutine returns the maximum and minimum value of a
c  rectangular 3-D array.  It differs from MNMX by using "  max" and
c  "  min" instead of "ISMAX" and "ISMIN" (thereby reducing execution
c  time by about 30%) and by not returning the grid location of the
c  extrema.
c
c  INPUT VARIABLES:
c    qty             the 3-D array to be searched for extrema.
c    i1              inner i index.
c    j1              inner j index.
c    k1              inner k index.
c    i2              outer i index.
c    j2              outer j index.
c    k2              outer k index.
c    nlog            =0 => return extrema
c                    =1 => return log10 of extrema
c
c  OUTPUT VARIABLES:
c    qmin            minimum value
c    qmax            maximum value
c
c  LOCAL VARIABLES:
c    qmink           minimum value for each k-sweep
c    qmaxk           maximum value for each k-sweep
c
c----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       integer       i       , j       , k       , i1      , j1
     1             , k1      , i2      , j2      , k2      , nlog
       real*8        qmin    , qmax
c
       real*8        qmink   (ijkn), qmaxk   (ijkn)
c
c      Careful!  "wa1d" - "wi1d" are used by BININT.
c
       equivalence   ( qmink   , wy1d     ), ( qmaxk   , wz1d     )
c
       real*8        qty     (  in,  jn,  kn)
c
c-----------------------------------------------------------------------
c
c      Extrema are first determined for each k-sweep.  Then the global
c  extrema are found among the sweep extrema.  This is done to aid the
c  EDITOR auto-tasking process.
c
       k = k1
       j = j1
       i = i1
       qmin = huge
       qmax =-huge
       do 30 k=k1,k2
           do 10 i=i1,i2
             qmin =   min ( qmin, qty(i,j,k) )
             qmax =   max ( qmax, qty(i,j,k) )
10         continue
20       continue
30     continue
c
c      Take log10 of extrema, if desired.
c
       if (nlog .eq. 1) then
         qmin =  log10 (   max ( tiny, qmin ) )
         qmax =  log10 (   max ( tiny, qmax ) )
       endif
c
       return
       end

       subroutine round ( vect, idime, isigfig )
c
c    dac:zeus3d.round <--------- sets no of sig figs for vector elements
c                                                          october, 1990
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE: This subroutine sets the number of significant figures of
c  the elements in the input vector to the specified number.
c
c  INPUT VARIABLES
c    vect      vector to be "rounded off"
c    idime     dimension of "vect"
c    isigfig   number of significant figures on output
c
c  OUTPUT VARIABLES
c    vect      rounded off input vector
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
       integer       i       , idime   , isigfig , i1
       real*8        q1      , q2
c
       real*8        vect    (idime)
c
c-----------------------------------------------------------------------
c
       if (isigfig .le. 0) return
       q1 = 0.0
       do 10 i=1,idime
         q1 =   max ( q1, abs(vect(i)) )
10     continue
       if (q1 .eq. 0.0) return
       q1 =  log10 ( q1 )
       q2 = sign ( haf, q1 )
       i1 = isigfig -  int ( q1 + q2 + 0.5 )
       do 20 i=1,idime
         vect(i) = anint ( vect(i) * 10.0**i1 ) / 10.0**i1
20     continue
c
       return
       end

       function ran1 ( idum )
c
c    dac:zeus3d.ran1 <------------------- returns uniform random deviate
c    from whp:numerical recipes                           december, 1992
c
c    written by: David Clarke
c    modified 1:
c
c  PURPOSE:  Returns a uniformly distrbuted random deviate between 0.0
c  and 1.0 (see Numerical Recipes, 1st edition for FORTRAN, page 196).
c
c  INPUT VARIABLES:
c    idum     .ge. 0 => get next random number from sequence
c             .lt. 0 => initialise sequence depending on absolute value
c                       of "idum", and gets next random number
c
c  OUTPUT VARIABLES:
c    ran1     deviate with uniform distribution between 0.0 and 1.0
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
       integer       imax    , m1      , ia1     , ic1     , m2
     1             , ia2     , ic2     , m3      , ia3     , ic3
       real*8        rm1     , rm2
       parameter     ( imax=97 )
       parameter     ( m1=259200, ia1=7141, ic1=54733, rm1=1.0/m1 )
       parameter     ( m2=134456, ia2=8121, ic2=28411, rm2=1.0/m2 )
       parameter     ( m3=243000, ia3=4561, ic3=51349 )
c
       integer       idum    , iff     , ix1     , ix2     , ix3
     1             , i
       real*8        ran1
c
       real*8        r       (imax)
c
c      Data statements
c
       data          iff      / 0 /
       save          iff     , ix1     , ix2     , ix3     , r
c
c-----------------------------------------------------------------------
c
c      If sequence is to be initialised, start here ...
c
       if ( (idum .lt. 0) .or. (iff .eq. 0) ) then
         iff = 1
         ix1 = mod ( ic1 - idum   , m1 )
         ix1 = mod ( ia1*ix1 + ic1, m1 )
         ix2 = mod ( ix1          , m2 )
         ix1 = mod ( ia1*ix1 + ic1, m1 )
         ix3 = mod ( ix1          , m3 )
         do 10 i=1,imax
           ix1  = mod ( ia1*ix1 + ic1, m1 )
           ix2  = mod ( ia2*ix2 + ic2, m2 )
           r(i) = (  real(ix1) +  real(ix2) * rm2 ) * rm1
10       continue
         idum = 1
       endif
c
c      Otherwise, start here ....
c
       ix1  = mod ( ia1*ix1 + ic1, m1 )
       ix2  = mod ( ia2*ix2 + ic2, m2 )
       ix3  = mod ( ia3*ix3 + ic3, m3 )
       i    = 1 + ( imax * ix3 ) / m3
       ran1 = r(i)
       r(i) = (  real(ix1) +  real(ix2) * rm2 ) * rm1
c
       return
       end

       subroutine mget
c
c    dac:zeus3d.mget <----------------------------- reads a restart dump
c    from jms:zeus2d.msave,mget                           november, 1989
c    from mln:zeus04.msave,mget
c
c    written by: David Clarke
c    modified 1: January, 1990 by David Clarke; incorporated into ZEUS3D
c    modified 2: May, 1992 by David Clarke; reworked for new common deck
c                structure and the new multiple record format for the
c                restart dumps.
c
c  PURPOSE:  Reads the following common block variables from the logical
c  unit "iodmp":
c
c        common / rootc    /  =  character root variables
c        common / rooti    /  =  integer   root variables
c        common / rootr    /  =  real      root variables
c
c  LOCAL VARIABLES:
c    iparm ( 1)                 in
c    iparm ( 2)                 jn
c    iparm ( 3)                 kn
c    iparm ( 4)                 niov
c    iparm ( 5)                 nios
c    iparm ( 6)                 ntsl
c    iparm ( 7)                 mn
c    iparm ( 8)                 nmd
c    iparm (21) -> iparm (40)   nt01 -> nt20
c    imacro( 1)                 =1 for ISYM   on
c    imacro( 2)                 =1 for JSYM   on
c    imacro( 3)                 =1 for KSYM   on
c    imacro( 4)                 =1 for ISO    on
c    imacro( 5)                 =1 for GRAV   on
c    imacro( 6)                 =1 for MHD    on
c    imacro( 7)                 =1 for TIMESL on
c
c  EXTERNALS:
c    MSKIP
c    PADC1D  , PADI1D  , PADR1D
c    PADI2D  , PADR2D
c    PADR3D
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundaries
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
       integer       maxp
       parameter     ( maxp =  50 )
c
       integer       i       , j       , k       , kill    , nerr
     1             , n       , nmax    , m       , mmax    , nwarn0
c
       integer       iparm   (maxp), imacro  (maxp)
       real*8        buff    (4*in*jn*kn)
c
c      Equivalence statements
c
       equivalence   ( buff    (1), wa3d    (1,1,1) )
c
c      External statements
c
       external      mskip   , padc1d  , padi1d  , padr1d  , padi2d
     1             , padr2d  , padr3d
c
c-----------------------------------------------------------------------
c
c      Open the restart dump file.
c
       open ( unit=iodmp, file=resfile, status='old', err=510
     1      , form='unformatted' )
c
c      Read environmental information from restart dump first.
c
       read  (iodmp, err=510) iparm, imacro
c
c      Issue warnings, if any.
c
       nwarn0 = 0
       if (igetmn .gt.         1) then
         if (iolog .gt. 0) write (iolog, 2010) igetmn
         nwarn0 = nwarn0 + 1
       endif
       if (igetmx .gt. iparm( 1)) then
         if (iolog .gt. 0) write (iolog, 2020) igetmx, iparm( 1)
         nwarn0 = nwarn0 + 1
       endif
       if (igetmx .lt. iparm( 1)) then
         if (iolog .gt. 0) write (iolog, 2030) igetmx, iparm( 1)
         nwarn0 = nwarn0 + 1
       endif
       if (jgetmn .gt.         1) then
         if (iolog .gt. 0) write (iolog, 2040) jgetmn
         nwarn0 = nwarn0 + 1
       endif
       if (jgetmx .gt. iparm( 2)) then
         if (iolog .gt. 0) write (iolog, 2050) jgetmx, iparm( 2)
         nwarn0 = nwarn0 + 1
       endif
       if (jgetmx .lt. iparm( 2)) then
         if (iolog .gt. 0) write (iolog, 2060) jgetmx, iparm( 2)
         nwarn0 = nwarn0 + 1
       endif
       if (kgetmn .gt.         1) then
         if (iolog .gt. 0) write (iolog, 2070) kgetmn
         nwarn0 = nwarn0 + 1
       endif
       if (kgetmx .gt. iparm( 3)) then
         if (iolog .gt. 0) write (iolog, 2080) kgetmx, iparm( 3)
         nwarn0 = nwarn0 + 1
       endif
       if (kgetmx .lt. iparm( 3)) then
         if (iolog .gt. 0) write (iolog, 2090) kgetmx, iparm( 3)
         nwarn0 = nwarn0 + 1
       endif
       if (niov   .gt. iparm( 4)) then
         if (iolog .gt. 0) write (iolog, 2100) niov  , iparm( 4)
         nwarn0 = nwarn0 + 1
       endif
       if (niov   .lt. iparm( 4)) then
         if (iolog .gt. 0) write (iolog, 2110) niov  , iparm( 4)
         nwarn0 = nwarn0 + 1
       endif
       if (nios   .gt. iparm( 5)) then
         if (iolog .gt. 0) write (iolog, 2120) nios  , iparm( 5)
         nwarn0 = nwarn0 + 1
       endif
       if (nios   .lt. iparm( 5)) then
         if (iolog .gt. 0) write (iolog, 2130) nios  , iparm( 5)
         nwarn0 = nwarn0 + 1
       endif
       if (ntsl   .gt. iparm( 6)) then
         if (iolog .gt. 0) write (iolog, 2140) ntsl  , iparm( 6)
         nwarn0 = nwarn0 + 1
       endif
       if (ntsl   .lt. iparm( 6)) then
         if (iolog .gt. 0) write (iolog, 2150) ntsl  , iparm( 6)
         nwarn0 = nwarn0 + 1
       endif
       if (mn     .gt. iparm( 7)) then
         if (iolog .gt. 0) write (iolog, 2160) mn    , iparm( 7)
         nwarn0 = nwarn0 + 1
       endif
       if (mn     .lt. iparm( 7)) then
         if (iolog .gt. 0) write (iolog, 2170) mn    , iparm( 7)
         nwarn0 = nwarn0 + 1
       endif
       if (nmd    .gt. iparm( 8)) then
         if (iolog .gt. 0) write (iolog, 2180) nmd   , iparm( 8)
         nwarn0 = nwarn0 + 1
       endif
       if (nmd    .lt. iparm( 8)) then
         if (iolog .gt. 0) write (iolog, 2190) nmd   , iparm( 8)
         nwarn0 = nwarn0 + 1
       endif
       if (nt01   .gt. iparm(21)) then
         if (iolog .gt. 0) write (iolog, 2200) nt01  , iparm(21)
         nwarn0 = nwarn0 + 1
       endif
       if (nt01   .lt. iparm(21)) then
         if (iolog .gt. 0) write (iolog, 2210) nt01  , iparm(21)
         nwarn0 = nwarn0 + 1
       endif
       if (nt02   .gt. iparm(22)) then
         if (iolog .gt. 0) write (iolog, 2220) nt02  , iparm(22)
         nwarn0 = nwarn0 + 1
       endif
       if (nt02   .lt. iparm(22)) then
         if (iolog .gt. 0) write (iolog, 2230) nt02  , iparm(22)
         nwarn0 = nwarn0 + 1
       endif
       if (nt03   .gt. iparm(23)) then
         if (iolog .gt. 0) write (iolog, 2240) nt03  , iparm(23)
         nwarn0 = nwarn0 + 1
       endif
       if (nt03   .lt. iparm(23)) then
         if (iolog .gt. 0) write (iolog, 2250) nt03  , iparm(23)
         nwarn0 = nwarn0 + 1
       endif
       if (nt04   .gt. iparm(24)) then
         if (iolog .gt. 0) write (iolog, 2260) nt04  , iparm(24)
         nwarn0 = nwarn0 + 1
       endif
       if (nt04   .lt. iparm(24)) then
         if (iolog .gt. 0) write (iolog, 2270) nt04  , iparm(24)
         nwarn0 = nwarn0 + 1
       endif
       if (nt05   .gt. iparm(25)) then
         if (iolog .gt. 0) write (iolog, 2280) nt05  , iparm(25)
         nwarn0 = nwarn0 + 1
       endif
       if (nt05   .lt. iparm(25)) then
         if (iolog .gt. 0) write (iolog, 2290) nt05  , iparm(25)
         nwarn0 = nwarn0 + 1
       endif
       if (nt06   .gt. iparm(26)) then
         if (iolog .gt. 0) write (iolog, 2300) nt06  , iparm(26)
         nwarn0 = nwarn0 + 1
       endif
       if (nt06   .lt. iparm(26)) then
         if (iolog .gt. 0) write (iolog, 2310) nt06  , iparm(26)
         nwarn0 = nwarn0 + 1
       endif
       if (nt07   .gt. iparm(27)) then
         if (iolog .gt. 0) write (iolog, 2320) nt07  , iparm(27)
         nwarn0 = nwarn0 + 1
       endif
       if (nt07   .lt. iparm(27)) then
         if (iolog .gt. 0) write (iolog, 2330) nt07  , iparm(27)
         nwarn0 = nwarn0 + 1
       endif
       if (nt08   .gt. iparm(28)) then
         if (iolog .gt. 0) write (iolog, 2340) nt08  , iparm(28)
         nwarn0 = nwarn0 + 1
       endif
       if (nt08   .lt. iparm(28)) then
         if (iolog .gt. 0) write (iolog, 2350) nt08  , iparm(28)
         nwarn0 = nwarn0 + 1
       endif
       if (nt09   .gt. iparm(29)) then
         if (iolog .gt. 0) write (iolog, 2360) nt09  , iparm(29)
         nwarn0 = nwarn0 + 1
       endif
       if (nt09   .lt. iparm(29)) then
         if (iolog .gt. 0) write (iolog, 2370) nt09  , iparm(29)
         nwarn0 = nwarn0 + 1
       endif
       if (nt10   .gt. iparm(30)) then
         if (iolog .gt. 0) write (iolog, 2380) nt10  , iparm(30)
         nwarn0 = nwarn0 + 1
       endif
       if (nt10   .lt. iparm(30)) then
         if (iolog .gt. 0) write (iolog, 2390) nt10  , iparm(30)
         nwarn0 = nwarn0 + 1
       endif
       if (nt11   .gt. iparm(31)) then
         if (iolog .gt. 0) write (iolog, 2400) nt11  , iparm(31)
         nwarn0 = nwarn0 + 1
       endif
       if (nt11   .lt. iparm(31)) then
         if (iolog .gt. 0) write (iolog, 2410) nt11  , iparm(31)
         nwarn0 = nwarn0 + 1
       endif
       if (nt15   .gt. iparm(35)) then
         if (iolog .gt. 0) write (iolog, 2420) nt15  , iparm(35)
         nwarn0 = nwarn0 + 1
       endif
       if (nt15   .lt. iparm(35)) then
         if (iolog .gt. 0) write (iolog, 2430) nt15  , iparm(35)
         nwarn0 = nwarn0 + 1
       endif
       if (nt16   .gt. iparm(36)) then
         if (iolog .gt. 0) write (iolog, 2440) nt16  , iparm(36)
         nwarn0 = nwarn0 + 1
       endif
       if (nt16   .lt. iparm(36)) then
         if (iolog .gt. 0) write (iolog, 2450) nt16  , iparm(36)
         nwarn0 = nwarn0 + 1
       endif
       if (nt20   .gt. iparm(40)) then
         if (iolog .gt. 0) write (iolog, 2460) nt20  , iparm(40)
         nwarn0 = nwarn0 + 1
       endif
       if (nt20   .lt. iparm(40)) then
         if (iolog .gt. 0) write (iolog, 2470) nt20  , iparm(40)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(1) .eq. 1) then
         if (iolog .gt. 0) write (iolog, 2490)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(2) .eq. 0) then
         if (iolog .gt. 0) write (iolog, 2500)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(3) .eq. 1) then
         if (iolog .gt. 0) write (iolog, 2530)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(4) .eq. 1) then
         if (iolog .gt. 0) write (iolog, 2550)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(5) .eq. 1) then
         if (iolog .gt. 0) write (iolog, 2570)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(6) .eq. 0) then
         if (iolog .gt. 0) write (iolog, 2580)
         nwarn0 = nwarn0 + 1
       endif
       if (imacro(7) .eq. 0) then
         if (iolog .gt. 0) write (iolog, 2600)
         nwarn0 = nwarn0 + 1
       endif
c
c      Determine ranges for field arrays
c
       igetmx =  min ( igetmx, iparm(1) )
       iputmx = iputmn + igetmx - igetmn
       jgetmx =  min ( jgetmx, iparm(2) )
       jputmx = jputmn + jgetmx - jgetmn
       kgetmx =  min ( kgetmx, iparm(3) )
       kputmx = kputmn + kgetmx - kgetmn
c
c      Abort execution if any of the array dimensions "in", "jn", or
c  "kn" is too small to load all the data requested.
c
       kill = 0
       if (iputmx .gt. in) then
         if (iotty .gt. 0) write (iotty, 2620) in, iputmx
         if (iolog .gt. 0) write (iolog, 2620) in, iputmx
         kill = 1
       endif
       if (jputmx .gt. jn) then
         if (iotty .gt. 0) write (iotty, 2630) jn, jputmx
         if (iolog .gt. 0) write (iolog, 2630) jn, jputmx
         kill = 1
       endif
       if (kputmx .gt. kn) then
         if (iotty .gt. 0) write (iotty, 2640) kn, kputmx
         if (iolog .gt. 0) write (iolog, 2640) kn, kputmx
         kill = 1
       endif
       if (kill .eq. 1) then
         if (iotty .gt. 0) write (iotty, 2650)
         if (iolog .gt. 0) write (iolog, 2650)
         stop
       endif
c
c-----------------------------------------------------------------------
c---------------------- READ THE RESTART DUMP FILE ---------------------
c-----------------------------------------------------------------------
c
       nerr = 0
c
c---------------------------- Read scalars -----------------------------
c
       nmax =  min ( nt01, iparm(21) )
       read (iodmp, err=510) ( insc(n),n=1,nmax )
       nmax =  min ( nt02, iparm(22) )
       read (iodmp, err=510) ( rlsc(n),n=1,nmax )
c
c---------------------------- Read vectors -----------------------------
c
       nmax =  min ( nt03, iparm(23) )
       mmax =  min ( niov, iparm( 4) )
       do 10 n=1,nmax
         read (iodmp, err=510) ( c2niov(m,n),m=1,mmax )
10     continue
       call mskip  ( iodmp, iparm(23)-nmax, nerr )
       call padc1d ( c2niov, niov, nt03, iparm( 4) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt04, iparm(24) )
       mmax =  min ( niov, iparm( 4) )
       do 20 n=1,nmax
         read (iodmp, err=510) ( inniov(m,n),m=1,mmax )
20     continue
       call mskip  ( iodmp, iparm(24)-nmax, nerr )
       call padi1d ( inniov, niov, nt04, iparm( 4) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt05, iparm(25) )
       mmax =  min ( nios, iparm( 5) )
       do 30 n=1,nmax
         read (iodmp, err=510) ( innios(m,n),m=1,mmax )
30     continue
       call mskip  ( iodmp, iparm(25)-nmax, nerr )
       call padi1d ( innios, nios, nt05, iparm( 5) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt06, iparm(26) )
       mmax =  min ( mn  , iparm( 7) )
       do 40 n=1,nmax
         read (iodmp, err=510) ( inmn  (m,n),m=1,mmax )
40     continue
       call mskip  ( iodmp, iparm(26)-nmax, nerr )
       call padi1d ( inmn  , mn  , nt06, iparm( 7) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt07, iparm(27) )
       mmax =  min ( niov, iparm( 4) )
       do 50 n=1,nmax
         read (iodmp, err=510) ( rlniov(m,n),m=1,mmax )
50     continue
       call mskip  ( iodmp, iparm(27)-nmax, nerr )
       call padr1d ( rlniov, niov, nt07, iparm( 4) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt08, iparm(28) )
       mmax =  min ( nios, iparm( 5) )
       do 60 n=1,nmax
         read (iodmp, err=510) ( rlnios(m,n),m=1,mmax )
60     continue
       call mskip  ( iodmp, iparm(28)-nmax, nerr )
       call padr1d ( rlnios, nios, nt08, iparm( 5) )
       if (nerr .gt. 0) go to 510
c
       nmax =  min ( nt09, iparm(29) )
       mmax =  min ( mn  , iparm( 7) )
       do 70 n=1,nmax
         read (iodmp, err=510) ( rlmn  (m,n),m=1,mmax )
70     continue
       call mskip  ( iodmp, iparm(29)-nmax, nerr )
       call padr1d ( rlmn  , mn  , nt09, iparm( 7) )
       if (nerr .gt. 0) go to 510
c
       if (imacro(7) .eq. 1) then
         nmax =  min ( nt10, iparm(30) )
         mmax =  min ( ntsl, iparm( 6) )
         do 80 n=1,nmax
           read (iodmp, err=510) ( rlntsl(m,n),m=1,mmax )
80       continue
         call mskip  ( iodmp, iparm(30)-nmax, nerr )
         call padr1d ( rlntsl, ntsl, nt10, iparm( 6) )
         if (nerr .gt. 0) go to 510
       endif
c
       read (iodmp, err=510) ( buff(i),i=1,igetmn-1 )
     1                     , ( x1a (i),i=iputmn,iputmx )
c
       read (iodmp, err=510) ( buff(i),j=1,jgetmn-1 )
     1                     , ( x2a (j),j=jputmn,jputmx )
c
       read (iodmp, err=510) ( buff(i),k=1,kgetmn-1 )
     1                     , ( x3a (k),k=kputmn,kputmx )
c
c---------------- Read 2-D arrays with dimension (jn,kn) ---------------
c
       if (imacro(1) .eq. 0) then
c
c      Read integer array "injnkn"
c
         nmax =  min ( nt11, iparm(31) )
         do 100 n=1,nmax
           call mskip ( iodmp, kgetmn-1, nerr )
           do 90 k=kputmn,kputmx
             read (iodmp, err=510) ( buff  (j    ),j=1,jgetmn-1 )
     1                           , ( injnkn(j,k,n),j=jputmn,jputmx )
90         continue
           call mskip ( iodmp, iparm(3)-kgetmx, nerr )
100      continue
         call mskip ( iodmp, (iparm(31)-nmax)*iparm(3), nerr )
         if (nerr .gt. 0) go to 510
c
c      Read isothermal hydrodynamic variables from real array "rljnkn"
c
         nmax =  min ( nt12, iparm(32) )
         do 120 n=1,nmax
           call mskip ( iodmp, kgetmn-1, nerr )
           do 110 k=kputmn,kputmx
             read (iodmp, err=510) ( buff  (j    ),j=1,jgetmn-1 )
     1                           , ( rljnkn(j,k,n),j=jputmn,jputmx )
110        continue
           call mskip ( iodmp, iparm(3)-kgetmx, nerr )
120      continue
         call mskip ( iodmp, (iparm(32)-nmax)*iparm(3), nerr )
         if (nerr .gt. 0) go to 510
c
c      Read internal energy variables from real array "rljnkn"
c
         if (imacro(4) .eq. 0) then
           nmax =  min ( nt13, iparm(33) )
           do 140 n=iparm(32)+1,nmax
             call mskip ( iodmp, kgetmn-1, nerr )
             do 130 k=kputmn,kputmx
               read (iodmp, err=510) ( buff  (j    ),j=1,jgetmn-1 )
     1                             , ( rljnkn(j,k,n),j=jputmn,jputmx )
130          continue
             call mskip ( iodmp, iparm(3)-kgetmx, nerr )
140        continue
           call mskip ( iodmp, (iparm(33)-nmax)*iparm(3), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Read gravity variables from real array "rljnkn"
c
         if (imacro(5) .eq. 1) then
           call mskip ( iodmp, (iparm(34)-iparm(33))*iparm(3), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Read magnetic variables from real array "rljnkn"
c
         if (imacro(6) .eq. 1) then
           nmax =  min ( nt16, iparm(36) )
           do 180 n=iparm(34)+1,nmax
             call mskip ( iodmp, kgetmn-1, nerr )
             do 170 k=kputmn,kputmx
               read (iodmp, err=510) ( buff  (j    ),j=1,jgetmn-1 )
     1                             , ( rljnkn(j,k,n),j=jputmn,jputmx )
170          continue
             call mskip ( iodmp, iparm(3)-kgetmx, nerr )
180        continue
           call mskip ( iodmp, (iparm(36)-nmax)*iparm(3), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Pad the arrays, if necessary
c
         call padi2d ( injnkn, jn, kn, nt11
     1               , jputmn, jputmx, kputmn, kputmx )
         call padr2d ( rljnkn, jn, kn, nt16
     1               , jputmn, jputmx, kputmn, kputmx )
       endif
c
c---------------- Read 2-D arrays with dimension (kn,in) ---------------
c
       if (imacro(2) .eq. 0) then
c
c      Pass over integer array "inknin" and real array "rlknin".
c
         call mskip ( iodmp, (iparm(31)+iparm(35))*iparm(1), nerr )
         if (nerr .gt. 0) go to 510
       endif
c
c---------------- Read 2-D arrays with dimension (in,jn) ---------------
c
       if (imacro(3) .eq. 0) then
c
c      Read integer array "ininjn"
c
         nmax =  min ( nt11, iparm(31) )
         do 300 n=1,nmax
           call mskip ( iodmp, jgetmn-1, nerr )
           do 290 j=jputmn,jputmx
             read (iodmp, err=510) ( buff  (i    ),i=1,igetmn-1 )
     1                           , ( ininjn(i,j,n),i=iputmn,iputmx )
290        continue
           call mskip ( iodmp, iparm(2)-jgetmx, nerr )
300      continue
         call mskip ( iodmp, (iparm(31)-nmax)*iparm(2), nerr )
         if (nerr .gt. 0) go to 510
c
c      Read isothermal hydrodynamic variables from real array "rlinjn"
c
         nmax =  min ( nt12, iparm(32) )
         do 320 n=1,nmax
           call mskip ( iodmp, jgetmn-1, nerr )
           do 310 j=jputmn,jputmx
             read (iodmp, err=510) ( buff  (i    ),i=1,igetmn-1 )
     1                           , ( rlinjn(i,j,n),i=iputmn,iputmx )
310        continue
           call mskip ( iodmp, iparm(2)-jgetmx, nerr )
320      continue
         call mskip ( iodmp, (iparm(32)-nmax)*iparm(2), nerr )
         if (nerr .gt. 0) go to 510
c
c      Read internal energy variables from real array "rlinjn"
c
         if (imacro(4) .eq. 0) then
           nmax =  min ( nt13, iparm(33) )
           do 340 n=iparm(32)+1,nmax
             call mskip ( iodmp, jgetmn-1, nerr )
             do 330 j=jputmn,jputmx
               read (iodmp, err=510) ( buff  (i    ),i=1,igetmn-1 )
     1                             , ( rlinjn(i,j,n),i=iputmn,iputmx )
330          continue
             call mskip ( iodmp, iparm(2)-jgetmx, nerr )
340        continue
           call mskip ( iodmp, (iparm(33)-nmax)*iparm(2), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Read gravity variables from real array "rlinjn"
c
         if (imacro(5) .eq. 1) then
           call mskip ( iodmp, (iparm(34)-iparm(33))*iparm(2), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Read magnetic variables from real array "rlinjn"
c
         if (imacro(6) .eq. 1) then
           nmax =  min ( nt15, iparm(35) )
           do 380 n=iparm(34)+1,nmax
             call mskip ( iodmp, jgetmn-1, nerr )
             do 370 j=jputmn,jputmx
               read (iodmp, err=510) ( buff  (i    ),i=1,igetmn-1 )
     1                             , ( rlinjn(i,j,n),i=iputmn,iputmx )
370          continue
             call mskip ( iodmp, iparm(2)-jgetmx, nerr )
380        continue
           call mskip ( iodmp, (iparm(35)-nmax)*iparm(2), nerr )
           if (nerr .gt. 0) go to 510
         endif
c
c      Pad the arrays, if necessary
c
         call padi2d ( ininjn, in, jn, nt11
     1               , iputmn, iputmx, jputmn, jputmx )
         call padr2d ( rlinjn, in, jn, nt15
     1               , iputmn, iputmx, jputmn, jputmx )
       endif
c
c--------------------------- Read 3-D arrays ---------------------------
c
c      Read isothermal hydrodynamic variables from real array "rlinjnkn"
c
       nmax =  min ( nt17, iparm(37) )
       do 410 n=1,nmax
         call mskip ( iodmp, (kgetmn-1)*iparm(2), nerr )
         do 400 k=kputmn,kputmx
           call mskip ( iodmp, jgetmn-1, nerr )
           do 390 j=jputmn,jputmx
             read (iodmp, err=510) (buff    (i      ),i=1,igetmn-1)
     1                           , (rlinjnkn(i,j,k,n),i=iputmn,iputmx)
390        continue
           call mskip ( iodmp, iparm(2)-jgetmx, nerr )
400      continue
         call mskip ( iodmp, (iparm(3)-kgetmx)*iparm(2), nerr )
410    continue
       call mskip ( iodmp, (iparm(37)-nmax)*iparm(3)*iparm(2), nerr )
       if (nerr .gt. 0) go to 510
c
c      Read internal energy from real array "rlinjnkn"
c
       if (imacro(4) .eq. 0) then
         nmax =  min ( nt18, iparm(38) )
         do 440 n=iparm(37)+1,nmax
           call mskip ( iodmp, (kgetmn-1)*iparm(2), nerr )
           do 430 k=kputmn,kputmx
             call mskip ( iodmp, jgetmn-1, nerr )
             do 420 j=jputmn,jputmx
               read (iodmp, err=510) (buff    (i      ),i=1,igetmn-1)
     1                             , (rlinjnkn(i,j,k,n),i=iputmn,iputmx)
420          continue
             call mskip ( iodmp, iparm(2)-jgetmx, nerr )
430        continue
           call mskip ( iodmp, (iparm(3)-kgetmx)*iparm(2), nerr )
440      continue
         call mskip ( iodmp, (iparm(38)-nmax)*iparm(3)*iparm(2), nerr )
         if (nerr .gt. 0) go to 510
       endif
c
c      Read gravitional potential from real array "rlinjnkn"
c
       if (imacro(5) .eq. 1) then
         call mskip ( iodmp, (iparm(39)-iparm(38))*iparm(3)*iparm(2)
     1              , nerr )
         if (nerr .gt. 0) go to 510
       endif
c
c      Read magnetic variables from real array "rlinjnkn"
c
       if (imacro(6) .eq. 1) then
         nmax =  min ( nt20, iparm(40) )
         do 500 n=iparm(39)+1,nmax
           call mskip ( iodmp, (kgetmn-1)*iparm(2), nerr )
           do 490 k=kputmn,kputmx
             call mskip ( iodmp, jgetmn-1, nerr )
             do 480 j=jputmn,jputmx
               read (iodmp, err=510) (buff    (i      ),i=1,igetmn-1)
     1                             , (rlinjnkn(i,j,k,n),i=iputmn,iputmx)
480          continue
             call mskip ( iodmp, iparm(2)-jgetmx, nerr )
490        continue
           call mskip ( iodmp, (iparm(3)-kgetmx)*iparm(2), nerr )
500      continue
         call mskip ( iodmp, (iparm(40)-nmax)*iparm(3)*iparm(2), nerr )
         if (nerr .gt. 0) go to 510
       endif
c
c      Pad the arrays, if necessary
c
       call padr3d ( rlinjnkn, in, jn, kn, nt20
     1             , iputmn, iputmx, jputmn, jputmx, kputmn, kputmx )
c
c-----------------------------------------------------------------------
c
c      Close restart dump.
c
       close ( unit=iodmp )
c
       if (iolog .gt. 0) write (iolog, 2660) resfile, time, nhy
       if (iotty .gt. 0) write (iotty, 2660) resfile, time, nhy
       nwarn = nwarn0
       return
c
c      Problem reading restart dump "resfile" on unit "iodmp".  ABORTS!
c
510    continue
       if (iolog .gt. 0) then
         write (iolog, 2670) resfile, iodmp
         write (iolog, 2650)
       endif
       if (iotty .gt. 0) then
         write (iotty, 2670) resfile, iodmp
         write (iolog, 2650)
       endif
       stop
c
c-----------------------------------------------------------------------
c----------------------- Write format statements -----------------------
c-----------------------------------------------------------------------
c
2010   format('MGET    : **** WARNING **** Data   partly read:   '
     1       ,'igetmn  =',i4,' > 1.')
2020   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'igetmx  =',i4,' > old in  =',i4,'.')
2030   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'igetmx  =',i4,' < old in  =',i4,'.')
2040   format('MGET    : **** WARNING **** Data   partly read:   '
     1       ,'jgetmn  =',i4,' > 1.')
2050   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'jgetmx  =',i4,' > old jn  =',i4,'.')
2060   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'jgetmx  =',i4,' < old jn  =',i4,'.')
2070   format('MGET    : **** WARNING **** Data   partly read:   '
     1       ,'kgetmn  =',i4,' > 1.')
2080   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'kgetmx  =',i4,' > old kn  =',i4,'.')
2090   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'kgetmx  =',i4,' < old kn  =',i4,'.')
2100   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new niov=',i4,' > old niov=',i4,'.')
2110   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new niov=',i4,' < old niov=',i4,'.')
2120   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nios=',i4,' > old nios=',i4,'.')
2130   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nios=',i4,' < old nios=',i4,'.')
2140   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new ntsl=',i4,' > old ntsl=',i4,'.')
2150   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new ntsl=',i4,' < old ntsl=',i4,'.')
2160   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new mn  =',i4,' > old mn  =',i4,'.')
2170   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new mn  =',i4,' < old mn  =',i4,'.')
2180   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nmd =',i4,' > old nmd =',i4,'.')
2190   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nmd =',i4,' < old nmd =',i4,'.')
2200   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt01=',i4,' > old nt01=',i4,'.')
2210   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt01=',i4,' < old nt01=',i4,'.')
2220   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt02=',i4,' > old nt02=',i4,'.')
2230   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt02=',i4,' < old nt02=',i4,'.')
2240   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt03=',i4,' > old nt03=',i4,'.')
2250   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt03=',i4,' < old nt03=',i4,'.')
2260   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt04=',i4,' > old nt04=',i4,'.')
2270   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt04=',i4,' < old nt04=',i4,'.')
2280   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt05=',i4,' > old nt05=',i4,'.')
2290   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt05=',i4,' < old nt05=',i4,'.')
2300   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt06=',i4,' > old nt06=',i4,'.')
2310   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt06=',i4,' < old nt06=',i4,'.')
2320   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt07=',i4,' > old nt07=',i4,'.')
2330   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt07=',i4,' < old nt07=',i4,'.')
2340   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt08=',i4,' > old nt08=',i4,'.')
2350   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt08=',i4,' < old nt08=',i4,'.')
2360   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt09=',i4,' > old nt09=',i4,'.')
2370   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt09=',i4,' < old nt09=',i4,'.')
2380   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt10=',i4,' > old nt10=',i4,'.')
2390   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt10=',i4,' < old nt10=',i4,'.')
2400   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt11=',i4,' > old nt11=',i4,'.')
2410   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt11=',i4,' < old nt11=',i4,'.')
2420   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt15=',i4,' > old nt15=',i4,'.')
2430   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt15=',i4,' < old nt15=',i4,'.')
2440   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt16=',i4,' > old nt16=',i4,'.')
2450   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt16=',i4,' < old nt16=',i4,'.')
2460   format('MGET    : **** WARNING **** Arrays partly filled: '
     1       ,'new nt20=',i4,' > old nt20=',i4,'.')
2470   format('MGET    : **** WARNING **** Data   partly read  : '
     1       ,'new nt20=',i4,' < old nt20=',i4,'.')
2480   format('MGET    : **** WARNING **** ISYM   set in current  '
     1       ,'run but not in previous run.')
2490   format('MGET    : **** WARNING **** ISYM   set in previous '
     1       ,'run but not in current  run.')
2500   format('MGET    : **** WARNING **** JSYM   set in current  '
     1       ,'run but not in previous run.')
2510   format('MGET    : **** WARNING **** JSYM   set in previous '
     1       ,'run but not in current  run.')
2520   format('MGET    : **** WARNING **** KSYM   set in current  '
     1       ,'run but not in previous run.')
2530   format('MGET    : **** WARNING **** KSYM   set in previous '
     1       ,'run but not in current  run.')
2540   format('MGET    : **** WARNING **** ISO    set in current  '
     1       ,'run but not in previous run.')
2550   format('MGET    : **** WARNING **** ISO    set in previous '
     1       ,'run but not in current  run.')
2560   format('MGET    : **** WARNING **** GRAV   set in current  '
     1       ,'run but not in previous run.')
2570   format('MGET    : **** WARNING **** GRAV   set in previous '
     1       ,'run but not in current  run.')
2580   format('MGET    : **** WARNING **** MHD    set in current  '
     1       ,'run but not in previous run.')
2590   format('MGET    : **** WARNING **** MHD    set in previous '
     1       ,'run but not in current  run.')
2600   format('MGET    : **** WARNING **** TIMESL set in current  '
     1       ,'run but not in previous run.')
2610   format('MGET    : **** WARNING **** TIMESL set in previous '
     1       ,'run but not in current  run.')
2620   format('MGET    : ***** ERROR ***** Parameter in = ',i4
     1       ,' too small to load requested',/
     2       ,'MGET    : data.  Reset "in" to ',i4,' and recompile.')
2630   format('MGET    : ***** ERROR ***** Parameter jn = ',i4
     1       ,' too small to load requested',/
     2       ,'MGET    : data.  Reset "jn" to ',i4,' and recompile.')
2640   format('MGET    : ***** ERROR ***** Parameter kn = ',i4
     1       ,' too small to load requested',/
     2       ,'MGET    : data.  Reset "kn" to ',i4,' and recompile.')
2650   format('MGET    : ABORTS!')
2660   format('MGET    :',/
     1       ,'MGET    : restart dump ',a6,' read successfully.',/
     2       ,'MGET    : Execution resumes ','at time=',1pe12.5
     3       ,', nhy=',i6)
2670   format('MGET    :',/
     1       ,'MGET    : ***** ERROR ***** Problem reading restart '
     2       ,'dump ',a8,' on unit ',i2,'.')
c
       end

      subroutine diffuse_distr
c
c    abcd:zeus3d.distr_evolve <--- Diffuses the already created particles
c          that have already undergone expansion in the shells.  The particles
c          are able to diffuse into neighbouring shell.
c
c                                                        DATE 07/01/02
c
c    written by: Ken Rice
c    modified 1:
c
c    modified by: Gang Li 02/21/2003    
c
c    modified by: Gang Li 03/11/2003: Add heavy ions
c    modified by: Gang Li 01/23/2004: 
c     1) Move code to after add_acc_ptcls.f in zeus3d.f
c     2) Write out current J = num /(MeV cm^2 s) at the shock front
c        to file dist_shock.dat (file 78) in the format
c        e, j, j_hi, r, t
c     3) Write out the content of distr_array(no_shells, p_int) to
c        file (96).
c     4) write out esc_number_up(p_int), x1a(shock_begin)+4.0D0*temp,
c        and time to file (88).
c     5) write out esc_number_up_hi(p_int), x1a(shock_begin)+4.0D0*temp,
c        and time to file (89).
c        
c
c
c  PURPOSE:
c
c
c  LOCAL VARIABLES:
c
c  EXTERNALS:
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
c
c-----------------------------------------------------------------------
c--------------------------- ROOT VARIABLES ----------------------------
c-----------------------------------------------------------------------
c
c============================ DECLARATIONS =============================
c
c------------------------- boundary variables --------------------------
c
c      Inner and outer i-boundaries
c
       integer       niib    (  jn,  kn), noib    (  jn,  kn)
     1             , niib2   (  jn,  kn), noib2   (  jn,  kn)
     2             , niib3   (  jn,  kn), noib3   (  jn,  kn)
     3             , niib23  (  jn,  kn), noib23  (  jn,  kn)
c
       real*8        diib1   (  jn,  kn), doib1   (  jn,  kn)
     1             , diib2   (  jn,  kn), doib2   (  jn,  kn)
     2             , v1iib1  (  jn,  kn), v1oib1  (  jn,  kn)
     3             , v1iib2  (  jn,  kn), v1oib2  (  jn,  kn)
     4             , v2iib1  (  jn,  kn), v2oib1  (  jn,  kn)
     5             , v2iib2  (  jn,  kn), v2oib2  (  jn,  kn)
     6             , v3iib1  (  jn,  kn), v3oib1  (  jn,  kn)
     7             , v3iib2  (  jn,  kn), v3oib2  (  jn,  kn)
       real*8        eiib1   (  jn,  kn), eoib1   (  jn,  kn)
     1             , eiib2   (  jn,  kn), eoib2   (  jn,  kn)
       real*8        b1iib1  (  jn,  kn), b1oib1  (  jn,  kn)
     1             , b1iib2  (  jn,  kn), b1oib2  (  jn,  kn)
     2             , b2iib1  (  jn,  kn), b2oib1  (  jn,  kn)
     3             , b2iib2  (  jn,  kn), b2oib2  (  jn,  kn)
     4             , b3iib1  (  jn,  kn), b3oib1  (  jn,  kn)
     5             , b3iib2  (  jn,  kn), b3oib2  (  jn,  kn)
     6             , emf1iib1(  jn,  kn), emf1oib1(  jn,  kn)
     7             , emf1iib2(  jn,  kn), emf1oib2(  jn,  kn)
     7             , emf1iib3(  jn,  kn), emf1oib3(  jn,  kn)
     8             , emf2iib1(  jn,  kn), emf2oib1(  jn,  kn)
       real*8        emf2iib2(  jn,  kn), emf2oib2(  jn,  kn)
     1             , emf2iib3(  jn,  kn), emf2oib3(  jn,  kn)
     1             , emf3iib1(  jn,  kn), emf3oib1(  jn,  kn)
     2             , emf3iib2(  jn,  kn), emf3oib2(  jn,  kn)
     3             , emf3iib3(  jn,  kn), emf3oib3(  jn,  kn)
     4             , a1iib1  (  jn,  kn)
     5             , a1iib2  (  jn,  kn)
     6             , a1iib3  (  jn,  kn)
     6             , a1iib4  (  jn,  kn)
     7             , a2iib1  (  jn,  kn)
       real*8        a2iib2  (  jn,  kn)
     1             , a2iib3  (  jn,  kn)
     1             , a2iib4  (  jn,  kn)
     1             , a3iib1  (  jn,  kn)
     2             , a3iib2  (  jn,  kn)
     3             , a3iib3  (  jn,  kn)
     4             , a3iib4  (  jn,  kn)
c
c      Inner and outer k-boundaries
c
       integer       nikb    (  in,  jn), nokb    (  in,  jn)
     1             , nikb1   (  in,  jn), nokb1   (  in,  jn)
     2             , nikb2   (  in,  jn), nokb2   (  in,  jn)
     3             , nikb12  (  in,  jn), nokb12  (  in,  jn)
c
       real*8        dikb1   (  in,  jn), dokb1   (  in,  jn)
     1             , dikb2   (  in,  jn), dokb2   (  in,  jn)
     2             , v1ikb1  (  in,  jn), v1okb1  (  in,  jn)
     3             , v1ikb2  (  in,  jn), v1okb2  (  in,  jn)     
     4             , v2ikb1  (  in,  jn), v2okb1  (  in,  jn)
     5             , v2ikb2  (  in,  jn), v2okb2  (  in,  jn)
     6             , v3ikb1  (  in,  jn), v3okb1  (  in,  jn)
     7             , v3ikb2  (  in,  jn), v3okb2  (  in,  jn)
       real*8        eikb1   (  in,  jn), eokb1   (  in,  jn)
     1             , eikb2   (  in,  jn), eokb2   (  in,  jn)
       real*8        b1ikb1  (  in,  jn), b1okb1  (  in,  jn)
     1             , b1ikb2  (  in,  jn), b1okb2  (  in,  jn)
     2             , b2ikb1  (  in,  jn), b2okb1  (  in,  jn)
     3             , b2ikb2  (  in,  jn), b2okb2  (  in,  jn)
     4             , b3ikb1  (  in,  jn), b3okb1  (  in,  jn)
     5             , b3ikb2  (  in,  jn), b3okb2  (  in,  jn)
     6             , emf1ikb1(  in,  jn), emf1okb1(  in,  jn)
     7             , emf1ikb2(  in,  jn), emf1okb2(  in,  jn)
     8             , emf1ikb3(  in,  jn), emf1okb3(  in,  jn)
     9             , emf2ikb1(  in,  jn), emf2okb1(  in,  jn)
       real*8        emf2ikb2(  in,  jn), emf2okb2(  in,  jn)
     1             , emf2ikb3(  in,  jn), emf2okb3(  in,  jn)
     2             , emf3ikb1(  in,  jn), emf3okb1(  in,  jn)
     3             , emf3ikb2(  in,  jn), emf3okb2(  in,  jn)
     3             , emf3ikb3(  in,  jn), emf3okb3(  in,  jn)
c
c------------------------- display variables ---------------------------
c
       integer       iswdis  , idisdmp , ndis    , mdis
       real*8        tdis    , dtdis
c
       character*2   disvar  (niov)
       integer       idismn  (nios), jdismn  (nios), kdismn  (nios)
     1             , idismx  (nios), jdismx  (nios), kdismx  (nios)
     2             , idisdir (nios), ldis    (nios)
c
c-------------------------- field variables ----------------------------
c
       real*8        d      (  in,  jn,  kn), v1     (  in,  jn,  kn)
     1             , v2     (  in,  jn,  kn), v3     (  in,  jn,  kn)
     2             , e      (  in,  jn,  kn)
     4             , b1     (  in,  jn,  kn), b2     (  in,  jn,  kn)
     5             , b3     (  in,  jn,  kn)
c
c---------------------- essential grid variables -----------------------
c
       integer       ismn    , is      , iemx    , ie      , ione
     1             , jsmn    , js      , jemx    , je      , jone
     2             , ksmn    , ks      , kemx    , ke      , kone
     3             , ia      , ja      , ka      , igcon
       real*8        x1scale , x2scale , x3scale , x1fac   , x2fac
     1             , x3fac
c
       integer       istretch(   4), jstretch(   4), kstretch(   4)
       real*8        x1a     (  in), x2a     (  jn), x3a     (  kn)
c
c---------------------------- HDF variables ----------------------------
c
       integer       iswhdf  , ihdfdmp , nhdf
       real*8        thdf    , dthdf
c
       character*2   hdfvar  (niov)
c
c--------------------------- pixel variables ---------------------------
c
       integer       iswpix  , ipixdmp , npix    , mpix    , ipixmm
     1             , ncpix   , rorhpix , iref    , jref
       real*8        tpix    , dtpix
c
       character*2   pixvar  (niov)
       integer       nlpix   (niov)
       integer       ipixdir (nios), lpix    (nios), npi     (nios)
     1             , npj     (nios)
       real*8        pixmin  (niov), pixmax  (niov)
       real*8        x1pxmn  (nios), x2pxmn  (nios), x3pxmn  (nios)
     1             , x1pxmx  (nios), x2pxmx  (nios), x3pxmx  (nios)
c
c------------------------- 1-D NCAR variables --------------------------
c
       integer       iswplt1 , iplt1dmp, nplt1   , mplt1   , iplt1mm
     1             , corl
       real*8        tplt1   , dtplt1
c
       character*2   plt1var (niov)
       integer       nlplt1  (niov)
       integer       iplt1   (nios), jplt1   (nios), kplt1   (nios)
     1             , iplt1dir(nios)
       real*8        plt1min (niov), plt1max (niov)
c
c------------------------- 2-D NCAR variables --------------------------
c
       integer       iswplt2 , iplt2dmp, nplt2   , mplt2   , iplt2mm
     1             , numcl   , incvx   , incvy
       real*8        tplt2   , dtplt2  , vscale
c
       character*2   plt2var (niov)
       integer       nlplt2  (niov)
       integer       iplt2dir(nios), lplt2   (nios)
       real*8        plt2min (niov), plt2max (niov)
       real*8        x1p2mn  (nios), x1p2mx  (nios), x2p2mn  (nios)
     1             , x2p2mx  (nios), x3p2mn  (nios), x3p2mx  (nios)
c
c--------------------------- RADIO variables ---------------------------
c
       integer       iswrad  , iraddmp , nrad    , iradmm  , ncrad
     1             , rorhrad , incpx   , incpy   , itype   , ntheta
     2             , nphi    , icnvlv  , eorb    , porf    , bworb
     3             , nisc    , njsc
       real*8        trad    , dtrad   , x1rdmn  , x2rdmn  , x3rdmn
     1             , x1rdmx  , x2rdmx  , x3rdmx  , theta   , thetamin
     2             , thetamax, dtheta  , phi     , phimin  , phimax
     3             , dphi    , alpha   , freq    , dsw     , btsw
     4             , dlower  , elower  , selower , pblower , shlower
     5             , vvlower , dupper  , eupper  , seupper , pbupper
     6             , shupper , vvupper , bmajor  , bminor  , bpa
     7             , cpb     , icut    , pcut    , vlmin   , pscale
c
       character*2   radvar  (niov)
       integer       nlrad   (niov)
       real*8        radmin  (niov), radmax  (niov)
c
c-------------------------- sundry variables ---------------------------
c
       integer       iswint  , iswdmp  , iresdmp , ilogdmp , incdmp
     1             , iord    , iordb1  , iordb2  , iordb3  , iordd
     2             , iorde   , iords1  , iords2  , iords3  , ippa
     3             , istp    , istpb1  , istpb2  , istpb3  , istpd
     4             , istpe   , istps1  , istps2  , istps3  , ifsen
     5             , nhy     , nlim    , nwarn   , ix1x2x3 , icool
     6             , itote   , imxd    , nmat    , iwiggle , ibpol
     7             , ijetmn  , ijetmx  , jjetmn  , jjetmx  , kjetmn
     8             , kjetmx  , igpiib
     9             , igpoib  , igpijb  , igpojb  , igpikb  , igpokb
       real*8        tdmp    , b1floor , b2floor , b3floor , dfloor
     1             , efloor  , v1floor , v2floor , v3floor , time
     2             , tlim    , trem    , tsave   , ttotal  , tused
     3             , dt      , dtrat   , dtmin   , dtnew   , dtcs
     4             , dtal    , dtqq    , dtqqi2  , dtv1    , dtv2
     5             , dtv3    , courno  , qcon    , qlin    , omega
     6             , thetai  , thetaj  , thetak  , rmode   , mamb
     7             , zsigma  , wnz     , ojet    , sig1    , sig2
     8             , sig3    , xibgen  , rjet    , g       , ptmass
     9             , x1ptm   , x2ptm   , x3ptm
c
       integer       niso    (  mn)
       real*8        ciso    (  mn), rmetal  (  mn), gam     (  mn)
     1             , gamma   (  mn), rgas    (  mn)
c
c------------------------ time slice variables -------------------------
c
       integer       iswtsl  , iswtslp , itsldmp , itslpdmp
       real*8        ttsl    , ttslp   , dttsl   , dttslp  , tslpmn
     1             , tslpmx
c
       real*8        timetsl (ntsl), massp   (ntsl), x1cmp   (ntsl)
     1             , x2cmp   (ntsl), x3cmp   (ntsl), eintp   (ntsl)
     2             , ek1p    (ntsl), ek2p    (ntsl), ek3p    (ntsl)
     3             , ekp     (ntsl), epotp   (ntsl), tep     (ntsl)
     4             , l1p     (ntsl), l2p     (ntsl), l3p     (ntsl)
     5             , dminp   (ntsl), dmaxp   (ntsl), seminp  (ntsl)
     6             , semaxp  (ntsl), pminp   (ntsl), pmaxp   (ntsl)
     7             , v1minp  (ntsl), v1maxp  (ntsl), v2minp  (ntsl)
     8             , v2maxp  (ntsl), v3minp  (ntsl), v3maxp  (ntsl)
     9             , vminp   (ntsl), vmaxp   (ntsl), dtcsp   (ntsl)
       real*8        dtv1p   (ntsl), dtv2p   (ntsl), dtv3p   (ntsl)
     1             , dtqqp   (ntsl), dtnewp  (ntsl), emag1p  (ntsl)
     2             , emag2p  (ntsl), emag3p  (ntsl), emagp   (ntsl)
     3             , b1flxp  (ntsl), b2flxp  (ntsl), b3flxp  (ntsl)
     4             , dvbp    (ntsl), b1minp  (ntsl), b1maxp  (ntsl)
     5             , b2minp  (ntsl), b2maxp  (ntsl), b3minp  (ntsl)
     6             , b3maxp  (ntsl), bminp   (ntsl), bmaxp   (ntsl)
     7             , dvbminp (ntsl), dvbmaxp (ntsl), dtalp   (ntsl)
c
c------------------------- user dump variables -------------------------
c
       integer       iswusr  , iusrdmp
       real*8        tusr    , dtusr
c
c--------------------------- voxel variables ---------------------------
c
       integer       iswvox  , ivoxdmp , nvox    , ivoxmm  , ncvox
     1             , rorhvox , nvi     , nvj     , nvk
       real*8        tvox    , dtvox   , x1vxmn  , x2vxmn  , x3vxmn
     1             , x1vxmx  , x2vxmx  , x3vxmx
c
       character*2   voxvar  (niov)
       integer       nlvox   (niov)
       real*8        voxmin  (niov), voxmax  (niov)
c
c======================== EQUIVALENCE STATEMENTS =======================
c
c------------------------------- scalars -------------------------------
c
       integer       insc    (nt01)
       real*8        rlsc    (nt02)
c
       equivalence
     1   (insc(  1),iswdis  ),(insc(  2),idisdmp ),(insc(  3),ndis    )
     2  ,(insc(  4),mdis    )
       equivalence
     1   (insc( 31),ismn    ),(insc( 32),is      ),(insc( 33),iemx    )
     2  ,(insc( 34),ie      ),(insc( 35),ione    ),(insc( 36),jsmn    )
     3  ,(insc( 37),js      ),(insc( 38),jemx    ),(insc( 39),je      )
     4  ,(insc( 40),jone    ),(insc( 41),ksmn    ),(insc( 42),ks      )
     5  ,(insc( 43),kemx    ),(insc( 44),ke      ),(insc( 45),kone    )
     6  ,(insc( 46),ia      ),(insc( 47),ja      ),(insc( 48),ka      )
     7  ,(insc( 49),igcon   )
       equivalence
     1   (insc( 91),istretch),(insc( 95),jstretch),(insc( 99),kstretch)
       equivalence
     1   (insc(121),iswhdf  ),(insc(122),ihdfdmp ),(insc(123),nhdf    )
       equivalence
     1   (insc(151),iswpix  ),(insc(152),ipixdmp ),(insc(153),npix    )
     2  ,(insc(154),mpix    ),(insc(155),ipixmm  ),(insc(156),ncpix   )
     3  ,(insc(157),rorhpix ),(insc(158),iref    ),(insc(159),jref    )
       equivalence
     1   (insc(181),iswplt1 ),(insc(182),iplt1dmp),(insc(183),nplt1   )
     2  ,(insc(184),mplt1   ),(insc(185),iplt1mm ),(insc(186),corl    )
       equivalence
     1   (insc(211),iswplt2 ),(insc(212),iplt2dmp),(insc(213),nplt2   )
     2  ,(insc(214),mplt2   ),(insc(215),iplt2mm ),(insc(216),numcl   )
     3  ,(insc(217),incvx   ),(insc(218),incvy   )
       equivalence
     1   (insc(241),iswrad  ),(insc(242),iraddmp ),(insc(243),nrad    )
     2  ,(insc(244),iradmm  ),(insc(245),ncrad   ),(insc(246),rorhrad )
     3  ,(insc(247),incpx   ),(insc(248),incpy   ),(insc(249),itype   )
     4  ,(insc(250),ntheta  ),(insc(251),nphi    ),(insc(252),icnvlv  )
     5  ,(insc(253),eorb    ),(insc(254),porf    ),(insc(255),bworb   )
     6  ,(insc(256),nisc    ),(insc(257),njsc    )
       equivalence
     1   (insc(331),iswint  ),(insc(332),iswdmp  ),(insc(333),iresdmp )
     2  ,(insc(334),ilogdmp ),(insc(335),incdmp  ),(insc(336),iord    )
     3  ,(insc(337),iordb1  ),(insc(338),iordb2  ),(insc(339),iordb3  )
     4  ,(insc(340),iordd   ),(insc(341),iorde   ),(insc(342),iords1  )
     5  ,(insc(343),iords2  ),(insc(344),iords3  ),(insc(345),ippa    )
     6  ,(insc(346),istp    ),(insc(347),istpb1  ),(insc(348),istpb2  )
     7  ,(insc(349),istpb3  ),(insc(350),istpd   ),(insc(351),istpe   )
     8  ,(insc(352),istps1  ),(insc(353),istps2  ),(insc(354),istps3  )
     9  ,(insc(355),ifsen   ),(insc(356),nhy     ),(insc(357),nlim    )
       equivalence
     1   (insc(358),nwarn   ),(insc(359),ix1x2x3 ),(insc(360),icool   )
     2  ,(insc(361),itote   ),(insc(362),imxd    ),(insc(363),nmat    )
     3  ,(insc(364),iwiggle ),(insc(365),ibpol   ),(insc(366),ijetmn  )
     4  ,(insc(367),ijetmx  ),(insc(368),jjetmn  ),(insc(369),jjetmx  )
     5  ,(insc(370),kjetmn  ),(insc(371),kjetmx  )
       equivalence
     1   (insc(375),igpiib  )
     2  ,(insc(376),igpoib  ),(insc(377),igpijb  ),(insc(378),igpojb  )
     3  ,(insc(379),igpikb  ),(insc(380),igpokb  )
       equivalence
     1   (insc(451),iswtsl  ),(insc(452),iswtslp ),(insc(453),itsldmp )
     2  ,(insc(454),itslpdmp)
       equivalence
     1   (insc(481),iswusr  ),(insc(482),iusrdmp )
       equivalence
     1   (insc(511),iswvox  ),(insc(512),ivoxdmp ),(insc(513),nvox    )
     2  ,(insc(514),ivoxmm  ),(insc(515),ncvox   ),(insc(516),rorhvox )
     3  ,(insc(517),nvi     ),(insc(518),nvj     ),(insc(519),nvk     )
c
       equivalence
     1   (rlsc(  1),tdis    ),(rlsc(  2),dtdis   )
       equivalence
     1   (rlsc( 31),x1scale ),(rlsc( 32),x2scale ),(rlsc( 33),x3scale )
     2  ,(rlsc( 34),x1fac   ),(rlsc( 35),x2fac   ),(rlsc( 36),x3fac   )
       equivalence
     1   (rlsc(121),thdf    ),(rlsc(122),dthdf   )
       equivalence
     1   (rlsc(151),tpix    ),(rlsc(152),dtpix   )
       equivalence
     1   (rlsc(181),tplt1   ),(rlsc(182),dtplt1  )
       equivalence
     1   (rlsc(211),tplt2   ),(rlsc(212),dtplt2  ),(rlsc(213),vscale  )
       equivalence
     1   (rlsc(241),trad    ),(rlsc(242),dtrad   ),(rlsc(243),x1rdmn  )
     2  ,(rlsc(244),x2rdmn  ),(rlsc(245),x3rdmn  ),(rlsc(246),x1rdmx  )
     3  ,(rlsc(247),x2rdmx  ),(rlsc(248),x3rdmx  ),(rlsc(249),theta   )
     4  ,(rlsc(250),thetamin),(rlsc(251),thetamax),(rlsc(252),dtheta  )
     5  ,(rlsc(253),phi     ),(rlsc(254),phimin  ),(rlsc(255),phimax  )
     6  ,(rlsc(256),dphi    ),(rlsc(257),alpha   ),(rlsc(258),freq    )
     7  ,(rlsc(259),dsw     ),(rlsc(260),btsw    ),(rlsc(261),dlower  )
     8  ,(rlsc(262),elower  ),(rlsc(263),selower ),(rlsc(264),pblower )
     9  ,(rlsc(265),shlower ),(rlsc(266),vvlower ),(rlsc(267),dupper  )
       equivalence
     1   (rlsc(268),eupper  ),(rlsc(269),seupper ),(rlsc(270),pbupper )
     2  ,(rlsc(271),shupper ),(rlsc(272),vvupper ),(rlsc(273),bmajor  )
     3  ,(rlsc(274),bminor  ),(rlsc(275),bpa     ),(rlsc(276),cpb     )
     4  ,(rlsc(277),icut    ),(rlsc(278),pcut    ),(rlsc(279),vlmin   )
     5  ,(rlsc(280),pscale  )
       equivalence
     1   (rlsc(331),tdmp    ),(rlsc(332),b1floor ),(rlsc(333),b2floor )
     2  ,(rlsc(334),b3floor ),(rlsc(335),dfloor  ),(rlsc(336),efloor  )
     3  ,(rlsc(337),v1floor ),(rlsc(338),v2floor ),(rlsc(339),v3floor )
     4  ,(rlsc(340),time    ),(rlsc(341),tlim    ),(rlsc(342),trem    )
     5  ,(rlsc(343),tsave   ),(rlsc(344),ttotal  ),(rlsc(345),tused   )
     6  ,(rlsc(346),dt      ),(rlsc(347),dtrat   ),(rlsc(348),dtmin   )
     7  ,(rlsc(349),dtnew   ),(rlsc(350),dtcs    ),(rlsc(351),dtal    )
     8  ,(rlsc(352),dtv1    ),(rlsc(353),dtv2    ),(rlsc(354),dtv3    )
     1  ,(rlsc(355),dtqq    ),(rlsc(356),dtqqi2  ),(rlsc(357),courno  )
       equivalence
     1   (rlsc(358),qcon    ),(rlsc(359),qlin    ),(rlsc(360),omega   )
     2  ,(rlsc(361),thetai  ),(rlsc(362),thetaj  ),(rlsc(363),thetak  )
     3  ,(rlsc(364),rmode   ),(rlsc(365),mamb    ),(rlsc(366),zsigma  )
     4  ,(rlsc(367),wnz     ),(rlsc(368),ojet    ),(rlsc(369),sig1    )
     5  ,(rlsc(370),sig2    ),(rlsc(371),sig3    ),(rlsc(372),xibgen  )
     6  ,(rlsc(373),rjet    ),(rlsc(374),g       ),(rlsc(375),ptmass  )
     6  ,(rlsc(376),x1ptm   ),(rlsc(377),x2ptm   ),(rlsc(378),x3ptm   )
       equivalence
     1   (rlsc(451),ttsl    ),(rlsc(452),ttslp   ),(rlsc(453),dttsl   )
     2  ,(rlsc(454),dttslp  ),(rlsc(455),tslpmn  ),(rlsc(456),tslpmx  )
       equivalence
     1   (rlsc(481),tusr    ),(rlsc(482),dtusr   )
       equivalence
     1   (rlsc(511),tvox    ),(rlsc(512),dtvox   ),(rlsc(513),x1vxmn  )
     2  ,(rlsc(514),x1vxmx  ),(rlsc(515),x2vxmn  ),(rlsc(516),x2vxmx  )
     3  ,(rlsc(517),x3vxmn  ),(rlsc(518),x3vxmx  )
c
c----------------------------- 1-D arrays ------------------------------
c
       character*2   c2niov  (niov,nt03)
       integer       inniov  (niov,nt04), innios  (nios,nt05)
     1             , inmn    (  mn,nt06)
       real*8        rlniov  (niov,nt07), rlnios  (nios,nt08)
     1             , rlmn    (  mn,nt09)
     2             , rlntsl  (ntsl,nt10)
c
       equivalence
     1    (c2niov  (1,  1), disvar  ), (c2niov  (1,  2), hdfvar  )
     2  , (c2niov  (1,  3), pixvar  ), (c2niov  (1,  4), plt1var )
     3  , (c2niov  (1,  5), plt2var ), (c2niov  (1,  6), radvar  )
     4  , (c2niov  (1,  7), voxvar  )
c
       equivalence
     1    (inniov  (1,  1), nlpix   ), (inniov  (1,  2), nlplt1  )
     2  , (inniov  (1,  3), nlplt2  ), (inniov  (1,  4), nlrad   )
     3  , (inniov  (1,  5), nlvox   )
       equivalence
     1    (innios  (1,  1), idisdir ), (innios  (1,  2), ldis    )
     2  , (innios  (1,  3), idismn  ), (innios  (1,  4), jdismn  )
     3  , (innios  (1,  5), kdismn  ), (innios  (1,  6), idismx  )
     4  , (innios  (1,  7), jdismx  ), (innios  (1,  8), kdismx  )
     5  , (innios  (1,  9), ipixdir ), (innios  (1, 10), lpix    )
     6  , (innios  (1, 11), npi     ), (innios  (1, 12), npj     )
     7  , (innios  (1, 13), iplt1   ), (innios  (1, 14), jplt1   )
     8  , (innios  (1, 15), kplt1   ), (innios  (1, 16), iplt1dir)
     9  , (innios  (1, 17), iplt2dir), (innios  (1, 18), lplt2   )
       equivalence
     1    (inmn    (1,  1), niso    )
c
       equivalence
     1    (rlniov  (1,  1), pixmin  ), (rlniov  (1,  2), pixmax  )
     2  , (rlniov  (1,  3), plt1min ), (rlniov  (1,  4), plt1max )
     3  , (rlniov  (1,  5), plt2min ), (rlniov  (1,  6), plt2max )
     4  , (rlniov  (1,  7), radmin  ), (rlniov  (1,  8), radmax  )
     5  , (rlniov  (1,  9), voxmin  ), (rlniov  (1, 10), voxmax  )
       equivalence
     1    (rlnios  (1,  1), x1pxmn  ), (rlnios  (1,  2), x2pxmn  )
     2  , (rlnios  (1,  3), x3pxmn  ), (rlnios  (1,  4), x1pxmx  )
     3  , (rlnios  (1,  5), x2pxmx  ), (rlnios  (1,  6), x3pxmx  )
     4  , (rlnios  (1,  7), x1p2mn  ), (rlnios  (1,  8), x2p2mn  )
     5  , (rlnios  (1,  9), x3p2mn  ), (rlnios  (1, 10), x1p2mx  )
     6  , (rlnios  (1, 11), x2p2mx  ), (rlnios  (1, 12), x3p2mx  )
       equivalence
     1    (rlmn    (1,  1), ciso    ), (rlmn    (1,  2), rmetal  )
     2  , (rlmn    (1,  3), gam     ), (rlmn    (1,  4), gamma   )
     3  , (rlmn    (1,  5), rgas    )
       equivalence
     1    (rlntsl  (1,  1), timetsl ), (rlntsl  (1,  2), massp   )
     2  , (rlntsl  (1,  3), x1cmp   ), (rlntsl  (1,  4), x2cmp   )
     3  , (rlntsl  (1,  5), x3cmp   ), (rlntsl  (1,  6), eintp   )
     4  , (rlntsl  (1,  7), ek1p    ), (rlntsl  (1,  8), ek2p    )
     5  , (rlntsl  (1,  9), ek3p    ), (rlntsl  (1, 10), ekp     )
     6  , (rlntsl  (1, 11), epotp   ), (rlntsl  (1, 12), tep     )
     7  , (rlntsl  (1, 13), l1p     ), (rlntsl  (1, 14), l2p     )
     8  , (rlntsl  (1, 15), l3p     ), (rlntsl  (1, 16), dminp   )
     9  , (rlntsl  (1, 17), dmaxp   ), (rlntsl  (1, 18), seminp  )
       equivalence
     1    (rlntsl  (1, 19), semaxp  ), (rlntsl  (1, 20), pminp   )
     2  , (rlntsl  (1, 21), pmaxp   ), (rlntsl  (1, 22), v1minp  )
     3  , (rlntsl  (1, 23), v1maxp  ), (rlntsl  (1, 24), v2minp  )
     4  , (rlntsl  (1, 25), v2maxp  ), (rlntsl  (1, 26), v3minp  )
     5  , (rlntsl  (1, 27), v3maxp  ), (rlntsl  (1, 28), vminp   )
     6  , (rlntsl  (1, 29), vmaxp   ), (rlntsl  (1, 30), dtcsp   )
     7  , (rlntsl  (1, 31), dtv1p   ), (rlntsl  (1, 32), dtv2p   )
     8  , (rlntsl  (1, 33), dtv3p   ), (rlntsl  (1, 34), dtqqp   )
     9  , (rlntsl  (1, 35), dtnewp  ), (rlntsl  (1, 36), emag1p  )
       equivalence
     1    (rlntsl  (1, 37), emag2p  ), (rlntsl  (1, 38), emag3p  )
     2  , (rlntsl  (1, 39), emagp   ), (rlntsl  (1, 40), b1flxp  )
     3  , (rlntsl  (1, 41), b2flxp  ), (rlntsl  (1, 42), b3flxp  )
     4  , (rlntsl  (1, 43), dvbp    ), (rlntsl  (1, 44), b1minp  )
     5  , (rlntsl  (1, 45), b1maxp  ), (rlntsl  (1, 46), b2minp  )
     6  , (rlntsl  (1, 47), b2maxp  ), (rlntsl  (1, 48), b3minp  )
     7  , (rlntsl  (1, 49), b3maxp  ), (rlntsl  (1, 50), bminp   )
     8  , (rlntsl  (1, 51), bmaxp   ), (rlntsl  (1, 52), dvbminp )
     9  , (rlntsl  (1, 53), dvbmaxp ), (rlntsl  (1, 54), dtalp   )
c
c----------------------------- 2-D arrays ------------------------------
c
       integer       injnkn  (  jn,  kn,nt11)
       real*8        rljnkn  (  jn,  kn,nt16)
c
       equivalence
     1   (injnkn(1,1,      1),niib    ),(injnkn(1,1,      2),noib    )
     2  ,(injnkn(1,1,      3),niib2   ),(injnkn(1,1,      4),noib2   )
     3  ,(injnkn(1,1,      5),niib3   ),(injnkn(1,1,      6),noib3   )
     4  ,(injnkn(1,1,      7),niib23  ),(injnkn(1,1,      8),noib23  )
       equivalence
     1   (rljnkn(1,1,      1),diib1   ),(rljnkn(1,1,      2),doib1   )
     2  ,(rljnkn(1,1,      3),diib2   ),(rljnkn(1,1,      4),doib2   )
     3  ,(rljnkn(1,1,      5),v1iib1  ),(rljnkn(1,1,      6),v1oib1  )
     4  ,(rljnkn(1,1,      7),v1iib2  ),(rljnkn(1,1,      8),v1oib2  )
     5  ,(rljnkn(1,1,      9),v2iib1  ),(rljnkn(1,1,     10),v2oib1  )
     6  ,(rljnkn(1,1,     11),v2iib2  ),(rljnkn(1,1,     12),v2oib2  )
     7  ,(rljnkn(1,1,     13),v3iib1  ),(rljnkn(1,1,     14),v3oib1  )
     8  ,(rljnkn(1,1,     15),v3iib2  ),(rljnkn(1,1,     16),v3oib2  )
       equivalence
     1   (rljnkn(1,1,nt12+ 1),eiib1   ),(rljnkn(1,1,nt12+ 2),eoib1   )
     2  ,(rljnkn(1,1,nt12+ 3),eiib2   ),(rljnkn(1,1,nt12+ 4),eoib2   )
       equivalence
     1   (rljnkn(1,1,nt14+ 1),b1iib1  ),(rljnkn(1,1,nt14+ 2),b1oib1  )
     2  ,(rljnkn(1,1,nt14+ 3),b1iib2  ),(rljnkn(1,1,nt14+ 4),b1oib2  )
     3  ,(rljnkn(1,1,nt14+ 5),b2iib1  ),(rljnkn(1,1,nt14+ 6),b2oib1  )
     4  ,(rljnkn(1,1,nt14+ 7),b2iib2  ),(rljnkn(1,1,nt14+ 8),b2oib2  )
     5  ,(rljnkn(1,1,nt14+ 9),b3iib1  ),(rljnkn(1,1,nt14+10),b3oib1  )
     6  ,(rljnkn(1,1,nt14+11),b3iib2  ),(rljnkn(1,1,nt14+12),b3oib2  )
     7  ,(rljnkn(1,1,nt14+13),emf1iib1),(rljnkn(1,1,nt14+14),emf1oib1)
     8  ,(rljnkn(1,1,nt14+15),emf1iib2),(rljnkn(1,1,nt14+16),emf1oib2)
     8  ,(rljnkn(1,1,nt14+17),emf1iib3),(rljnkn(1,1,nt14+18),emf1oib3)
       equivalence
     9   (rljnkn(1,1,nt14+19),emf2iib1),(rljnkn(1,1,nt14+20),emf2oib1)
     1  ,(rljnkn(1,1,nt14+21),emf2iib2),(rljnkn(1,1,nt14+22),emf2oib2)
     2  ,(rljnkn(1,1,nt14+23),emf2iib3),(rljnkn(1,1,nt14+24),emf2oib3)
     3  ,(rljnkn(1,1,nt14+25),emf3iib1),(rljnkn(1,1,nt14+26),emf3oib1)
     4  ,(rljnkn(1,1,nt14+27),emf3iib2),(rljnkn(1,1,nt14+28),emf3oib2)
     5  ,(rljnkn(1,1,nt14+29),emf3iib3),(rljnkn(1,1,nt14+30),emf3oib3)
     6  ,(rljnkn(1,1,nt14+31),a1iib1  ),(rljnkn(1,1,nt14+32),a1iib2  )
     7  ,(rljnkn(1,1,nt14+33),a1iib3  ),(rljnkn(1,1,nt14+34),a1iib4  )
     1  ,(rljnkn(1,1,nt14+35),a2iib1  ),(rljnkn(1,1,nt14+36),a2iib2  )
       equivalence
     8   (rljnkn(1,1,nt14+37),a2iib3  ),(rljnkn(1,1,nt14+38),a2iib4  )
     9  ,(rljnkn(1,1,nt14+39),a3iib1  ),(rljnkn(1,1,nt14+40),a3iib2  )
     1  ,(rljnkn(1,1,nt14+41),a3iib3  ),(rljnkn(1,1,nt14+42),a3iib4  )
c
       integer       inknin
       real*8        rlknin
c
       integer       ininjn  (  in,  jn,nt11)
       real*8        rlinjn  (  in,  jn,nt15)
c
       equivalence
     1   (ininjn(1,1,      1),nikb    ),(ininjn(1,1,      2),nokb    )
     2  ,(ininjn(1,1,      3),nikb1   ),(ininjn(1,1,      4),nokb1   )
     3  ,(ininjn(1,1,      5),nikb2   ),(ininjn(1,1,      6),nokb2   )
     4  ,(ininjn(1,1,      7),nikb12  ),(ininjn(1,1,      8),nokb12  )
       equivalence
     1   (rlinjn(1,1,      1),dikb1   ),(rlinjn(1,1,      2),dokb1   )
     2  ,(rlinjn(1,1,      3),dikb2   ),(rlinjn(1,1,      4),dokb2   )
     3  ,(rlinjn(1,1,      5),v1ikb1  ),(rlinjn(1,1,      6),v1okb1  )
     4  ,(rlinjn(1,1,      7),v1ikb2  ),(rlinjn(1,1,      8),v1okb2  )
     5  ,(rlinjn(1,1,      9),v2ikb1  ),(rlinjn(1,1,     10),v2okb1  )
     6  ,(rlinjn(1,1,     11),v2ikb2  ),(rlinjn(1,1,     12),v2okb2  )
     7  ,(rlinjn(1,1,     13),v3ikb1  ),(rlinjn(1,1,     14),v3okb1  )
     8  ,(rlinjn(1,1,     15),v3ikb2  ),(rlinjn(1,1,     16),v3okb2  )
       equivalence
     1   (rlinjn(1,1,nt12+ 1),eikb1   ),(rlinjn(1,1,nt12+ 2),eokb1   )
     2  ,(rlinjn(1,1,nt12+ 3),eikb2   ),(rlinjn(1,1,nt12+ 4),eokb2   )
       equivalence
     1   (rlinjn(1,1,nt14+ 1),b1ikb1  ),(rlinjn(1,1,nt14+ 2),b1okb1  )
     2  ,(rlinjn(1,1,nt14+ 3),b1ikb2  ),(rlinjn(1,1,nt14+ 4),b1okb2  )
     3  ,(rlinjn(1,1,nt14+ 5),b2ikb1  ),(rlinjn(1,1,nt14+ 6),b2okb1  )
     4  ,(rlinjn(1,1,nt14+ 7),b2ikb2  ),(rlinjn(1,1,nt14+ 8),b2okb2  )
     5  ,(rlinjn(1,1,nt14+ 9),b3ikb1  ),(rlinjn(1,1,nt14+10),b3okb1  )
     6  ,(rlinjn(1,1,nt14+11),b3ikb2  ),(rlinjn(1,1,nt14+12),b3okb2  )
     7  ,(rlinjn(1,1,nt14+13),emf1ikb1),(rlinjn(1,1,nt14+14),emf1okb1)
     8  ,(rlinjn(1,1,nt14+15),emf1ikb2),(rlinjn(1,1,nt14+16),emf1okb2)
     9  ,(rlinjn(1,1,nt14+17),emf1ikb3),(rlinjn(1,1,nt14+18),emf1okb3)
       equivalence
     1   (rlinjn(1,1,nt14+19),emf2ikb1),(rlinjn(1,1,nt14+20),emf2okb1)
     2  ,(rlinjn(1,1,nt14+21),emf2ikb2),(rlinjn(1,1,nt14+22),emf2okb2)
     3  ,(rlinjn(1,1,nt14+23),emf2ikb3),(rlinjn(1,1,nt14+24),emf2okb3)
     4  ,(rlinjn(1,1,nt14+25),emf3ikb1),(rlinjn(1,1,nt14+26),emf3okb1)
     5  ,(rlinjn(1,1,nt14+27),emf3ikb2),(rlinjn(1,1,nt14+28),emf3okb2)
     5  ,(rlinjn(1,1,nt14+29),emf3ikb3),(rlinjn(1,1,nt14+30),emf3okb3)
c
c----------------------------- 3-D arrays ------------------------------
c
       real*8        rlinjnkn(  in,  jn,  kn,nt20)
c
       equivalence
     1    ( rlinjnkn(1,1,1,      1), d        )
     2  , ( rlinjnkn(1,1,1,      2), v1       )
     3  , ( rlinjnkn(1,1,1,      3), v2       )
     4  , ( rlinjnkn(1,1,1,      4), v3       )
     5  , ( rlinjnkn(1,1,1,nt17+ 1), e        )
     7  , ( rlinjnkn(1,1,1,nt19+ 1), b1       )
     8  , ( rlinjnkn(1,1,1,nt19+ 2), b2       )
     9  , ( rlinjnkn(1,1,1,nt19+ 3), b3       )
c
c============================= COMMON BLOCKS ===========================
c
       common / rootc    /
     1               c2niov
       common / rooti    /
     1               insc    , inniov  , innios  , inmn    , injnkn
     2             , inknin  , ininjn
       common / rootr    /
     1               rlsc    , rlniov  , rlnios  , rlmn    , rlntsl
     2             , x1a     , x2a     , x3a     , rljnkn  , rlknin
     3             , rlinjn  , rlinjnkn
c
c-----------------------------------------------------------------------
c-------------------------- COOLING VARIABLES --------------------------
c-----------------------------------------------------------------------
c
       real*8        tfac    , tmin    , trat
       real*8        cfunc   ( nmd), dcfnc   ( nmd)
       real*8        xheat   (  in)
c
c----------------------------- Common blocks ---------------------------
c
       common / coolcomr /
     1               tfac    , tmin    , trat    , cfunc   , dcfnc
     2             , xheat
c
c-----------------------------------------------------------------------
c---------------------- ADDITIONAL GRID VARIABLES ----------------------
c-----------------------------------------------------------------------
c
       integer       ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     1             , ism2    , ism1    , isp1    , isp2    , isp3
     2             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     3             , iem2    , iem1    , iep1    , iep2    , iep3
     4             , nx1zmx  , nx1z
       integer       jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     1             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     2             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     3             , jem2    , jem1    , jep1    , jep2    , jep3
     4             , nx2zmx  , nx2z
       integer       ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     1             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     2             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     3             , kem2    , kem1    , kep1    , kep2    , kep3
     4             , nx3zmx  , nx3z
       real*8        onei    , onej    , onek
c
       real*8                        x1ah    (  in), x1an    (  in)
     1             , dx1a    (  in), dx1ah   (  in), dx1an   (  in)
     2             , dvl1a   (  in), dvl1ah  (  in), dvl1an  (  in)
     3             , g2a     (  in), g2ah    (  in), g2an    (  in)
     4             , g31a    (  in), g31ah   (  in), g31an   (  in)
     5             , dg2ad1  (  in)
     6             , dg31ad1 (  in)
       real*8        x1ai    (  in), x1ahi   (  in), x1ani   (  in)
     1             , dx1ai   (  in), dx1ahi  (  in), dx1ani  (  in)
     2             , dvl1ai  (  in), dvl1ahi (  in), dvl1ani (  in)
     3             , g2ai    (  in), g2ahi   (  in), g2ani   (  in)
     4             , g31ai   (  in), g31ahi  (  in), g31ani  (  in)
       real*8        x1b     (  in), x1bh    (  in), x1bn    (  in)
     1             , dx1b    (  in), dx1bh   (  in), dx1bn   (  in)
     2             , dvl1b   (  in), dvl1bh  (  in), dvl1bn  (  in)
     3             , g2b     (  in), g2bh    (  in), g2bn    (  in)
     4             , g31b    (  in), g31bh   (  in), g31bn   (  in)
     5             , dg2bd1  (  in)
     6             , dg31bd1 (  in)
       real*8        x1bi    (  in), x1bhi   (  in), x1bni   (  in)
     1             , dx1bi   (  in), dx1bhi  (  in), dx1bni  (  in)
     2             , dvl1bi  (  in), dvl1bhi (  in), dvl1bni (  in)
     3             , g2bi    (  in), g2bhi   (  in), g2bni   (  in)
     4             , g31bi   (  in), g31bhi  (  in), g31bni  (  in)
       real*8        vg1     (  in)
       real*8        f1dx1a  (  in), f2dx1a  (  in), f3dx1a  (  in)
     1             , f4dx1a  (  in), f5dx1a  (  in), f6dx1a  (  in)
     2             , f7dx1a  (  in), f8dx1a  (  in)
       real*8        f1dx1b  (  in), f2dx1b  (  in), f3dx1b  (  in)
     1             , f4dx1b  (  in), f5dx1b  (  in), f6dx1b  (  in)
     2             , f7dx1b  (  in), f8dx1b  (  in), f9dx1b  (  in)
c
       real*8                        x2ah    (  jn), x2an    (  jn)
     1             , dx2a    (  jn), dx2ah   (  jn), dx2an   (  jn)
     2             , dvl2a   (  jn), dvl2ah  (  jn), dvl2an  (  jn)
     3             , g32a    (  jn), g32ah   (  jn), g32an   (  jn)
     4             , dg32ad2 (  jn)
       real*8        x2ai    (  jn), x2ahi   (  jn), x2ani   (  jn)
     1             , dx2ai   (  jn), dx2ahi  (  jn), dx2ani  (  jn)
     2             , dvl2ai  (  jn), dvl2ahi (  jn), dvl2ani (  jn)
     3             , g32ai   (  jn), g32ahi  (  jn), g32ani  (  jn)
       real*8        x2b     (  jn), x2bh    (  jn), x2bn    (  jn)
     1             , dx2b    (  jn), dx2bh   (  jn), dx2bn   (  jn)
     2             , dvl2b   (  jn), dvl2bh  (  jn), dvl2bn  (  jn)
     3             , g32b    (  jn), g32bh   (  jn), g32bn   (  jn)
     4             , dg32bd2 (  jn)
       real*8        x2bi    (  jn), x2bhi   (  jn), x2bni   (  jn)
     1             , dx2bi   (  jn), dx2bhi  (  jn), dx2bni  (  jn)
     2             , dvl2bi  (  jn), dvl2bhi (  jn), dvl2bni (  jn)
     3             , g32bi   (  jn), g32bhi  (  jn), g32bni  (  jn)
       real*8        vg2     (  jn)
       real*8        f1dx2a  (  jn), f2dx2a  (  jn), f3dx2a  (  jn)
     1             , f4dx2a  (  jn), f5dx2a  (  jn), f6dx2a  (  jn)
     2             , f7dx2a  (  jn), f8dx2a  (  jn)
       real*8        f1dx2b  (  jn), f2dx2b  (  jn), f3dx2b  (  jn)
     1             , f4dx2b  (  jn), f5dx2b  (  jn), f6dx2b  (  jn)
     2             , f7dx2b  (  jn), f8dx2b  (  jn), f9dx2b  (  jn)
c
       real*8                        x3ah    (  kn), x3an    (  kn)
     1             , dx3a    (  kn), dx3ah   (  kn), dx3an   (  kn)
     2             , dvl3a   (  kn), dvl3ah  (  kn), dvl3an  (  kn)
       real*8        x3ai    (  kn), x3ahi   (  kn), x3ani   (  kn)
     1             , dx3ai   (  kn), dx3ahi  (  kn), dx3ani  (  kn)
     2             , dvl3ai  (  kn), dvl3ahi (  kn), dvl3ani (  kn)
       real*8        x3b     (  kn), x3bh    (  kn), x3bn    (  kn)
     1             , dx3b    (  kn), dx3bh   (  kn), dx3bn   (  kn)
     2             , dvl3b   (  kn), dvl3bh  (  kn), dvl3bn  (  kn)
       real*8        x3bi    (  kn), x3bhi   (  kn), x3bni   (  kn)
     1             , dx3bi   (  kn), dx3bhi  (  kn), dx3bni  (  kn)
     2             , dvl3bi  (  kn), dvl3bhi (  kn), dvl3bni (  kn)
       real*8        vg3     (  kn)
       real*8        f1dx3a  (  kn), f2dx3a  (  kn), f3dx3a  (  kn)
     1             , f4dx3a  (  kn), f5dx3a  (  kn), f6dx3a  (  kn)
     2             , f7dx3a  (  kn), f8dx3a  (  kn)
       real*8        f1dx3b  (  kn), f2dx3b  (  kn), f3dx3b  (  kn)
     1             , f4dx3b  (  kn), f5dx3b  (  kn), f6dx3b  (  kn)
     2             , f7dx3b  (  kn), f8dx3b  (  kn), f9dx3b  (  kn)
c
c----------------------------- Common blocks ---------------------------
c
       common / gridcomi /
     1               ismnm2  , ismnm1  , ismnp1  , ismnp2  , ismnp3
     2             , ism2    , ism1    , isp1    , isp2    , isp3
     3             , iemxm2  , iemxm1  , iemxp1  , iemxp2  , iemxp3
     4             , iem2    , iem1    , iep1    , iep2    , iep3
     5             , nx1zmx  , nx1z
       common / gridcomi /
     1               jsmnm2  , jsmnm1  , jsmnp1  , jsmnp2  , jsmnp3
     2             , jsm2    , jsm1    , jsp1    , jsp2    , jsp3
     3             , jemxm2  , jemxm1  , jemxp1  , jemxp2  , jemxp3
     4             , jem2    , jem1    , jep1    , jep2    , jep3
     5             , nx2zmx  , nx2z
       common / gridcomi /
     1               ksmnm2  , ksmnm1  , ksmnp1  , ksmnp2  , ksmnp3
     2             , ksm2    , ksm1    , ksp1    , ksp2    , ksp3
     3             , kemxm2  , kemxm1  , kemxp1  , kemxp2  , kemxp3
     4             , kem2    , kem1    , kep1    , kep2    , kep3
     5             , nx3zmx  , nx3z
c
       common / gridcomr /
     1               onei    , onej    , onek
c
       common / gridcomr /
     1               x1ah    , x1an    , dx1a    , dx1ah   , dx1an
     2             , dvl1a   , dvl1ah  , dvl1an  , g2a     , g2ah
     3             , g2an    , g31a    , g31ah   , g31an   , dg2ad1
     4             , dg31ad1 , x1ai    , x1ahi   , x1ani   , dx1ai
     5             , dx1ahi  , dx1ani  , dvl1ai  , dvl1ahi , dvl1ani
     6             , g2ai    , g2ahi   , g2ani   , g31ai   , g31ahi
     7             , g31ani  , x1b     , x1bh    , x1bn    , dx1b
     8             , dx1bh   , dx1bn   , dvl1b   , dvl1bh  , dvl1bn
     9             , g2b     , g2bh    , g2bn    , g31b    , g31bh
       common / gridcomr /
     1               g31bn   , dg2bd1  , dg31bd1 , x1bi    , x1bhi
     2             , x1bni   , dx1bi   , dx1bhi  , dx1bni  , dvl1bi
     3             , dvl1bhi , dvl1bni , g2bi    , g2bhi   , g2bni
     4             , g31bi   , g31bhi  , g31bni  , vg1     , f1dx1a
     5             , f2dx1a  , f3dx1a  , f4dx1a  , f5dx1a  , f6dx1a
     6             , f7dx1a  , f8dx1a  , f1dx1b  , f2dx1b  , f3dx1b
     7             , f4dx1b  , f5dx1b  , f6dx1b  , f7dx1b  , f8dx1b
     8             , f9dx1b
c
       common / gridcomr /
     1               x2ah    , x2an    , dx2a    , dx2ah   , dx2an
     2             , dvl2a   , dvl2ah  , dvl2an  , g32a    , g32ah
     3             , g32an   , dg32ad2 , x2ai    , x2ahi   , x2ani
     4             , dx2ai   , dx2ahi  , dx2ani  , dvl2ai  , dvl2ahi
     5             , dvl2ani , g32ai   , g32ahi  , g32ani  , x2b
     6             , x2bh    , x2bn    , dx2b    , dx2bh   , dx2bn
     7             , dvl2b   , dvl2bh  , dvl2bn  , g32b    , g32bh
     8             , g32bn   , dg32bd2 , x2bi    , x2bhi   , x2bni
     9             , dx2bi   , dx2bhi  , dx2bni  , dvl2bi  , dvl2bhi
       common / gridcomr /
     1               dvl2bni , g32bi   , g32bhi  , g32bni  , vg2
     2             , f1dx2a  , f2dx2a  , f3dx2a  , f4dx2a  , f5dx2a
     3             , f6dx2a  , f7dx2a  , f8dx2a  , f1dx2b  , f2dx2b
     4             , f3dx2b  , f4dx2b  , f5dx2b  , f6dx2b  , f7dx2b
     5             , f8dx2b  , f9dx2b
c
       common / gridcomr /
     1               x3ah    , x3an    , dx3a    , dx3ah   , dx3an
     2             , dvl3a   , dvl3ah  , dvl3an  , x3ai    , x3ahi
     3             , x3ani   , dx3ai   , dx3ahi  , dx3ani  , dvl3ai
     4             , dvl3ahi , dvl3ani , x3b     , x3bh    , x3bn
     5             , dx3b    , dx3bh   , dx3bn   , dvl3b   , dvl3bh
     6             , dvl3bn  , x3bi    , x3bhi   , x3bni   , dx3bi
     7             , dx3bhi  , dx3bni  , dvl3bi  , dvl3bhi , dvl3bni
     8             , vg3     , f1dx3a  , f2dx3a  , f3dx3a  , f4dx3a
     9             , f5dx3a  , f6dx3a  , f7dx3a  , f8dx3a  , f1dx3b
       common / gridcomr /
     1               f2dx3b  , f3dx3b  , f4dx3b  , f5dx3b  , f6dx3b
     2             , f7dx3b  , f8dx3b  , f9dx3b
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL RADIO VARIABLES ----------------------
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c--------------------- ADDITIONAL SUNDRY VARIABLES ---------------------
c-----------------------------------------------------------------------
c
       character*2   id
       character*8   logfile , resfile , plt1file, plt2file, tslfile
     1             , tslpfile, disfile , usrfile
       integer       ioin    , iotty   , ioplt1  , ioplt2  , iolog
     1             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     2             , iovox   , iodis   , iorad   , igetmn  , igetmx
     3             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     4             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     5             , iaddz   , jaddz   , kaddz   , irestart
       real*8        dtdmp
c
c----------------------------- Common blocks ---------------------------
c
       common / sundcomc /
     1               id      , logfile , resfile , plt1file, plt2file
     2             , tslfile , tslpfile, disfile , usrfile
       common / sundcomi /
     1               ioin    , iotty   , ioplt1  , ioplt2  , iolog
     2             , iodmp   , iopix   , iousr   , iotsl   , iotslp
     3             , iovox   , iodis   , iorad   , igetmn  , igetmx
     4             , jgetmn  , jgetmx  , kgetmn  , kgetmx  , iputmn
     5             , iputmx  , jputmn  , jputmx  , kputmn  , kputmx
     6             , iaddz   , jaddz   , kaddz   , irestart
       common / sundcomr /
     1               dtdmp
c
c-----------------------------------------------------------------------
c-------------------- SCRATCH SPACE (WORKER ARRAYS) --------------------
c-----------------------------------------------------------------------
c
c      1-D worker arrays
c
       real*8        wa1d    (ijkn), wb1d    (ijkn), wc1d    (ijkn)
     1             , wd1d    (ijkn), we1d    (ijkn), wf1d    (ijkn)
     2             , wg1d    (ijkn), wh1d    (ijkn), wi1d    (ijkn)
     3             , wj1d    (ijkn), wk1d    (ijkn), wl1d    (ijkn)
     4             , wm1d    (ijkn), wn1d    (ijkn), wo1d    (ijkn)
     5             , wp1d    (ijkn), wq1d    (ijkn), wr1d    (ijkn)
     6             , ws1d    (ijkn), wt1d    (ijkn), wu1d    (ijkn)
     7             , wv1d    (ijkn), ww1d    (ijkn), wx1d    (ijkn)
     8             , wy1d    (ijkn), wz1d    (ijkn)
c
c      2-D worker arrays
c
       real*8        wa2d    (idim,jdim), wa2dt   (jdim,idim)
     1             , wb2d    (idim,jdim), wb2dt   (jdim,idim)
     1             , wc2d    (idim,jdim), wc2dt   (jdim,idim)
     2             , wd2d    (idim,jdim), wd2dt   (jdim,idim)
     1             , we2d    (idim,jdim), we2dt   (jdim,idim)
     2             , wf2d    (idim,jdim), wf2dt   (jdim,idim)
c
c      3-D worker arrays
c
       real*8        wa3d    (  in,  jn,  kn), wb3d    (  in,  jn,  kn)
     1             , wc3d    (  in,  jn,  kn), wd3d    (  in,  jn,  kn)
     2             , we3d    (  in,  jn,  kn), wf3d    (  in,  jn,  kn)
     3             , wg3d    (  in,  jn,  kn)
c
       equivalence   ( wa2d    , wa2dt    ), ( wb2d    , wb2dt    )
     1             , ( wc2d    , wc2dt    ), ( wd2d    , wd2dt    )
     2             , ( we2d    , we2dt    ), ( wf2d    , wf2dt    )
       equivalence   ( wa3d    , wa2d     ), ( wb3d    , wb2d     )
     1             , ( wc3d    , wc2d     ), ( wd3d    , wd2d     )
     2             , ( we3d    , we2d     ), ( wf3d    , wf2d     )
c
c---------------------------- Common Blocks ----------------------------
c
       common / scratchr /
     1               wa1d    , wb1d    , wc1d    , wd1d    , we1d
     2             , wf1d    , wg1d    , wh1d    , wi1d    , wj1d
     3             , wk1d    , wl1d    , wm1d    , wn1d    , wo1d
     4             , wp1d    , wq1d    , wr1d    , ws1d    , wt1d
     5             , wu1d    , wv1d    , ww1d    , wx1d    , wy1d
     6             , wz1d
       common / scratchr /
     1               wa3d    , wb3d    , wc3d    , wd3d    , we3d
     2             , wf3d
     3             , wg3d
c
c
c-----------------------------------------------------------------------
c-------------- START OF PROGRAM/SUBROUTINE ----------------------------
c-----------------------------------------------------------------------
c
c      
       integer   maxshells, p_number
       real*8    max_p, mp,vo, p0 
c
       parameter (maxshells = 200, max_p = 10.0D0, p_number = 250, 
     *      p0 = 2.0, vo = 52483.25D0, mp = 1.67D-27) 
c
       real*8   get_number
       real*8      R_shell_x(maxshells)
       real*8      del_p, p, fi, num_ptcls  
       real*8      shock_speed, Machno, comp_rat            
       real*8      p_inj, p_cut, distr_array(maxshells, p_number)   
       real*8      new_ptcl_num(in), temp, temp0
       real*8      diffuse_array(maxshells, p_number)
       real*8      esc_dens_up(p_number), esc_dens_down(p_number),
     *             prev_acc_time, prev_expand_time(maxshells),
     *             prev_acc_posn
       real*8      esc_shell(in, p_number), dens_ptcls
       real*8      total_num, total_num_shells, total_num_esc_shell 
       real*8      shell_posn, esc_length, shell_vol
       real*8      kappa(p_number,maxshells)
       real*8      kappa_hi(p_number, maxshells)
       real*8      kappa_norm, Energy, vel
         
       real*8      esc_dens_shell(p_number, maxshells)
       real*8      esc_dens_shell_hi(p_number, maxshells)
       integer     shock_begin, shock_end, shell_posn_int
       integer     i , j , k, l, R_shell_i(maxshells), no_shells
       integer     p_int
       
       real*8      escape_location(p_number)
       real*8      vpar           ! particle speed.
       
c============= 02/02/2007, GL
       real*8      temp_esc(p_number), temp_esc_hi(p_number)
       real *8 delta_out
c============= 02/02/2007, GL       

c---- for heavy ions.

       real*8   charge, Amass, p_hi_inj, p_hi_cut
       real*8   distr_array_hi(maxshells,p_number)
       real*8   esc_dens_up_hi(p_number), esc_dens_down_hi(p_number)

       real*8   esc_shell_hi(in,p_number)
       
       real*8  esc_number_up(p_number), esc_number_up_hi(p_number)
       real*8  esc_number_down(p_number), esc_number_down_hi(p_number)
       real*8  temp1, temp2
       
       real*8  escape_location_hi(p_number)

       real*8  p_cut_old, p_hi_cut_old
       real*8  p_cut_expand, p_hi_cut_expand 

       real*8  test_alpha, test_fac, test_p

       real*8  factor_num 
       integer index1,index2, index3

       real *8 dV, den_sh, fi_hi, den_sh_hi ! den_sh is the density at shock front.
       real *8 den_sh_j, den_sh_hi_j

       real *8 energy_low, energy_hi
       real *8 Vsh
       real*8 totnum,tempR
       real*8 total_num_p(maxshells),total_num_hi(maxshells)
       
       real*8 kappa_norm0

       real*8 temp_counter1, temp_counter2

       real*8 esc_ptcl_counter(p_number) ! time-integrated escaped particles.
       real*8 esc_ptcl_counter_hi(p_number) ! time-integrated escaped particles.

       real*8 c 

       integer escape_shell_num(1:250)
       integer escape_shell_num_hi(1:250)

       real*8 ipmax(maxshells),ipmin(maxshells)
       real*8 ipmax_hi(maxshells),ipmin_hi(maxshells)
       
       integer ichoice, ii

       real*8 temp_num(1:p_number),temp_num_hi(1:p_number), temp_dV


       integer i1
       real*8 temp_factor

       real*8 distr_all(250)

       real *8 temp_esc_up, temp_esc_up_hi

       real *8 tttt, ttt

       real *8 temp_check(250), temp_check2(250)

       common /p_checker/ipmax,ipmin,ipmax_hi,ipmin_hi

       common /shell/  esc_shell,R_shell_x,R_shell_i,no_shells
       common /shock2/ shock_begin, shock_end, shock_speed,
     *                 Machno, comp_rat 
       common /ptcls/  p_inj, p_cut, distr_array, esc_dens_up,
     *                 esc_dens_down, prev_acc_time,prev_expand_time,
     *                 prev_acc_posn
       common /diff_coeff/ kappa,kappa_hi

       common /heavyIon/ charge, Amass, p_hi_inj, p_hi_cut
       common /heavyIon2/ distr_array_hi,esc_dens_up_hi,
     *      esc_dens_down_hi,esc_shell_hi

       common /diff_add_expand_ptcl/esc_number_up, esc_number_up_hi

       common /diff_expand/ p_cut_old, p_hi_cut_old,  p_cut_expand, 
     *      p_hi_cut_expand 

       common /escape_counter/ esc_ptcl_counter, esc_ptcl_counter_hi

       common /diag/ distr_all
c       
c-----------------------------------------------------------------------
c                            

       del_p = (max_p - p0)/(p_number*1.)  ! step of log(p) (p is in measure of p/mp) 
       
       print*, "--------Entering diffuse_distr.f --------"
       
       c = 3.0D8 

       Do j = 1, p_number
          p = p0 + (j-1)* del_p   
          energy = Sqrt((mp*c**2.0)**2.0+(mp*Exp(p)*vo*c)**2.0)- !kinetic energy
     *         mp*c**2.0
          energy = energy/1.6E-19 ! in eV.
          write(28,*) Energy, kappa(j,no_shells)
       ENDDO

c----( debug 
c---- total_num_p(i) and total_num_hi(i) are the total proton number 
c---- and heavy ion number in the ith shell (integrated over all momentum).

        Do i = 1, no_shells
           total_num_p(i) = 0.
           total_num_hi(i) = 0.
          Do j = 1, p_number
             p = p0 + (j-1) * del_p
             total_num_p(i) = total_num_p(i) +  
     *            distr_array(i,j) *4./3. * pi *
     *            (Exp(p+del_p)**3 - Exp(p)**3)
             total_num_hi(i) =  total_num_hi(i) +  
     *            distr_array_hi(i,j) *4./3. * pi *
     *            (Exp(p+del_p)**3 - Exp(p)**3)
             escape_location(j) = 0.
             escape_location_hi(j) = 0.
          End Do
c          print*, " ---- before diffuse -----"
c          print*, " -- i, total_num_p(i) --", i, total_num_p(i)
c          print*, " -- i,total_num_hi(i) --", i, total_num_hi(i)
       End Do
   

c---- ) debug

c---- ( debug

       write(97,*)"--- time and r_shell_x(no_shells+1) ---", 
     * time, r_shell_x(no_shells+1)   

       Do j = 1, p_number
          temp_num(j) = 0.
       ENDDO
       temp_dV = 0.
       
       DO i =1, no_shells 
          DO j =1, p_number
             p = p0 + del_p * (j-1)
             Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *            (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *            1.67E-27*3.0E8**2.0 ! the kinetic energy.
             Energy = Energy/1.6E-19 !  (Energy in eV)
             factor_num = 4.*pi/3.* (Exp(p)**3 - Exp(p-del_p)**3) 
             dV = 4.*pi/3. *(  R_shell_x(i+1)**3 
     *         - R_shell_x(i)**3 ) ! no need to convert R_shell_x.
c             write(97,*) Energy,distr_array(i,j)* factor_num/dV,
c     *            distr_array_hi(i,j)*factor_num/dV

             temp_num(j) = temp_num(j) + distr_array(i,j)
             temp_dV = temp_dV + dV
             write(97,*) Energy,distr_array(i,j),
     *            distr_array(i,j)* factor_num/dV
c             print*, "j,energy,distr_array(no_shells,j)",
c     *            j,energy,distr_array(no_shells,j)
          ENDDO
       ENDDO


c----- write out time-integrated accelerated particles. 
c----- should be identical to fort.94 from add-acc_ptcls.f.

       Do j = 1, p_number
          temp_check(j) = 0.0
          temp_check2(j) = 0.0
       Enddo

       Do j = 1, p_number
          Do i = 1, no_shells ! i = no_shells + 1 for ptls in front of the shock
             temp_check(j) = temp_check(j) + distr_array(i,j)
          End Do
       End Do                   
       
       Do j = 1, p_number
          temp_check2(j) = temp_check(j) + esc_ptcl_counter(j)
       ENDDO

       Do j = 1, p_number
          p = p0 + del_p * (j-1)
          Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *         (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0 ! the kinetic energy.
          Energy = Energy/1.6E-19 !  (Energy
          write(83,*) Energy, temp_check(j),temp_check2(j),distr_all(j),
     *         time
       Enddo

c---- ) debug

c---- Now we need to do something about ipmax(i=1:no_shells).
c---- The idea is that ipmax(i) must >= ipmax(i+1), for every i = 1 : no_shells -1 .
c---- This is to say, if the shock is still accelerating particles to higher energy, then
c---- turbulence will develop in all the previous shells as well.

       print*, "no_shells,ipmax(no_shells)", no_shells, ipmax(no_shells)
c       pause
       
       Do i1 = 1, no_shells -1  ! this DO END block is a rare case
          i = no_shells - i1

          if(ipmax(i) .lt. ipmax(i+1) ) then
             temp_factor = ( (R_shell_x(i+1)+R_shell_x(i))/
     *            (R_shell_x(i-1)+ R_shell_x(i)) )**3
             Do j = ipmax(i) + 1, ipmax(i+1)
c                kappa(j, i) = kappa(j, i+1) * temp_factor
                kappa(j, i) = kappa(j, i+1)
             Enddo
             ipmax(i) = ipmax(i+1)
          endif
       Enddo


       Do i1 = 1, no_shells -1  ! this DO END block is a rare case
          i = no_shells - i1

          if(ipmax_hi(i) .lt. ipmax_hi(i+1) ) then
             temp_factor = ( (R_shell_x(i+1)+R_shell_x(i))/
     *            (R_shell_x(i-1)+ R_shell_x(i)) )**3
             Do j = ipmax_hi(i) + 1, ipmax_hi(i+1)
c                kappa_hi(i, j) = kappa_hi(i+1, j) * temp_factor
                kappa_hi(i, j) = kappa_hi(i+1, j)
             Enddo
             ipmax_hi(i) = ipmax_hi(i+1)
          endif
       Enddo

       Do i =1, no_shells
          print*, " i, ipmax(i)", i, ipmax(i)
       ENDDO
c       pause

c---- initialization of escape_shell_num(j).
c---- Find the escaping location for different energies.

       Do j = 1, 250
          escape_shell_num(j) =  no_shells
          escape_shell_num_hi(j) =  no_shells
       ENDDO

       Do j = 1, 250
          Do i = 1, no_shells
             if ( j .le. ipmax(i) ) then
                escape_shell_num(j) = i
             endif

             if ( j .le. ipmax_hi(i) ) then
                escape_shell_num_hi(j) = i
             endif
          ENDDO
       ENDDO

       Do j =1, 250
          escape_location(j) =  R_shell_x(escape_shell_num(j) + 1) 
          escape_location_hi(j) = R_shell_x(escape_shell_num_hi(j)+ 1)
       ENDDO


c-- Alternatively, use the following simplified estimate ---------
c       Do j = 1, 250
c          escape_shell_num(j) =  no_shells
c          escape_shell_num_hi(j) =  no_shells
c          escape_location(j) =  R_shell_x(no_shells+1)
c          escape_location_hi(j) = R_shell_x(no_shells+1)
c       ENDDO
c-----------------------------------------------------------------

c---- Initialize the escaped particle ( Not used )
       do ii = 1, maxshells
          esc_dens_shell(p_int, ii) = 0.
          esc_dens_shell_hi(p_int, ii) = 0.
       enddo

c---- ( debug
       write(84,*)"time is", time
       Do j = 1, 250
c          print*, "j, escape_shell_num(j), no_shells", j, 
c     *         escape_shell_num(j),no_shells

          write(84,*) "j, escape_shell_num(j), no_shells", j, 
     *         escape_shell_num(j),no_shells

       ENDDO
c       pause

c---- ) debug

c---  now calculate the corresponding index for p_cut_old, p_cut_expand,p_cut
       
c       if ( p_cut .ne. 0.) then
c          index1 =  1 +  INT(( DLog(p_cut_old)- p0)/del_p + 0.5)
c          index2 =  1 +  INT(( DLog(p_cut_expand)- p0)/del_p + 0.5)
c          index3 =  1 +  INT(( DLog(p_cut)- p0)/del_p + 0.5)
c       else
c          index1 = 0
c          index2 = 0
c          index3 = 0
c       endif
c       print*, " *** index1, index2,index3 *** ", index1, index2, index3

c       pause

c                          
       Do i = 1, no_shells + 1  ! i = no_shells + 1 for ptls in front of the shock
          Do j = 1, p_number
             diffuse_array(i,j) = 0.0D0 ! The new array for the distribution  
                                ! after the diffusion.
             esc_dens_up(j) = 0.0D0 ! escaped distribution at upstream.
             esc_dens_down(j) = 0.0D0 ! escaped distribution at downstream.
          End Do
       End Do                   
c     
c--- ( del
       Do i = 1, in             ! # of position.
          Do j = 1, p_number         ! # of momentum.
             esc_shell(i, j) = 0.0D0
          End Do           
       End Do
c--- ) del

c----- Initialization of particles in up and dn stream.
       Do i = 1, p_number
          esc_number_up(i) = 0.
          esc_number_up_hi(i) = 0.
          esc_number_down(i) = 0.
          esc_number_down_hi(i) = 0.
       ENDDO
       

c===== added by Gang Li  02/02/2007

       do j = 1, p_number
          temp_esc(j)  = 0.
          temp_esc_hi(j)  = 0.
       enddo


c       delta_out = 1.7183  ! delta_out controls how many particles leak out when the shell is first generated.
       delta_out = 0.25  


       print*, " --- no_shells --", no_shells
       write(99,*) " time is ", time





c---- Now the real stuff...

       Do i = 1, no_shells  ! For the current shell and all the shells generated earlier.
          
          shell_posn = (R_shell_x(i + 1) + R_shell_x(i))/2.0D0 ! the loc. of the center of the ith shell.
          
          shell_posn_int = (R_shell_i(i+1)+R_shell_i(i))/2.0D0 ! the index of the center of the ith shell.
c     
          shell_vol = 4.0*pi*(R_shell_x(i+1)**3.0D0-
     *         R_shell_x(i)**3.0D0)/3.0D0 ! volume of the shell.    
c            
          print*, " shell no is ", i                                          
          write(99,*) " shell no is ", i                                          

          Do j = 1, p_number
             p_int = j
             p = p0 + (j-1) * del_p
             
             Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *            (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *            1.67E-27*3.0E8**2.0 ! the kinetic energy.
             
             Energy = Energy/1.6E-19 !  (Energy in eV)
c     
             vel = Exp(p)*52483.25/Sqrt(1.0 + Exp(p)*Exp(p)*
     *            52483.25*52483.25/(3.0E8*3.0E8)) ! particle velocity.
                                ! note v/c = (p/mc) / sqrt( 1 + (p/mc)^2 ) is in m/s.

             vel = vel/52483.25D0 ! Normalized velocity (in unit of the sound speed at 1 AU).

c             print*, "i,j,escape_shell_num(j)", i,j,escape_shell_num(j)
c             print*, "kappa(j,escape_shell_num(j)),kappa(j,i)",
c     *            kappa(j,escape_shell_num(j)), kappa(j,i)
            
             fi = distr_array(i, p_int) ! number of particles before the diffusion.

C            /added by Olga 
c	       if (no_shells .gt. 22) then
c	           delta_out =0.
c	       endif
C            /added by Olga 


c===========  add by Gang Li for a better approximation for escape 


             if ( i .eq. no_shells) then 
                temp_esc(p_int) =  fi  * 1. / (1.+delta_out)
                fi = (1. - 1./(1.+delta_out) )  * fi
             endif

c===========  end add by Gang Li

 

c----   should change kappa(j,1) to kappa(j, no_shells-i)
             
             kappa_norm = kappa(j,i)*2858055.0D0/1.5D11/1.5D11 ! get the normalised kappa.
                                ! kappa_norm is in the unit of AU * v0 where v0 
                                ! is the normolization speed.
             
             temp0 = 4.0D0*kappa_norm*(time - prev_acc_time) ! the length scale 4 
                                                            !the Green's function.
c             temp = temp0 + (kappa_norm/(shock_speed - 
c     *            v1(shock_end+2,1,5)) )**2.0D0 ! take into account the initial extended 
                                !   of the assumed delta function ditribution. 

             temp = temp0 + ((R_shell_x(i + 1) - R_shell_x(i))/4.)**2
                                ! temp is the [distance^2] in the code.

c --- ( debug
c             if (i .eq. no_shells) then
c                print*, "i,j,temp0, temp", i,j,temp0,temp
c                write(96,*) "i,j,temp0, temp", i,j,temp0,temp
c             endif 
c --- ) debug

c     if (i .eq. no_shells) then
c             write(99,*) j,energy,temp, fi/shell_vol
c     endif
c     
c     If (temp**0.5 .gt. 0.5D0*vel*(time-prev_acc_time)) Then ! Ensure ptcl does not 
c                temp = (0.5D0*vel*(time-prev_acc_time))**2. ! diffuse further than it
c                print*, " **** ballistically propagation happens ****"
c             EndIf              ! could propagate ballistically. 
c                             !  SHOULD change 0.5  to 1.0. 
                
             
             If (fi .NE. 0.0D0) Then ! fi = distr_array(i, p_int)
                                ! There are particles in shell j for momentum p_int.
c---  ( debug
c                print*, " --- start diff. [1 escape_shell_num(j) ] ---"
                
c                if ( p_int .ge. 150) then
c                   write(96,*),"---start diff.[escape] ---"
c                   write(96,*) "i,j,temp0, temp", i,j,temp0,temp
c                   write(96,*)" fi,sqrt(temp),j", fi,temp**0.5,j
c                endif
c---  ) debug
                
                total_num = 0.0D0 ! total number of ptcl.
                total_num_shells = 0.0D0 ! total number of ptcl in the shells.
                total_num_esc_shell = 0.0D0 ! total number of escaped ptcl.
                
                Do l = 1, escape_shell_num(j) ! only Re-distribute particles to those shells 
                                !  that have already had particles of this energy.
                   
c     Do l = 1, no_shells  ! only Re-distribute particles to those shells 
                   
                   call diffuse_distr_integ(num_ptcls,fi,shell_posn, ! get the number of particles 
     *                  R_shell_x(l), R_shell_x(l+1), temp) !in the lth shell. 
                   
c     write(22,*)"---num_ptcls from subroutine", num_ptcls
                   num_ptcls = get_number(fi,shell_posn, ! get the number of particles 
     *                  R_shell_x(l), R_shell_x(l+1), temp)
c     write(22,*)"---num_ptcls from code", num_ptcls
                   
ccc   print*,"fi,num_ptcls,temp,j",fi,num_ptcls,temp,j
ccc   print*,"l, shell_posn,R_shell_x(l,l+1)",l,
ccc   *                  shell_posn,R_shell_x(l), R_shell_x(l+1)
                   
c---  (- debug
c     if ( j .ge. 150) then
c     write(96,*)" fi,num_ptcls,temp,j",
c     *                     fi,num_ptcls,temp,j
c     write(96,*)" l,shell_posn,R_shell_x(l,l+1)",l,
c     *                  shell_posn,R_shell_x(l), R_shell_x(l+1)
c     endif
c---  -) debug 
                   
c------num_ptcls is the output: ptcl number (per unit momentum space)
c------between R_shell_x(l) and R_shell_x(l+1).
c------fi: input ptcl number in the shell (per unit momentum space) designated by shell_posn.
c------shell_posn: the shell in consideration.
c------R_shell_x(l): beginning loc. of  lth shell. 
c------R_shell_x(l): ending loc. of  lth shell.                              
c------temp: the length scale associated with p.
                   
                   diffuse_array(l,p_int) = diffuse_array(l,p_int) +
     *                  num_ptcls
                   
                   total_num = total_num + num_ptcls
                   total_num_shells = total_num_shells + num_ptcls 
c     
                End Do          ! (l = 1, escape_shell_num(j) )

c       print*, " ----i, j,total_num,fi----", i,j,total_num,fi
c     print*, "fi, total_num ", fi, total_num
                
c---  Now calculate kappa_norm0 which is used to calculate esc_length for jth momentum.
                
                kappa_norm0 = kappa(j, escape_shell_num(j) )
     *               *2858055.0D0/1.5D11/1.5D11 

c---  
c---  Calculate esc_length for this momentum.
c---  The index of the outmost shell for this momentum is 
c---  given by escape_shell_num(j).
c---  Then get the value for escape_location(p_int)
                


                if ( j .le. ipmax(escape_shell_num(j) ) ) then
                   esc_length = 2.0D0 * kappa_norm0/
     *                  (shock_speed-v1(shock_end+2,1,5)) ! Note e^4 = 55
                else
                   esc_length = 0.
                endif

                esc_length = 0.
               
c--------- adding the following by GL -------
                if ( escape_shell_num(j)  .eq. no_shells ) then ! we are in the first shell.
                   esc_length = 2.0D0 * kappa_norm0/
     *                  (shock_speed-v1(shock_end+2,1,5)) ! Note e^4 = 55
                else if ( escape_shell_num(j)  .lt. no_shells ) then
                   esc_length = 0.
                     endif
                endif
c---------end adding the following by GL --------                 

                escape_location(p_int)=R_shell_x(escape_shell_num(j)+1)
     *               + esc_length


c------ After testing the above way for escape_location, I decided
c------ to use the following value for escape_location(p_int).
c------ Basically, this is the location of the outer boundary of the shell
c------ for particles with momentum p_int. I expect this to be a good approx.
c------ GL, 02/20/2004.
c                escape_location(p_int)=R_shell_x(escape_shell_num(j)+1) 

                
c
c                print*, "R_shell_x(escape_shell_num(j)+1) ",
c     *               R_shell_x(escape_shell_num(j)+1) 

c                print*, "i,j,escape_shell_num(j)+1, esc_length",i,j,
c     *               escape_shell_num(j)+1,esc_length
                
c                print*, "j,esc_length,escape_location(p_int)",
c     *               p_int,esc_length, escape_location(p_int)

                write(85,*)"i,j,escape_shell_num(j)+1, esc_length",i,j,
     *               escape_shell_num(j)+1,esc_length
                
                write(85,*)"j,esc_length,escape_location(p_int)",
     *               p_int,esc_length, escape_location(p_int)


c----- Now let us calculate escaped particles.
                
                temp1 = escape_location(p_int)
                temp2 = min(x1a(ie-10), 3.5 * temp1)
c     temp2 = 10. * temp1
                
                call diffuse_distr_integ(num_ptcls, fi, shell_posn,
     *               temp1, temp2, temp) ! temp is the (length scale)^2 for the diffusion.
                
ccc   print*, " num_ptcls using diffuse_distr", num_ptcls
                
                num_ptcls = get_number(fi, shell_posn,
     *               temp1, temp2, temp) ! temp is the (length scale)^2 for the diffusion.
                
ccc   print*, " num_ptcls using get_number", num_ptcls
                
c     pause
                
ccc   print*, "esc_num,temp1,temp2",num_ptcls,temp1,temp2
ccc   print*, "fi,shell_posn,temp",fi,shell_posn,temp
                
ccc   if (j .ge. 150) then
ccc   write(96,*)"esc_#,temp1,temp2",num_ptcls,temp1,temp2
ccc   endif

                esc_number_up(p_int) = esc_number_up(p_int) + 
     *               num_ptcls 
                
                esc_ptcl_counter(p_int) = esc_ptcl_counter(p_int) + 
     *               num_ptcls 
                
                total_num = total_num + num_ptcls
                total_num_shells = total_num_shells + num_ptcls 

c--- let us put particles between R_shell_x(escape_shell_num(p_int)+1) 
c--- and  escape_location(p_int) to diffuse_array(l,p_int).
                
                temp1 = R_shell_x(escape_shell_num(p_int)+1) 
                temp2 = escape_location(p_int)
                
                if (temp1 .ne. temp2) then 
                   l = escape_shell_num(j)
                   call diffuse_distr_integ(num_ptcls,fi,shell_posn, ! get the number of particles 
     *                  temp1,temp2 , temp) !in the lth shell. 
                   
                   num_ptcls= get_number(fi,shell_posn, ! get the number of particles 
     *                  temp1,temp2 , temp) !in the lth shell. 
                   
                   diffuse_array(l,p_int) = diffuse_array(l,p_int) +
     *                  num_ptcls

c---- ( debug
                   if ( j .ge. 150) then
                      write(96,*) "-- ptcls in (outlayer, escape bc) --"
                      write(96,*)"num_ptcls,temp1,temp2",
     *                     num_ptcls,temp1,temp2 
                   endif
                   
ccc                   print*, " ----- particles between the outlayer and the
ccc     *                  the escape boundary ---- "
ccc                   print*, "num_ptcls", num_ptcls
ccc                   print*, " temp1,temp2", temp1,temp2
             
c---- ) debug      
                   total_num = total_num + num_ptcls
                   total_num_shells = total_num_shells + num_ptcls 
                   
                endif
                
c---- The following calculate particles leaking from the shock rear end. 
                
                k = R_shell_i(1) ! index of the location of the inner bd. of the first shell.                                
                temp1 = x1a(is+10) 
                temp2 = R_shell_x(1)
                
                if ( (temp2 - temp1) .lt. 3.* temp**0.5 ) then
                   temp1 =  0.01
                endif

                call diffuse_distr_integ(num_ptcls, fi, shell_posn,
     *               temp1, temp2, temp) 
                
                num_ptcls=get_number(fi, shell_posn,
     *               temp1, temp2, temp) 
                
                if ( j .ge. 150) then
                   write(96,*)"shell_posn,x1a(is+10),R_shell_x(1)",
     *                  shell_posn,x1a(is+10),R_shell_x(1)
                   write(96,*)"fi, num_ptcls, temp1,temp2",
     *                  fi,num_ptcls,temp1,temp2
                endif
                
c---- Behind the shock, the CME ejecta can reflect energetic particles back.
                
                Do l = 1, escape_shell_num(p_int) 
                   diffuse_array(l,p_int) = diffuse_array(l,p_int) +
     *                  num_ptcls * (R_shell_x(l+1)**3- R_shell_x(l)**3)
     *                  /  (R_shell_x(escape_shell_num(p_int)+1)**3
     *                  - R_shell_x(1)**3)
                Enddo

c---- The following for back propagation. 

                esc_number_down(p_int) = esc_number_down(p_int) 
     *               + num_ptcls

                total_num = total_num + num_ptcls 
                total_num_esc_shell = total_num_esc_shell + num_ptcls

                write(96,*) "j, fi, total_num, esc, esc/tot,time", 
     *               j, fi, total_num, esc_number_up(p_int), 
     *               esc_number_up(p_int)/total_num, time
                write(96,*) " **** end  diff ****"

c                print*, " p_int, escape_shell_num(p_int)", 
c     *               p_int, escape_shell_num(p_int)
c                pause

c                print*,"total_num(1+2)-distr_array(i,j),total_num,fi", 
c     *               total_num-distr_array(i,j),total_num,fi

c---   GL April 22nd, 2003.
                

c---  Now calculate the number density at the escape boundary @ shock front.
                call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *               x1a(shock_begin)+esc_length, temp) ! particle number fi.
c---  try the following.
                
                call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *               x1a(shock_begin), temp) ! particle number fi.
                
                esc_dens_up(p_int) = esc_dens_up(p_int) + 
     *               dens_ptcls

c---  Now calculate the number density at the inner escape boundary at the 1st shell.
                call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *               R_shell_x(1), temp) ! particle number fi.
                
                esc_dens_down(p_int) = esc_dens_down(p_int) + 
     *               dens_ptcls
                
                do ii = 1, no_shells
                   call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *                  R_shell_x(ii+1), temp) ! particle number fi.
                   
                   esc_dens_shell(p_int, ii) = esc_dens_shell(p_int, ii) 
     *                  + dens_ptcls
                enddo
                
             End Do             ! if (fi .NE. 0.) 
             
c     Write(46,*) " ***", Energy, esc_dens_up(j), 
c     *          diffuse_array(i,j)/shell_vol
             
          End Do                ! do j = 1, p_number
       End Do                   ! Do i = 1, no_shells
      

 
       
c---  ( debug

c     do j =1 ,250
c          print*, "j,escape_location(j)",j,escape_location(j)
c     enddo
c     pause

c---  ) debug
       
       Do i = 1, no_shells +1
          Do j = 1, p_number    !  Reset ptcl distributions as they
                                !  have now diffused and need to be included 
             
c---  ( debug
c     print*, "---distr_array (i,j) before diffuse ---", i,j,
c     *            distr_array(i,j)
c---  ) debug
             
             distr_array(i,j) = diffuse_array(i,j) ! in the distr array.
             
c---  ( debug
c     print*, "---distr_array (i,j) after diffuse ---", i,j,
c     *         distr_array(i,j)
c---  ) debug
             
          End Do
       End Do  

c--------------
       
       Do j = 1, p_number
          temp_num(j) = 0.
       ENDDO
       temp_dV = 0.
       
       DO i =1, no_shells 
          DO j =1, p_number
             p = p0 + del_p * (j-1)

             factor_num = 4.*pi/3.* (Exp(p)**3 - Exp(p-del_p)**3) 
             dV = 4.*pi/3. *(  R_shell_x(i+1)**3 
     *         - R_shell_x(i)**3 ) ! no need to convert R_shell_x.
             
             temp_num(j) = temp_num(j) + distr_array(i,j)
             temp_dV = temp_dV + dV
          ENDDO
       ENDDO
       
       Do j = 1, p_number
          p = p0 + del_p * (j-1)
          Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *         (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0 ! the kinetic energy.
          Energy = Energy/1.6E-19 !  (Energ
          ttt = temp_num(j) + esc_number_up(j)
          tttt = temp_num(j) + esc_ptcl_counter(j)

          write(82,*) Energy,temp_num(j), ttt, tttt,
     *         temp_num(j)/temp_dV
       Enddo

c-------------


c      pause
c-----------------Now for heavy ions-------------------------------------------

       del_p = (max_p - p0)/(p_number *1.) ! step of log(p) (p is in measure of p/mp) 
c     
       Do i = 1, no_shells + 1
          Do j = 1, p_number
             diffuse_array(i,j) = 0.0D0 
             esc_dens_up_hi(j) = 0.0D0 
             esc_dens_down_hi(j) = 0.0D0 
          End Do
       End Do                   
c     
c--- ( del
       Do i = 1, in             ! # of position.
          Do j = 1, p_number         ! # of momentum.
             esc_shell_hi(i, j) = 0.0D0 
          End Do           
       End Do    
c--- ) del   


       Do i = 1, no_shells   ! For all the shells generated earlier.
          
          shell_posn = (R_shell_x(i + 1) + R_shell_x(i))/2.0D0 ! the loc. of the center of the ith shell.
          shell_posn_int = (R_shell_i(i+1)+R_shell_i(i))/2.0D0 ! the index of the center of the ith shell.
c     
          shell_vol = 4.0*pi*(R_shell_x(i+1)**3.0D0-
     *         R_shell_x(i)**3.0D0)/3.0D0 ! volume of the shell.    
c     

          Do j = 1, p_number
             p_int = j
c             print*, " p_int and j are", p_int, j
             p = p0 + (j-1) * del_p

             Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *            (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *            1.67E-27*3.0E8**2.0 ! the kinetic energy.
             Energy = Energy/1.6E-19 !  (Energy in eV)
c     
             vel = Exp(p)*52483.25/Sqrt(1.0 + Exp(p)*Exp(p)*
     *            52483.25*52483.25/(3.0E8*3.0E8)) ! particle velocity.
                                ! note v/c = (p/mc) / sqrt( 1 + (p/mc)^2 ) is in m/s.
             
             vel = vel/52483.25D0 ! Normalized velocity (in unit of the sound speed at 1 AU).
             
             fi = distr_array_hi(i, p_int) ! number of particles before the diffusion.

c===========add by Gang Li for a better approximation for escape 

C            /added by Olga 
c	       if (no_shells .gt. 22) then
c                   delta_out =0.
c	       endif
C            /added by Olga  


             if ( i .eq. no_shells) then 
                temp_esc_hi(p_int) =  fi * 1. / (1.+delta_out)
                fi  = (1. - 1./(1.+delta_out) ) * fi
             endif


c===========  end add by Gang Li



c---     
             kappa_norm = kappa_hi(j,i)*2858055.0D0/1.5D11/1.5D11 ! get the normalised kappa.
            
             temp0 = 4.0D0*kappa_norm*(time - prev_acc_time) ! the length scale squre 4 the 
                                                            ! Green's function.

c             temp = temp0 + (kappa_norm/(shock_speed - 
c     *            v1(shock_end+2,1,5)) )**2.0D0 ! take into account the initial extended 
c                                !   of the assumed delta function ditribution. 
             temp = temp0

             temp = temp0 + ((R_shell_x(i + 1) - R_shell_x(i))/5.)**2


c     temp_new = vel*(time-prev_acc_time)  ! the distence particle can move ballistically.
c     If (temp .gt. temp_new) Then ! Ensure ptcl does not 
c     print*, "--- temp, temp2---", temp, temp_new
c     temp = temp_new ! diffuse further than it
c     ! could propagate ballistically. 
c     EndIf              
             
             If (fi .NE. 0.0D0) Then ! so this momentum bin contains particles.
                
                total_num = 0.0D0 ! total number of ptcl.
                total_num_shells = 0.0D0 ! total number of ptcl in the shells.
                total_num_esc_shell = 0.0D0 ! total number of escaped ptcl.
                
                Do l = 1, no_shells 
                   
                   call diffuse_distr_integ(num_ptcls,fi,shell_posn, ! get the number of particles 
     *                  R_shell_x(l), R_shell_x(l+1), temp) !in the lth shell. 
                   
                   num_ptcls = get_number(fi,shell_posn, ! get the number of particles 
     *                  R_shell_x(l), R_shell_x(l+1), temp) !in the lth shell. 

c------num_ptcls is the output: ptcl number between R_shell_x(l) and R_shell_x(l+1).
c------fi: input ptcl number in the shell designated by shell_posn.
c------shell_posn: the shell in consideration.
c------R_shell_x(l): beginning loc. of  lth shell. 
c------R_shell_x(l): ending loc. of  lth shell.                              
c------temp: the length scale associated with p.
                   
                   diffuse_array(l,p_int) = diffuse_array(l,p_int)+
     *                  num_ptcls
                   
                   total_num = total_num + num_ptcls
                   total_num_shells = total_num_shells + num_ptcls 
c     
                End Do          ! (l = 1, no_shells)

c                print*, "total_num  - distr_array_hi(i,j)", 
c     *               total_num - distr_array_hi(i,j), total_num
c     
c--- Now calculate kappa_norm0 which is used to calculate esc_length for jth momentum.
                kappa_norm0 = kappa_hi(j,escape_shell_num_hi(j))
     *               *2858055.0D0/1.5D11/1.5D11 ! used to calculate esc_length

                if ( j .lt. ipmax_hi(no_shells) ) then
                   esc_length = 1.0D0 * kappa_norm0/
     *                  (shock_speed-v1(shock_end+2,1,5)) ! Note e^4 = 55
                else
                   esc_length = 0.
                endif

                esc_length = 0.

c--------- adding the following by GL  06/14/2007 -------
                if ( escape_shell_num_hi(j)  .eq. no_shells ) then ! we are in the first shell.
                   esc_length = 2.0D0 * kappa_norm0/
     *                  (shock_speed-v1(shock_end+2,1,5)) ! Note e^4 = 55
                else if ( escape_shell_num_hi(j)  .lt. no_shells ) then
                   esc_length = 0.
                     endif
                endif
c---------end adding the following by GL --------                 

                escape_location_hi(p_int)=
     *               R_shell_x(escape_shell_num_hi(p_int)+1)+esc_length

c------ After testing the above way for escape_location, I decided
c------ to use the following value for escape_location(p_int).
c------ Basically, this is the location of the outer boundary of the shell
c------ for particles with momentum p_int. I expect this to be a good approx.
c------ GL, 02/20/2004.
c                escape_location_hi(p_int)=
c     *               R_shell_x(escape_shell_num_hi(j)+1) 
                
                
cc     If ((DExp(p) .GE. p_hi_inj) .AND. ! only particles within the acceleration range has 
cc     *               (DExp(p) .LE. p_hi_cut)) Then ! non-zero esc_length.
                
cc     esc_length = 4.0D0*kappa_norm0/
cc     *                  (shock_speed-v1(shock_end+2,1,5))
cc     Else
cc     esc_length = 0.0D0
cc     EndIf  
cc     escape_location_hi(p_int) = x1a(shock_begin)+ esc_length
                
c-----Now let us calculate escaped particles.
                temp1 = escape_location_hi(p_int)
                temp2 = min(x1a(ie-10), 3.5 * temp1)
                
                call diffuse_distr_integ(num_ptcls, fi, shell_posn,
     *               temp1, temp2, temp) ! temp is the (length scale)^2 for the diffusion.
                
                num_ptcls =get_number(fi, shell_posn,
     *               temp1, temp2, temp) ! temp is the (length scale)^2 for the diffusion.

                esc_number_up_hi(p_int) = esc_number_up_hi(p_int) 
     *               + num_ptcls
                
                esc_ptcl_counter_hi(p_int) = esc_ptcl_counter_hi(p_int) 
     *               + num_ptcls
                
c---  let us put particles between R_shell_x(escape_shell_num(p_int)+1) 
c---  and  escape_location(p_int) back to diffuse_array(l,p_int)
                
                temp1 = R_shell_x(escape_shell_num_hi(p_int)+1) 
                temp2 = escape_location_hi(p_int)
                
                if (temp1 .ne. temp2) then 
                   l = escape_shell_num(p_int)
                   call diffuse_distr_integ(num_ptcls,fi,shell_posn, ! get the number of particles 
     *                  temp1,temp2 , temp) !in the lth shell. 

                   num_ptcls=get_number(fi,shell_posn, ! get the number of particles 
     *                  temp1,temp2 , temp) !in the lth shell. 

                   diffuse_array(l,p_int) = diffuse_array(l,p_int) +
     *                  num_ptcls
                endif

                total_num = total_num + num_ptcls 
                total_num_esc_shell = total_num_esc_shell + num_ptcls
                
c     diffuse_array(no_shells+1, p_int) =  num_ptcls + 
c     *               diffuse_array(no_shells+1, p_int)
                
c---  GL April 22nd, 2003.
                
c---- Now calculate the number density at the escape boundary @ shock front.   
                call diff_distr_fn_posn(dens_ptcls,fi,shell_posn,
     *               x1a(shock_begin)+esc_length, temp)             
                
                esc_dens_up_hi(p_int) = esc_dens_up_hi(p_int) + 
     *               dens_ptcls
                
c---  Now calculate the number density at the inner escape boundary at the 1st shell.
                call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *               R_shell_x(1), temp) ! particle number fi.
                
                esc_dens_down_hi(p_int) = esc_dens_down_hi(p_int) + 
     *               dens_ptcls
  
                do ii = 1, no_shells
                   call diff_distr_fn_posn(dens_ptcls,fi,shell_posn, ! get the density from the     
     *                  R_shell_x(ii), temp) ! particle number fi.
                   
                   esc_dens_shell_hi(p_int, ii) = 
     *                  esc_dens_shell_hi(p_int, ii) + dens_ptcls
                enddo

c------The following calculate the number of ptcl in the region $ R(t) < r < R(t) + \lambda_{esc}$.
                
c                k = R_shell_i(no_shells + 1) ! index of the location of the shock.
c                
c                call diffuse_distr_integ(num_ptcls, fi, shell_posn,
c     *               R_shell_x(no_shells+1),
c     *               R_shell_x(no_shells+1)+esc_length,temp)

c                esc_shell_hi(k, p_int)=esc_shell_hi(k,p_int)+num_ptcls
                
c                total_num = total_num + num_ptcls 
c                total_num_esc_shell = total_num_esc_shell + num_ptcls
c---------------------------

                k = R_shell_i(1) ! index of the location of the inner bd. of the first shell.                
                temp1 = x1a(is+10) 
                temp2 = R_shell_x(1)

                if ( (temp2 - temp1) .lt. 3.* temp**0.5 ) then
                   temp1 =  0.01
                endif


                call diffuse_distr_integ(num_ptcls, fi, shell_posn,
     *               temp1, temp2, temp) 

                num_ptcls =get_number(fi, shell_posn,
     *               temp1, temp2, temp) 
                

c---- Behind the shock, the CME ejecta can reflect energetic particles back.

                Do l = 1, escape_shell_num_hi(p_int) 
                   diffuse_array(l,p_int) = diffuse_array(l,p_int) +
     *                  num_ptcls * (R_shell_x(l+1)**3- R_shell_x(l)**3)
     *                  /  (R_shell_x(escape_shell_num(p_int)+1)**3
     *                  - R_shell_x(1)**3)
                Enddo

c---- The following for back propagation. 
                esc_number_down_hi(p_int) = esc_number_down_hi(p_int) 
     *               + num_ptcls
c----
                total_num = total_num + num_ptcls 
                total_num_esc_shell = total_num_esc_shell + num_ptcls
                
                if (abs(total_num-distr_array_hi(i,j))
     *               /distr_array_hi(i,j)  .ge. 5.D-5) then
                   
c                   print*,"i,j,total_num-distr_array_hi(i,j),distr_arr",
c     *                  i,j,total_num-distr_array_hi(i,j), 
c     *                  distr_array_hi(i,j)                   
c                   pause 
                endif
             Enddo             ! if (fi .NE. 0.) 
                
c             Write(66,*) Energy, esc_dens_up_hi(j), 
c     *            diffuse_array(i,j)/shell_vol
             
          End Do                ! do j = 1, p_number
       End Do                   ! Do i = 1, no_shells - 1 
       

       Do i = 1, no_shells + 1
          Do j = 1, p_number         !  Reset ptcl distributions as they
                                !  have now diffused and need to be included 

c---( debug
c          print*, "---distr_array_hi (i,j) before diffuse ---", i,j,
c     *            distr_array_hi(i,j)
c---  ) debug

             distr_array_hi(i,j) = diffuse_array(i,j) ! in the distr array.

c---( debug
c          print*, "---distr_array_hi (i,j) after diffuse ---", i,j,
c     *            distr_array_hi(i,j)
c---  ) debug

          End Do
       End Do  
c---
       write(13,*)"--- time is ---", time, r_shell_x(no_shells+1)
       write(14,*)"--- time is ---", time, r_shell_x(no_shells+1)




       temp_dV = 0.

       Do j = 1, p_number
          temp_num(j) = 0.          
          temp_num_hi(j) = 0.          
          temp_dV = 0.
       Enddo


       DO i =1, no_shells 
c          write(13,*)"--- shell no. ---", i
c          write(14,*)"--- shell no. ---", i
          DO j =1, p_number
             p = p0 + del_p * (j-1)
             Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *            (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *            1.67E-27*3.0E8**2.0 ! the kinetic energy.
             Energy = Energy/1.6E-19 !  (Energy in eV)
             
             factor_num = 4.*pi/3.* (Exp(p)**3 - Exp(p-del_p)**3) 
             dV = 4.*pi/3. *(  R_shell_x(i+1)**3 
     *         - R_shell_x(i)**3 ) ! no need to convert R_shell_x.

             temp_num(j) = temp_num(j) + distr_array(i,j)
             temp_num_hi(j) = temp_num_hi(j) + distr_array_hi(i,j)
             temp_dV = temp_dV + dV

             write(13,*) Energy,distr_array(i,j)/dV,  !distr_array(i,j)/dV * factor_num,
     *            distr_array_hi(i,j)/dV, distr_array(i,j),
     *            distr_array_hi(i,j)

             write(14,*) Energy,esc_dens_shell(j,i),
     *            esc_dens_shell_hi(j,i)

c             write(14,*) Energy,distr_array(i,j)/dV,
c     *            distr_array_hi(i,j)/dV

                                !write distr_array(no_shells, j) to file (14).
          ENDDO
       ENDDO

       Do j = 1, p_number
          p = p0 + del_p * (j-1)
          Energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + 
     *         (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0 ! the kinetic energy.
          Energy = Energy/1.6E-19 !  (Energy
          write(13,*) Energy,temp_num(j)/temp_dV,
     *         temp_num_hi(j)/temp_dV, temp_num(j), temp_num_hi(j)
       Enddo


       
c------ what does the following do?

c       if ( (index1 .gt. index2) .and. (index2 .gt. index3) ) then

c          test_alpha = log(esc_number_up(index3)/esc_number_up(index2))
c     *         / log(p_cut_expand / p_cut) 

c          test_fac=(p_cut**(1-test_alpha)-p_cut_expand**(1-test_alpha))
c     *         /( p_cut **(1-test_alpha) - p_cut_old**(1-test_alpha) )

c          do j = index3, index2
c             esc_number_up(j) =  test_fac * esc_number_up(j)
c          enddo

c          do j = index2+1, index1
c             test_p = exp( ( (j-1)*del_p + p0) )
c             esc_number_up(j) =  test_fac * esc_number_up(index2)
c     *            * (test_p/p_cut_expand) **(-test_alpha)
c          enddo

c       endif

c       p_cut_old = p_cut
c       p_hi_cut_old = p_hi_cut

c       do j = 1, p_number
c          print*, "j,esc_number_up(j)",j,esc_number_up(j)
c       enddo

c---
c--- Now calculate the current at the shock front and
c--- write out to file (78). Also write out to file (96)
c--- the distr_array(no_shells, p_int) and distr_array_hi(no_shells, p_int)
c--- Note, distr_array (no_shells,p_int) has unit of number/ (p^3).
c---
 
       do j = 1, p_number 
          p_int = j
          p = p0 + (j - 1) *del_p

          fi = distr_array(no_shells, p_int)
          
          fi_hi = distr_array_hi(no_shells, p_int)

          dV = 4.*pi/3. *(  R_shell_x(no_shells+1)**3 
     *         - R_shell_x(no_shells)**3 ) ! no need to convert R_shell_x.
          
          den_sh = fi / dV * 4./3.*pi*(Exp(p)**3-Exp(p-del_p)**3) 
          den_sh_hi = fi_hi/dV * 4./3.*pi*(Exp(p)**3-Exp(p-del_p)**3) 
          
c---- Now calculate the current f * v_sh / dE where dE is the energy gap. 

          energy_low = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + ! particle kinetic energy/nucleon.
     *         (1.67E-27*Exp(p-del_p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0
          energy_low = energy_low/1.6D-19 ! Convert to eV.
          
          energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + ! particle kinetic energy/nucleon.
     *         (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0
          energy = energy / 1.6D-19
          energy_hi = energy

          Vpar = (Exp(p)* 52483.25)* 938. / (energy/1E6 +938 )  ! particle speed

          Vsh = shock_speed * vo  ! shock velocity in m/s.
          
c          print*, " ---- Vpar, Vsh -----", Exp(p)*52483.25, Vpar, Vsh

c          den_sh_j = den_sh * Vsh/(energy_hi - energy_low) 
          den_sh_j = den_sh * Vpar/(energy_hi - energy_low) 
          den_sh_j = den_sh_j *1.D6 * 1.D2  ! to 1/cm^3 (cm/s) * (1/MeV)

c          den_sh_hi_j = den_sh_hi*Vsh / (energy_hi - energy_low)
          den_sh_hi_j = den_sh_hi*Vpar / (energy_hi - energy_low)
          den_sh_hi_j = den_sh_hi_j *1.D6 * 1.D2  ! to 1/cm^3 (cm/s) * (1/MeV)
          
                                ! den_sh_j is the current
                                ! den_sh_hi_j is the current for hvy ion.

          write(78,*) Energy, den_sh_j, den_sh_hi_j,
     *         x1a(shock_begin), time

          write(79,*) Energy, distr_array(no_shells, p_int), 
     *         distr_array_hi(no_shells, p_int), time
       enddo

c       pause


c====== added by Gang Li, Feb. 2, 2007 

       do j = 1, p_number
          esc_number_up(j) = esc_number_up(j) + temp_esc(j) 
          esc_number_up_hi(j) = esc_number_up_hi(j) + temp_esc_hi(j) 
       enddo

c====== end added by Gang Li, Jan. 

c---  Now write out esc_number_up(p_int), x1a(shock_begin)+ esc_length,
c---  and time to file (88).

       do j = 1, p_number 
          p_int = j
          p = p0 + (j - 1) *del_p
          energy = Sqrt((1.67E-27*3.0E8**2.0)**2.0 + ! particle kinetic energy/nucleon.
     *         (1.67E-27*Exp(p)*52483.25*3.0E8)**2.0) -
     *         1.67E-27*3.0E8**2.0
          energy = energy / 1.6D-19

c ----- Need to get the real number,rather than number/d^3p.
          temp_esc_up = esc_number_up(p_int) *  ! real particle number that leaked out.
     *         4 * pi /3. * (Exp(p)**3 - Exp(p-del_p)**3)

          temp_esc_up_hi = esc_number_up_hi(p_int) *  ! same as temp_esc_up, for heavyIon.
     *         4. * pi /3. * (Exp(p)**3 - Exp(p-del_p)**3)

          temp_counter1  = esc_ptcl_counter(p_int) * ! accumulated particle number that leaked out.
     *         4. * pi /3. * (Exp(p)**3 - Exp(p-del_p)**3)

          temp_counter2  = esc_ptcl_counter_hi(p_int) * !same as temp_counter1, for HeavyIon.
     *         4. * pi /3. * (Exp(p)**3 - Exp(p-del_p)**3)

c ----- Should times (1.5*13)**3 for the real number. No need for that.
 
          If (Exp(p) .LE. p_cut ) Then

             write(88,*) Energy, 
     *            temp_esc_up, temp_counter1,
     *            escape_location(p_int),time

          ELSE
             write(88,*) Energy, 
     *            temp_esc_up, temp_counter1,
     *            escape_location(p_int),time
          ENDIF

          write(38,*) Energy, esc_dens_up(p_int), 
     *         escape_location(p_int), time


          
          If (Exp(p) .GE. p_hi_cut ) Then
             write(29,*) Energy, esc_number_up_hi(p_int), 
     *            esc_ptcl_counter_hi(p_int),
     *            escape_location_hi(p_int),time

             write(89,*) Energy, 
     *            temp_esc_up_hi, temp_counter2,
     *            escape_location(p_int),time

          ELSE

             write(29,*) Energy, esc_number_up_hi(p_int), 
     *            esc_ptcl_counter_hi(p_int),
     *            escape_location_hi(p_int),time

             write(89,*) Energy, 
     *            temp_esc_up_hi, temp_counter2,
     *            escape_location(p_int),time
          ENDIF
          
          write(58,*) Energy, esc_dens_up_hi(p_int), 
     *         escape_location_hi(p_int), time
       enddo

c----(  move data-writing to file (68) from expand_distr.f to here. 
c---- Now let us calculate the total number of each shell after the expansion.

       totnum = 0.0
c     
       Do i = 1, no_shells

          Do j = 1, 250
             p = 2.0 + (j-1) * del_p
             totnum = totnum + 4.* pi/3. * distr_array(i,j)*
     *            ( Exp(p+del_p)**3 - Exp(p)**3 )
          End Do
          total_num_p(i) = totnum 
          
          totnum = 0.0
          Do j = 1, 250
             p = 2.0 + (j-1) * del_p
             totnum = totnum + 4.* pi/3. * distr_array_hi(i,j)*
     *            ( Exp(p+del_p)**3 - Exp(p)**3 )
          End Do
          total_num_hi(i) = totnum 
       ENDDO
       tempR= R_shell_x(no_shells+1)

       write(68,*) "--- time and R_shock ---", time, tempR
       write(69,*) "--- time and R_shock ---", time, tempR

       do i = 1, no_shells 

          dV = 4.*pi/3. *(  R_shell_x(i+1)**3 
     *         - R_shell_x(i)**3 )

          write(68,*) i, R_shell_i(i), R_shell_x(i),total_num_p(i)/dV,
     *         total_num_hi(i)/dV
          write(69,*) i, R_shell_i(i), R_shell_x(i),total_num_p(i),
     *         total_num_hi(i)

       enddo

c---- ) 

c       pause
c---  ( debugging.

       print*, "---- after diffusion ---"
ccc       do i = 1, no_shells  
ccc          print*, " -- total_num_p(i) --", total_num_p(i)
ccc          print*, " -- total_num_hi(i) --", total_num_hi(i)
ccc       enddo

ccc       print*, "---- for debuging purpose -----"
ccc       print*, "---- print out from 100 to 110, the following ---"
ccc       print*, "---- pint, energy,esc_number_up[hi](p_int),x,time" 
ccc       do p_int = 100, 110
ccc          write(*,*)p_int,esc_number_up(p_int),esc_number_up_hi(p_int), 
ccc     *         escape_location(p_int), time
ccc       enddo

c---  ) debugging.
c       pause

       print*, "******* Leaving diffuse_distr.f *******"       
       print*, "                                       "
c       pause
       return
       End


      Function get_number(fo, ri, r1, r2,temp)
      real*8 get_number
      real*8 num_ptcls, fo, ri, r1, r2, temp, pi    
      real*8 rsml,rbig, alpha_temp, xx1,xx2,xx3,test2
      
      pi = 3.14159265
      alpha_temp = temp**0.5
      
      if (r1 .lt. r2) then
         rsml = r1
         rbig = r2
      else
         rsml = r2
         rbig = r1
      endif


      if ( (rsml .lt. ri) .and. (ri .lt. rbig) ) then
         xx1 = abs( (rsml - ri) / alpha_temp )
         xx2 = abs( (rbig - ri) / alpha_temp )
         test2 = alpha_temp/ri / sqrt(4 *pi) * fo
         test2 = test2 * ( Dexp(-xx1**2) - Dexp(-xx2**2)  +
     *        sqrt(pi) * ri/alpha_temp *(erf(xx2) + erf(xx1) ))
         num_ptcls = test2
      else
         
         xx1 =  abs(rsml - ri) / alpha_temp 
         xx2 =  abs(rbig - ri) / alpha_temp 
         
         if ((Derf(xx2) .eq. 1.) .and. (Derf(xx1) .eq. 1.)) then
            test2 = alpha_temp/ri / sqrt(4 *pi) * fo
            test2 = test2 * (Dexp(-xx1**2) - Dexp(-xx2**2) +
     *           sqrt(pi) * ri/alpha_temp *abs(Derfc(xx1)-Derfc(xx2)))
            num_ptcls = test2
            
         else
            test2 = alpha_temp/ri / sqrt(4 *pi) * fo
            test2 = test2 * (Dexp(-xx1**2) - Dexp(-xx2**2) +
     *           sqrt(pi) * ri/alpha_temp *abs(Derf(xx2) - Derf(xx1)))
            num_ptcls = test2
         endif

      endif

c     endif

c      if (num_ptcls .eq. 0.) then
c         print*, " --- xx1,xx2, alpha_temp ---",xx1,xx2, alpha_temp 
c         print*, " --- Derfc(xx1),Derfc(xx2) ---",Derfc(xx1),Derfc(xx2)
c      endif

c     pause

      get_number = num_ptcls
      return
      
      End


      

       subroutine slic2d4
     1   ( q3d, i1, j1, k1, i2, j2, k2, nlog, q2d )
c
c    dac:zeus3d.slic2d4 <------ extracts a 2-d slice from a 3-d datacube
c                                                            march, 1990
c
c    written by: David Clarke
c    modified 1: Robert Fiedler to make q2d real*4 when REAL is real*8.
c
c  PURPOSE:  This subroutine extracts a 2-D slice specified by the input
c  coordinates from a 3-D datacube and copies it to a 2-D array.  The
c  slice is restricted by virtue of the fact that its normal must be
c  parallel to one of the coordinate directions.  Accordingly, i1=i2, or
c  j1=j2, or k1=k2.
c
c  INPUT VARIABLES:
c    q3d        the 3-D array from which the 2-D slice is to be
c               extracted.
c    i1,j1,k1   coordinates of the "bottom left" corner of the slice.
c    i2,j2,k2   coordinates of the "top right" corner of the slice.
c    nlog       =0 => return data slice
c               =1 => return log10 of data slice
c
c  OUTPUT VARIABLES:
c    q2d        the 2-D slice.
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
c
c-----------------------------------------------------------------------
c----------------------------- PARAMETERS ------------------------------
c-----------------------------------------------------------------------
c
c      Primary parameters:
c
       integer       in      , jn      , kn      , ijkn    , nxpx
     1             , nypx    , nxrd    , nyrd    , niov    , nios
     2             , ntsl    , mn      , nmd     , isig
       real*8        pi  , tiny  , huge  , one  , mone  , haf  , zro
c
       parameter     ( in = 5005, jn = 1, kn = 10, ijkn = 5005)
       parameter     ( nxpx = 1, nypx = 1, nxrd =   1, nyrd =   1 )
       parameter     ( niov =  20, nios =  20, ntsl =1000 )
       parameter     ( mn   =   1, nmd  =   1 )
       parameter     ( pi   = 3.1415926535898 )
       parameter     ( isig = 9, tiny = 1.0d-99, huge = 1.0d+99 )
       parameter     ( one  = 1.0d+00, mone = -1.0d+00
     1                               , haf  =  0.5d+00, zro = 0.0d+00)
c
c      Secondary parameters:
c
       integer        idim    , jdim
     1              , nt01    , nt02    , nt03    , nt04    , nt05
     2              , nt06    , nt07    , nt08    , nt09    , nt10
     3              , nt11    , nt12    , nt13    , nt14    , nt15
     4              , nt16    , nt17    , nt18    , nt19    , nt20
       parameter     ( idim =   kn, jdim =   in )
       parameter     ( nt01 = 600, nt02 = 600, nt03 =   7, nt04 =   5 )
       parameter     ( nt05 =  18, nt06 =   1, nt07 =  10, nt08 =  12 )
       parameter     ( nt09 =   5, nt10 =  54, nt11 =   8 )
       parameter     ( nt12 =        16, nt17 =         4 )
       parameter     ( nt13 = nt12 +  4, nt18 = nt17 +  1 )
       parameter     ( nt14 = nt13     , nt19 = nt18      )
       parameter     ( nt15 = nt14 + 30, nt20 = nt19 +  3 )
       parameter     ( nt16 = nt14 + 42 )
       integer       i       , j       , k       , i1      , i2
     1             , j1      , j2      , k1      , k2      , imax
     2             , jmax    , nlog
c
       real*8        large
       real*4        small
       parameter ( small = 1.0e-22 , large = 1.0e+32 )
c
       real*4        q2d     (idim,jdim)
c
       real*8        q3d     (  in,  jn,  kn)
c
c-----------------------------------------------------------------------
c
c      Slice is in the x2-x3 plane.
c
       if (i1 .eq. i2) then
         if (nlog .eq. 1) then
           do 20 k=k1,k2
             do 10 j=j1,j2
               q2d(j,k) =  log10 (   max ( tiny, q3d(i1,j,k) ) )
10           continue
20         continue
         else
           do 40 k=k1,k2
             do 30 j=j1,j2
               q2d(j,k) = sign( one, q3d(i1,j,k) )
     1                  * min( large, abs( q3d(i1,j,k) ) )
               if( abs(q2d(j,k)) .lt. small ) q2d(j,k) = 0.0
30           continue
40         continue
         endif
         return
       endif
c
c      Slice is in the x3-x1 plane.
c
       if (j1 .eq. j2) then
         if (nlog .eq. 1) then
           do 60 i=i1,i2
             do 50 k=k1,k2
               q2d(k,i) =  log10 (   max ( tiny, q3d(i,j1,k) ) )
50           continue
60         continue
         else
           do 80 i=i1,i2
             do 70 k=k1,k2
               q2d(k,i) = sign( one, q3d(i,j1,k) )
     1                  * min( large, abs( q3d(i,j1,k) ) )
               if( abs(q2d(k,i)) .lt. small ) q2d(k,i) = 0.0
70           continue
80         continue
         endif
         return
       endif
c
c      Slice is in the x1-x2 plane.
c
       if (k1 .eq. k2) then
         if (nlog .eq. 1) then
           do 100 j=j1,j2
             do 90 i=i1,i2
               q2d(i,j) =  log10 (   max ( tiny, q3d(i,j,k1) ) )
90           continue
100        continue
         else
           do 120 j=j1,j2
             do 110 i=i1,i2
               q2d(i,j) = sign( one, q3d(i,j,k1) )
     1                  * min( large, abs( q3d(i,j,k1) ) )
               if( abs(q2d(i,j)) .lt. small ) q2d(i,j) = 0.0
110          continue
120        continue
         endif
         return
       endif
c
c      If no plane is specified (i1.ne.i2 .and. j1.ne.j2 .and. k1.ne.k2)
c  then no slice can be extracted.  Return a zeroed "q2d" to calling
c  routine.
c
       imax = kn
       jmax = in
       do 140 j=1,jmax
         do 130 i=1,imax
           q2d(i,j) = 0.0
130      continue
140    continue
c
       return
       end

       subroutine trnsps4
     1   ( ar, idim, jdim, art )
c
c    dac:zeus3d.trnsps4 <------------------------ transposes a 2-D array
c                                                          october, 1992
c
c    written by: David Clarke
c    modified 1: Robert Fiedler to make the input and output arrays
c                real*4.  Called only if alias REAL is set to real*4.
c
c  PURPOSE:  This subroutine returns the transpose of a 2-D array.
c
c  INPUT VARIABLES:
c    ar          input array to be transposed
c    idim,jdim   dimensions of "ar" and "art"
c
c  OUTPUT VARIABLES:
c    art         transposed array
c
c  LOCAL VARIABLES:
c
c  EXTERNALS: [NONE]
c
c-----------------------------------------------------------------------
c
c
c-----------------------------------------------------------------------
c------------------------ IMPLICIT STATEMENTS --------------------------
c-----------------------------------------------------------------------
c
       implicit      none
       integer       idim    , jdim    , i       , j
c
       real*4        ar      (idim,jdim), art     (jdim,idim)
c
c-----------------------------------------------------------------------
c
       do 20 i=1,idim
         do 10 j=1,jdim
           art(j,i) = ar(i,j)
10       continue
20     continue
c
       return
       end
